package provide DS9 1.0

proc AnalysisPlot {unique tt wtt title xaxis yaxis dim data} {
    global ap

    if {!$unique && [APPing $tt]} {
	set xx ap${tt}xx
	set yy ap${tt}yy
	set ee ap${tt}ee
	set yy2 ap${tt}yy2
	set ee2 ap${tt}ee2

	APUpdateVector $tt $dim $data $xx $yy $ee $yy2 $ee2
	APUpdateData $tt
	APUpdate $tt
	APRaise $tt
    } else {
	if {$unique} {
	    append tt $ap(unique,id)
	    incr ap(unique,id)
	}
	set xx ap${tt}xx
	set yy ap${tt}yy
	set ee ap${tt}ee
	set yy2 ap${tt}yy2
	set ee2 ap${tt}ee2

	blt::vector create $xx $yy $ee $yy2 $ee2
	APUpdateVector $tt $dim $data $xx $yy $ee $yy2 $ee2
	AnalysisPlotV $tt $wtt $title $xaxis $yaxis $xx $yy $ee $yy2 $ee2
    }
}

proc AnalysisPlotV {tt wtt title xaxis yaxis xdata ydata edata y2data e2data} {
    global ap
    global ds9
    global menu
    global prefs

    if {[APPing $tt]} {
	APRaise $tt
	return
    }

    set ap($tt,top) ".${tt}"
    set ap($tt,mb) ".${tt}mb"

    set ap($tt,xdata) $xdata
    set ap($tt,ydata) $ydata
    set ap($tt,edata) $edata
    set ap($tt,y2data) $y2data
    set ap($tt,e2data) $e2data

    global $ap($tt,xdata) $ap($tt,ydata) $ap($tt,edata) \
	$ap($tt,y2data) $ap($tt,e2data)

    set ap($tt,graph,title) "$title"
    set ap($tt,graph,xaxis) "$xaxis"
    set ap($tt,graph,yaxis) "$yaxis"
    set ap($tt,graph,x,auto) 1
    set ap($tt,graph,x,min) {}
    set ap($tt,graph,x,max) {}
    set ap($tt,graph,y,auto) 1
    set ap($tt,graph,y,min) {}
    set ap($tt,graph,y,max) {}

    set ap($tt,grid) $prefs(ap,grid)
    set ap($tt,grid,log) $prefs(ap,grid,log) 

    set ap($tt,discrete) $prefs(ap,discrete) 
    set ap($tt,discrete,symbol) $prefs(ap,discrete,symbol) 
    set ap($tt,discrete,color) $prefs(ap,discrete,color) 

    set ap($tt,linear) $prefs(ap,linear) 
    set ap($tt,linear,width) $prefs(ap,linear,width) 
    set ap($tt,linear,color) $prefs(ap,linear,color) 
    set ap($tt,linear,dash) $prefs(ap,linear,dash) 

    set ap($tt,step) $prefs(ap,step) 
    set ap($tt,step,width) $prefs(ap,step,width) 
    set ap($tt,step,color) $prefs(ap,step,color) 
    set ap($tt,step,dash) $prefs(ap,step,dash) 

    set ap($tt,quadratic) $prefs(ap,quadratic) 
    set ap($tt,quadratic,width) $prefs(ap,quadratic,width) 
    set ap($tt,quadratic,color) $prefs(ap,quadratic,color) 
    set ap($tt,quadratic,dash) $prefs(ap,quadratic,dash) 

    set ap($tt,error,width) $prefs(ap,error,width) 
    set ap($tt,error,color) $prefs(ap,error,color) 
    set ap($tt,error,style) $prefs(ap,error,style) 

    set ap($tt,titleFont) $prefs(ap,titleFont) 
    set ap($tt,titleSize) $prefs(ap,titleSize) 
    set ap($tt,titleStyle) $prefs(ap,titleStyle) 

    set ap($tt,textlabFont) $prefs(ap,textlabFont) 
    set ap($tt,textlabSize) $prefs(ap,textlabSize) 
    set ap($tt,textlabStyle) $prefs(ap,textlabStyle) 

    set ap($tt,numlabFont) $prefs(ap,numlabFont) 
    set ap($tt,numlabSize) $prefs(ap,numlabSize) 
    set ap($tt,numlabStyle) $prefs(ap,numlabStyle)

    toplevel $ap($tt,top) -colormap $ds9(main)
    wm title $ap($tt,top) $wtt
    wm iconname $ap($tt,top) $wtt
    wm group $ap($tt,top) $ds9(top)
    wm protocol $ap($tt,top) WM_DELETE_WINDOW "APDestroy $tt"

    $ap($tt,top) configure -menu $ap($tt,mb)

    menu $ap($tt,mb) -tearoff 0 -selectcolor $menu(selectcolor)
    $ap($tt,mb) add cascade -label File -menu $ap($tt,mb).file
    $ap($tt,mb) add cascade -label Edit -menu $ap($tt,mb).edit
    $ap($tt,mb) add cascade -label View -menu $ap($tt,mb).view
    $ap($tt,mb) add cascade -label Grid -menu $ap($tt,mb).grid
    $ap($tt,mb) add cascade -label Color -menu $ap($tt,mb).color
    $ap($tt,mb) add cascade -label Line -menu $ap($tt,mb).line
    $ap($tt,mb) add cascade -label Font -menu $ap($tt,mb).font

    menu $ap($tt,mb).file -tearoff 0 -selectcolor $menu(selectcolor)
    $ap($tt,mb).file add command -label "Load Data..." \
	-command "APLoadData $tt"
    $ap($tt,mb).file add command -label "Save Data..." \
	-command "APSaveData $tt"
    $ap($tt,mb).file add separator
    $ap($tt,mb).file add command -label "Load Configuration..." \
	-command "APLoadConfig $tt"
    $ap($tt,mb).file add command -label "Save Configuration..." \
	-command "APSaveConfig $tt"
    $ap($tt,mb).file add separator
    $ap($tt,mb).file add command -label "Print..." -command "APPrint $tt"
    $ap($tt,mb).file add command -label "Page Setup..." -command PageDialog
    $ap($tt,mb).file add separator
    $ap($tt,mb).file add command -label "Close" \
	-command "APDestroy $tt"

    global tcl_platform
    if {$tcl_platform(platform) == "windows"} {
	$ap($tt,mb).file entryconfig "Print..." -state disabled
	$ap($tt,mb).file entryconfig "Page Setup..." -state disabled
    }

    menu $ap($tt,mb).edit -tearoff 0 -selectcolor $menu(selectcolor)
    $ap($tt,mb).edit add command -label "Cut" -state disabled
    $ap($tt,mb).edit add command -label "Copy" -state disabled
    $ap($tt,mb).edit add command -label "Paste" -state disabled
    $ap($tt,mb).edit add command -label "Clear" -state disabled

    menu $ap($tt,mb).view -tearoff 0 -selectcolor $menu(selectcolor)
    $ap($tt,mb).view add checkbutton -label Discrete \
	-variable ap($tt,discrete) -command "APUpdate $tt"
    $ap($tt,mb).view add checkbutton -label Line \
	-variable ap($tt,linear) -command "APUpdate $tt"
    $ap($tt,mb).view add checkbutton -label Step \
	-variable ap($tt,step) -command "APUpdate $tt"
    $ap($tt,mb).view add checkbutton -label Quadratic \
	-variable ap($tt,quadratic) -command "APUpdate $tt"
    $ap($tt,mb).view add checkbutton -label Errorbar \
	-variable ap($tt,error) -command "APUpdate $tt"
    $ap($tt,mb).view add separator
    $ap($tt,mb).view add command -label "Axis Range..." \
	-command "APRange $tt"
    $ap($tt,mb).view add command -label "Labels..." -command "APTitle $tt"

    menu $ap($tt,mb).grid -tearoff 0 -selectcolor $menu(selectcolor)
    $ap($tt,mb).grid add checkbutton -label "Grid" \
	-variable ap($tt,grid) -command "APUpdate $tt"
    $ap($tt,mb).grid add separator
    $ap($tt,mb).grid add radiobutton -label "Linear-Linear" \
	-variable ap($tt,grid,log) -value linearlinear \
	-command "APUpdate $tt"
    $ap($tt,mb).grid add radiobutton -label "Linear-Log" \
	-variable ap($tt,grid,log) -value linearlog \
	-command "APUpdate $tt"
    $ap($tt,mb).grid add radiobutton -label "Log-Linear" \
	-variable ap($tt,grid,log) -value loglinear \
	-command "APUpdate $tt"
    $ap($tt,mb).grid add radiobutton -label "Log-Log" \
	-variable ap($tt,grid,log) -value loglog \
	-command "APUpdate $tt"

    menu $ap($tt,mb).color -tearoff 0 -selectcolor $menu(selectcolor)
    $ap($tt,mb).color add cascade -label Discrete \
	-menu $ap($tt,mb).color.discrete
    $ap($tt,mb).color add cascade -label Line \
	-menu $ap($tt,mb).color.linear
    $ap($tt,mb).color add cascade -label Step \
	-menu $ap($tt,mb).color.step
    $ap($tt,mb).color add cascade -label Quadratic \
	-menu $ap($tt,mb).color.quadratic
    $ap($tt,mb).color add cascade -label Errorbar \
	-menu $ap($tt,mb).color.error

    APCreateColorMenu $ap($tt,mb).color.discrete \
	ap($tt,discrete,color) "APUpdate $tt"
    APCreateColorMenu $ap($tt,mb).color.linear \
	ap($tt,linear,color) "APUpdate $tt"
    APCreateColorMenu $ap($tt,mb).color.step \
	ap($tt,step,color) "APUpdate $tt"
    APCreateColorMenu $ap($tt,mb).color.quadratic \
	ap($tt,quadratic,color) "APUpdate $tt"
    APCreateColorMenu $ap($tt,mb).color.error \
	ap($tt,error,color) "APUpdate $tt"

    menu $ap($tt,mb).line -tearoff 0 -selectcolor $menu(selectcolor)
    $ap($tt,mb).line add cascade -label Discrete \
	-menu $ap($tt,mb).line.discrete
    $ap($tt,mb).line add cascade -label Line -menu $ap($tt,mb).line.linear
    $ap($tt,mb).line add cascade -label Step -menu $ap($tt,mb).line.step
    $ap($tt,mb).line add cascade -label Quadratic \
	-menu $ap($tt,mb).line.quadratic
    $ap($tt,mb).line add cascade -label Errorbar \
	-menu $ap($tt,mb).line.error

    menu $ap($tt,mb).line.discrete -tearoff 0 \
	-selectcolor $menu(selectcolor)
    $ap($tt,mb).line.discrete add radiobutton -label "Circle" \
	-variable ap($tt,discrete,symbol) -value circle \
	-command "APUpdate $tt"
    $ap($tt,mb).line.discrete add radiobutton -label "Diamond" \
	-variable ap($tt,discrete,symbol) -value diamond \
	-command "APUpdate $tt"
    $ap($tt,mb).line.discrete add radiobutton -label "Plus" \
	-variable ap($tt,discrete,symbol) -value plus \
	-command "APUpdate $tt"
    $ap($tt,mb).line.discrete add radiobutton -label "Cross" \
	-variable ap($tt,discrete,symbol) -value cross \
	-command "APUpdate $tt"

    APCreateLineMenu $ap($tt,mb).line.linear \
	ap($tt,linear,width) ap($tt,linear,dash) "APUpdate $tt"
    APCreateLineMenu $ap($tt,mb).line.step \
	ap($tt,step,width) ap($tt,step,dash) "APUpdate $tt"
    APCreateLineMenu $ap($tt,mb).line.quadratic \
	ap($tt,quadratic,width) ap($tt,quadratic,dash) "APUpdate $tt"

    menu $ap($tt,mb).line.error -tearoff 0 -selectcolor $menu(selectcolor)
    $ap($tt,mb).line.error add radiobutton -label 1 \
	-variable ap($tt,error,width) -value 1 -command "APUpdate $tt"
    $ap($tt,mb).line.error add radiobutton -label 2 \
	-variable ap($tt,error,width) -value 2 -command "APUpdate $tt"
    $ap($tt,mb).line.error add radiobutton -label 3 \
	-variable ap($tt,error,width) -value 3 -command "APUpdate $tt"
    $ap($tt,mb).line.error add radiobutton -label 4 \
	-variable ap($tt,error,width) -value 4 -command "APUpdate $tt"
    $ap($tt,mb).line.error add separator
    $ap($tt,mb).line.error add radiobutton -label "Style 1" \
	-variable ap($tt,error,style) -value 0 -command "APUpdate $tt"
    $ap($tt,mb).line.error add radiobutton -label "Style 2" \
	-variable ap($tt,error,style) -value 1 -command "APUpdate $tt"

    menu $ap($tt,mb).font -tearoff 0 -selectcolor $menu(selectcolor)
    $ap($tt,mb).font add cascade -label "Axis Numbers" \
	-menu $ap($tt,mb).font.numlab
    $ap($tt,mb).font add cascade -label "Axis Label" \
	-menu $ap($tt,mb).font.textlab
    $ap($tt,mb).font add cascade -label "Title" \
	-menu $ap($tt,mb).font.title

    APCreateFontMenu $ap($tt,mb).font.numlab \
	ap($tt,numlabFont) ap($tt,numlabSize) ap($tt,numlabStyle) \
	"APUpdate $tt"
    APCreateFontMenu $ap($tt,mb).font.textlab \
	ap($tt,textlabFont) ap($tt,textlabSize) ap($tt,textlabStyle) \
	"APUpdate $tt"
    APCreateFontMenu $ap($tt,mb).font.title \
	ap($tt,titleFont) ap($tt,titleSize) ap($tt,titleStyle) \
	"APUpdate $tt"

    set ap($tt,graph) [blt::graph $ap($tt,top).g -plotrelief groove \
			   -plotbackground [.ds9 cget -background]]
    $ap($tt,graph) legend configure -hide yes

    Blt_ZoomStack $ap($tt,graph)

    # we need to manually set the element foreground color,
    # i.e. use graph fg
    # create the second set of data first, so that its the last rendered

    $ap($tt,graph) element create d12 -linewidth 0 -fill {} -pixels 5 \
	-xdata $ap($tt,xdata) -ydata $ap($tt,y2data) \
	-trace increasing 
    $ap($tt,graph) element create d22 -smooth linear -symbol {} \
	-xdata $ap($tt,xdata) -ydata $ap($tt,y2data) \
	-trace increasing 
    $ap($tt,graph) element create d32 -smooth step -symbol {} \
	-xdata $ap($tt,xdata) -ydata $ap($tt,y2data) \
	-trace increasing 
    $ap($tt,graph) element create d42 -smooth quadratic -symbol {} \
	-xdata $ap($tt,xdata) -ydata $ap($tt,y2data) \
	-trace increasing 

    $ap($tt,graph) element create err02 -smooth linear -symbol {} \
	-trace decreasing 
    $ap($tt,graph) element create err12 -smooth linear -symbol {} \
	-trace decreasing 
    $ap($tt,graph) element create err22 -smooth linear -symbol {} \
	-trace decreasing 

    $ap($tt,graph) element create d11 -linewidth 0 -fill {} -pixels 5 \
	-xdata $ap($tt,xdata) -ydata $ap($tt,ydata) \
	-trace increasing 
    $ap($tt,graph) element create d21 -smooth linear -symbol {} \
	-xdata $ap($tt,xdata) -ydata $ap($tt,ydata) \
	-trace increasing 
    $ap($tt,graph) element create d31 -smooth step -symbol {} \
	-xdata $ap($tt,xdata) -ydata $ap($tt,ydata) \
	-trace increasing 
    $ap($tt,graph) element create d41 -smooth quadratic -symbol {} \
	-xdata $ap($tt,xdata) -ydata $ap($tt,ydata) \
	-trace increasing 

    $ap($tt,graph) element create err01 -smooth linear -symbol {} \
	-trace decreasing 
    $ap($tt,graph) element create err11 -smooth linear -symbol {} \
	-trace decreasing 
    $ap($tt,graph) element create err21 -smooth linear -symbol {} \
	-trace decreasing 

    pack $ap($tt,graph) -expand yes -fill both

    if {[$ap($tt,xdata) length] > 0} {
	$ap($tt,mb).file entryconfig "Load Data..." -state disabled
    }

    APUpdateData $tt
    APUpdate $tt
}

proc APPing {tt} {
    global ap

    if {[info exist ap($tt,top)]} {
	if {[winfo exist $ap($tt,top)]} {
	    return 1
	}
    }
    return 0
}

proc APRaise {tt} {
    global ap

    if {[APPing $tt]} {
	raise $ap($tt,top)
    }
}

proc APDestroy {tt} {
    global ap

    # see if it still is around
    if {![APPing $tt]} {
	return
    }

    global $ap($tt,xdata) $ap($tt,ydata) $ap($tt,edata) \
	$ap($tt,y2data) $ap($tt,e2data)
    blt::vector destroy $ap($tt,xdata) $ap($tt,ydata) $ap($tt,edata) \
	$ap($tt,y2data) $ap($tt,e2data)

    destroy $ap($tt,top)
    destroy $ap($tt,mb)

    unset ap($tt,top)
    unset ap($tt,mb)

    unset ap($tt,xdata)
    unset ap($tt,ydata)
    unset ap($tt,edata)
    unset ap($tt,y2data)
    unset ap($tt,e2data)

    unset ap($tt,graph)

    unset ap($tt,graph,title)
    unset ap($tt,graph,xaxis)
    unset ap($tt,graph,yaxis)
    unset ap($tt,graph,x,auto)
    unset ap($tt,graph,x,min)
    unset ap($tt,graph,x,max)
    unset ap($tt,graph,y,auto)
    unset ap($tt,graph,y,min)
    unset ap($tt,graph,y,max)

    unset ap($tt,grid)
    unset ap($tt,grid,log)

    unset ap($tt,discrete)
    unset ap($tt,discrete,symbol)
    unset ap($tt,discrete,color)

    unset ap($tt,linear)
    unset ap($tt,linear,width)
    unset ap($tt,linear,color)
    unset ap($tt,linear,dash)

    unset ap($tt,step)
    unset ap($tt,step,width)
    unset ap($tt,step,color)
    unset ap($tt,step,dash)

    unset ap($tt,quadratic)
    unset ap($tt,quadratic,width)
    unset ap($tt,quadratic,color)
    unset ap($tt,quadratic,dash)

    unset ap($tt,error)
    unset ap($tt,error,width)
    unset ap($tt,error,color)
    unset ap($tt,error,style)

    unset ap($tt,titleFont)
    unset ap($tt,titleSize)
    unset ap($tt,titleStyle)

    unset ap($tt,textlabFont)
    unset ap($tt,textlabSize)
    unset ap($tt,textlabStyle)
    
    unset ap($tt,numlabFont)
    unset ap($tt,numlabSize)
    unset ap($tt,numlabStyle)
}

proc APUpdateData {tt} {
    global ap
    global $ap($tt,xdata) $ap($tt,ydata) $ap($tt,edata) \
	$ap($tt,y2data) $ap($tt,e2data)

    set ap($tt,graph,x,min) [expr "$$ap($tt,xdata)\(min\)"]
    set ap($tt,graph,x,max) [expr "$$ap($tt,xdata)\(max\)"]

    switch $ap($tt,dim) {
	2 -
	3 {
	    set ap($tt,graph,y,min) [expr "$$ap($tt,ydata)\(min\)"]
	    set ap($tt,graph,y,max) [expr "$$ap($tt,ydata)\(max\)"]
	}
	4 -
	5 {
	    set min1 [expr "$$ap($tt,ydata)\(min\)"]
	    set min2 [expr "$$ap($tt,y2data)\(min\)"]
	    set max1 [expr "$$ap($tt,ydata)\(max\)"]
	    set max2 [expr "$$ap($tt,y2data)\(max\)"]
	    if {$min1 < $min2} {
		set ap($tt,graph,y,min) $min1
	    } else {
		set ap($tt,graph,y,min) $min2
	    }
	    if {$max1 > $max2} {
		set ap($tt,graph,y,max) $max1
	    } else {
		set ap($tt,graph,y,max) $max2
	    }
	}
    }

    set err01 {}
    set err11 {}
    set err21 {}

    if {[$ap($tt,edata) length] == 0} {
	set ap($tt,error) 0
	$ap($tt,mb).view entryconfig Errorbar -state disabled

    } else {
	set ap($tt,error) 1
	$ap($tt,mb).view entryconfig Errorbar -state normal

	set min [expr "$$ap($tt,xdata)\(min\)"]
	set max [expr "$$ap($tt,xdata)\(max\)"]
	set errdelt [expr ($max-$min)*.0125]

	set l [$ap($tt,edata) length]
	for {set i 0} {$i<$l} {incr i} {
	    set x [expr "$$ap($tt,xdata)\($i\)"]
	    set y [expr "$$ap($tt,ydata)\($i\)"]
	    set e [expr "$$ap($tt,edata)\($i\)"]

	    append err01  "$x [expr $y-$e] $x [expr $y+$e] "
	    append err11 \
	    "[expr $x+$errdelt] [expr $y+$e] [expr $x-$errdelt] [expr $y+$e] "
	    append err21 \
	    "[expr $x+$errdelt] [expr $y-$e] [expr $x-$errdelt] [expr $y-$e] "
	}

	$ap($tt,graph) element configure err01 -data $err01
	$ap($tt,graph) element configure err11 -data $err11
	$ap($tt,graph) element configure err21 -data $err21
    }

    set err02 {}
    set err12 {}
    set err22 {}

    if {[$ap($tt,e2data) length] != 0} {
	set min [expr "$$ap($tt,xdata)\(min\)"]
	set max [expr "$$ap($tt,xdata)\(max\)"]
	set errdelt [expr ($max-$min)*.0125]

	set l [$ap($tt,e2data) length]
	for {set i 0} {$i<$l} {incr i} {
	    set x [expr "$$ap($tt,xdata)\($i\)"]
	    set y [expr "$$ap($tt,y2data)\($i\)"]
	    set e [expr "$$ap($tt,e2data)\($i\)"]

	    append err02  "$x [expr $y-$e] $x [expr $y+$e] "
	    append err12 \
	    "[expr $x+$errdelt] [expr $y+$e] [expr $x-$errdelt] [expr $y+$e] "
	    append err22 \
	    "[expr $x+$errdelt] [expr $y-$e] [expr $x-$errdelt] [expr $y-$e] "
	}

	$ap($tt,graph) element configure err02 -data $err02
	$ap($tt,graph) element configure err12 -data $err12
	$ap($tt,graph) element configure err22 -data $err22
    }
}

proc APUpdate {tt} {
    global ap

    switch $ap($tt,grid,log) {
	linearlinear {set xlog false; set ylog false}
	linearlog {set xlog false; set ylog true}
	loglinear {set xlog true; set ylog false}
	loglog {set xlog true; set ylog true}
    }

    if {$ap($tt,graph,x,auto)} {
	set xmin {}
	set xmax {}
    } else {
	set xmin $ap($tt,graph,x,min)
	set xmax $ap($tt,graph,x,max)
    }

    if {$ap($tt,graph,y,auto)} {
	set ymin {}
	set ymax {}
    } else {
	set ymin $ap($tt,graph,y,min)
	set ymax $ap($tt,graph,y,max)
    }

    $ap($tt,graph) configure -plotpadx 0 -plotpady 0 \
	-title $ap($tt,graph,title) \
	-font "$ap($tt,titleFont) $ap($tt,titleSize) $ap($tt,titleStyle)"

    $ap($tt,graph) grid configure -hide [expr !$ap($tt,grid)]

    $ap($tt,graph) xaxis configure -logscale $xlog \
	-min $xmin -max $xmax \
	-title $ap($tt,graph,xaxis) -tickfont \
	"$ap($tt,numlabFont) $ap($tt,numlabSize) $ap($tt,numlabStyle)" \
	-titlefont \
	"$ap($tt,textlabFont) $ap($tt,textlabSize) $ap($tt,textlabStyle)"
    $ap($tt,graph) yaxis configure -logscale $ylog \
	-min $ymin -max $ymax \
	-title $ap($tt,graph,yaxis) -tickfont \
	"$ap($tt,numlabFont) $ap($tt,numlabSize) $ap($tt,numlabStyle)" \
	-titlefont \
	"$ap($tt,textlabFont) $ap($tt,textlabSize) $ap($tt,textlabStyle)"

    $ap($tt,graph) element configure d11 \
	-hide [expr !$ap($tt,discrete)] \
	-symbol $ap($tt,discrete,symbol) \
	-outline $ap($tt,discrete,color) \
	-color $ap($tt,discrete,color)
    $ap($tt,graph) element configure d21 \
	-hide [expr !$ap($tt,linear)] \
	-linewidth $ap($tt,linear,width) \
	-color $ap($tt,linear,color) \
	-dashes $ap($tt,linear,dash)
    $ap($tt,graph) element configure d31 \
	-hide [expr !$ap($tt,step)] \
	-linewidth $ap($tt,step,width) \
	-color $ap($tt,step,color) \
	-dashes $ap($tt,step,dash)
    $ap($tt,graph) element configure d41 \
	-hide [expr !$ap($tt,quadratic)] \
	-linewidth $ap($tt,quadratic,width) \
	-color $ap($tt,quadratic,color) \
	-dashes $ap($tt,quadratic,dash)

    $ap($tt,graph) element configure err01 \
	-hide [expr !$ap($tt,error)] \
	-linewidth $ap($tt,error,width) \
	-color $ap($tt,error,color)
    $ap($tt,graph) element configure err11 \
	-hide [expr !($ap($tt,error) && $ap($tt,error,style))] \
	-linewidth $ap($tt,error,width) \
	-color $ap($tt,error,color)
    $ap($tt,graph) element configure err21 \
	-hide [expr !($ap($tt,error) && $ap($tt,error,style))] \
	-linewidth $ap($tt,error,width) \
	-color $ap($tt,error,color)

    $ap($tt,graph) element configure d12 \
	-hide [expr !$ap($tt,discrete)] \
	-symbol $ap($tt,discrete,symbol) \
	-outline $ap($tt,discrete,color) \
	-color [APNextColor $ap($tt,discrete,color)]
    $ap($tt,graph) element configure d22 \
	-hide [expr !$ap($tt,linear)] \
	-linewidth $ap($tt,linear,width) \
	-color [APNextColor $ap($tt,linear,color)] \
	-dashes $ap($tt,linear,dash)
    $ap($tt,graph) element configure d32 \
	-hide [expr !$ap($tt,step)] \
	-linewidth $ap($tt,step,width) \
	-color [APNextColor $ap($tt,step,color)] \
	-dashes $ap($tt,step,dash)
    $ap($tt,graph) element configure d42 \
	-hide [expr !$ap($tt,quadratic)] \
	-linewidth $ap($tt,quadratic,width) \
	-color [APNextColor $ap($tt,quadratic,color)] \
	-dashes $ap($tt,quadratic,dash)

    $ap($tt,graph) element configure err02 \
	-hide [expr !$ap($tt,error)] \
	-linewidth $ap($tt,error,width) \
	-color $ap($tt,error,color)
    $ap($tt,graph) element configure err12 \
	-hide [expr !($ap($tt,error) && $ap($tt,error,style))] \
	-linewidth $ap($tt,error,width) \
	-color $ap($tt,error,color)
    $ap($tt,graph) element configure err22 \
	-hide [expr !($ap($tt,error) && $ap($tt,error,style))] \
	-linewidth $ap($tt,error,width) \
	-color $ap($tt,error,color)
}

proc APDataFormatDialog {} {
    global ed

    set w ".apdata"

    set ed(ok) 0
    set ed(dim) 2

    DialogCreate $w "Data Format" -borderwidth 2
    frame $w.dim  -relief groove -borderwidth 2
    frame $w.buttons -relief groove -borderwidth 2
    pack $w.dim $w.buttons -fill x -ipadx 4 -ipady 4

    label $w.dim.title -text "Data Format:"
    radiobutton $w.dim.xy -text "X Y" -variable ed(dim) -value 2
    radiobutton $w.dim.xye -text "X Y Err" -variable ed(dim) -value 3
    radiobutton $w.dim.xyey -text "X Y Err Y2" -variable ed(dim) -value 4
    radiobutton $w.dim.xyeye -text "X Y Err Y2 Err2" -variable ed(dim) -value 5
    grid $w.dim.title -padx 4 -sticky w
    grid $w.dim.xy -padx 4 -sticky w
    grid $w.dim.xye -padx 4 -sticky w
    grid $w.dim.xyey -padx 4 -sticky w
    grid $w.dim.xyeye -padx 4 -sticky w

    button $w.buttons.ok -text "OK" -default active -command {set ed(ok) 1}
    button $w.buttons.cancel -text "Cancel" -command {set ed(ok) 0}
    pack $w.buttons.ok -side left -padx 10
    pack $w.buttons.cancel -side right -padx 10

    bind $w <Return> {set ed(ok) 1}
    bind $w <Alt-o> "tkButtonInvoke $w.buttons.ok"
    bind $w <Alt-c> "tkButtonInvoke $w.buttons.cancel"

    DialogCenter $w 
    DialogWait $w ed(ok) $w.dim.xy
    DialogDismiss $w
}

proc APLoadData {tt} {
    global ds9
    global ap
    global ed

    set filename [OpenFileDialog apdatafbox]
    if {$filename != {}} {
	APDataFormatDialog

	if {$ed(ok)} {
	    set ch [open $filename]
	    set data [read $ch]
	    close $ch

	    APUpdateVector $tt $ed(dim) $data $ap($tt,xdata) \
		$ap($tt,ydata) $ap($tt,edata) $ap($tt,y2data) $ap($tt,e2data)
	    APUpdateData $tt
	    APUpdate $tt
	    APRaise $tt
	}
	
	unset ed
    }
}

proc APSaveData {tt} {
    global ap
    global ed
    global ds9

    set filename [SaveFileDialog apdatafbox]
    if {$filename != {}} {
	set ch [open $filename w]

	switch $ap($tt,dim) {
	    2 {APSave2DData $tt $ch}
	    3 {APSave3DData $tt $ch}
	    4 {APSave4DData $tt $ch}
	    5 {APSave5DData $tt $ch}
	}

	close $ch
    }
    APRaise $tt
}

proc APSave2DData {tt ch} {
    global ap
    global $ap($tt,xdata) $ap($tt,ydata)

    set l [$ap($tt,xdata) length]

    for {set i 0} {$i<$l} {incr i} {
	set x [expr "$$ap($tt,xdata)\($i\)"]
	set y [expr "$$ap($tt,ydata)\($i\)"]
	puts $ch "$x $y"
    }
}

proc APSave3DData {tt ch} {
    global ap
    global $ap($tt,xdata) $ap($tt,ydata) $ap($tt,edata)

    set l [$ap($tt,xdata) length]

    for {set i 0} {$i<$l} {incr i} {
	set x [expr "$$ap($tt,xdata)\($i\)"]
	set y [expr "$$ap($tt,ydata)\($i\)"]
	set e [expr "$$ap($tt,edata)\($i\)"]
	puts $ch "$x $y $e"
    }
}

proc APSave4DData {tt ch} {
    global ap
    global $ap($tt,xdata) $ap($tt,ydata) $ap($tt,edata) $ap($tt,y2data)

    set l [$ap($tt,xdata) length]

    for {set i 0} {$i<$l} {incr i} {
	set x [expr "$$ap($tt,xdata)\($i\)"]
	set y [expr "$$ap($tt,ydata)\($i\)"]
	set e [expr "$$ap($tt,edata)\($i\)"]
	set y2 [expr "$$ap($tt,y2data)\($i\)"]
	puts $ch "$x $y $e $y2"
    }
}

proc APSave5DData {tt ch} {
    global ap
    global $ap($tt,xdata) $ap($tt,ydata) $ap($tt,edata) \
	$ap($tt,y2data) $ap($tt,e2data)

    set l [$ap($tt,xdata) length]

    for {set i 0} {$i<$l} {incr i} {
	set x [expr "$$ap($tt,xdata)\($i\)"]
	set y [expr "$$ap($tt,ydata)\($i\)"]
	set e [expr "$$ap($tt,edata)\($i\)"]
	set y2 [expr "$$ap($tt,y2data)\($i\)"]
	set e2 [expr "$$ap($tt,e2data)\($i\)"]
	puts $ch "$x $y $e $y2 $e2"
    }
}

proc APLoadConfig {tt} {
    global ds9
    global ap

    set filename [OpenFileDialog apconfigfbox]
    if {$filename != {}} {
	source $filename

        set ap($tt,grid) $analysisplot(grid)
        set ap($tt,grid,log) $analysisplot(grid,log)

        set ap($tt,discrete) $analysisplot(discrete)
        set ap($tt,discrete,symbol) $analysisplot(discrete,symbol)
        set ap($tt,discrete,color) $analysisplot(discrete,color)

        set ap($tt,linear) $analysisplot(linear)
        set ap($tt,linear,width) $analysisplot(linear,width)
        set ap($tt,linear,color) $analysisplot(linear,color)
        set ap($tt,linear,dash) $analysisplot(linear,dash)

        set ap($tt,step) $analysisplot(step)
        set ap($tt,step,width) $analysisplot(step,width)
        set ap($tt,step,color) $analysisplot(step,color)
        set ap($tt,step,dash) $analysisplot(step,dash)

        set ap($tt,quadratic) $analysisplot(quadratic)
        set ap($tt,quadratic,width) $analysisplot(quadratic,width)
        set ap($tt,quadratic,color) $analysisplot(quadratic,color)
        set ap($tt,quadratic,dash) $analysisplot(quadratic,dash)

        set ap($tt,error) $analysisplot(error)
        set ap($tt,error,width) $analysisplot(error,width)
        set ap($tt,error,color) $analysisplot(error,color)
        set ap($tt,error,style) $analysisplot(error,style)
    }

    APUpdate $tt
}

proc APSaveConfig {tt} {
    global ds9
    global ap

    set filename [SaveFileDialog apconfigfbox]

    if {$filename != {}} {
	set file [open $filename w]

        puts $file "set analysisplot(grid) $ap($tt,grid)"
        puts $file "set analysisplot(grid,log) $ap($tt,grid,log)"

        puts $file "set analysisplot(discrete) $ap($tt,discrete)"
        puts $file "set analysisplot(discrete,symbol) $ap($tt,discrete,symbol)"
        puts $file "set analysisplot(discrete,color) $ap($tt,discrete,color)"

        puts $file "set analysisplot(linear) $ap($tt,linear)"
        puts $file "set analysisplot(linear,width) $ap($tt,linear,width)"
        puts $file "set analysisplot(linear,color) $ap($tt,linear,color)"
        puts $file "set analysisplot(linear,dash) \"$ap($tt,linear,dash)\""

        puts $file "set analysisplot(step) $ap($tt,step)"
        puts $file "set analysisplot(step,width) $ap($tt,step,width)"
        puts $file "set analysisplot(step,color) $ap($tt,step,color)"
        puts $file "set analysisplot(step,dash) \"$ap($tt,step,dash)\""

        puts $file "set analysisplot(quadratic) $ap($tt,quadratic)"
        puts $file "set analysisplot(quadratic,width) $ap($tt,quadratic,width)"
        puts $file "set analysisplot(quadratic,color) $ap($tt,quadratic,color)"
        puts $file \
	    "set analysisplot(quadratic,dash) \"$ap($tt,quadratic,dash)\""

        puts $file "set analysisplot(error) $ap($tt,error)"
        puts $file "set analysisplot(error,width) $ap($tt,error,width)"
        puts $file "set analysisplot(error,color) $ap($tt,error,color)"
        puts $file "set analysisplot(error,style) \"$ap($tt,error,style)\""

	close $file
    }
}

proc APRange {tt} {
    global ap
    global ed

    set w ".aptitle"

    set ed(ok) 0
    set ed(xauto) $ap($tt,graph,x,auto)
    set ed(xmin) $ap($tt,graph,x,min)
    set ed(xmax) $ap($tt,graph,x,max)
    set ed(yauto) $ap($tt,graph,y,auto)
    set ed(ymin) $ap($tt,graph,y,min)
    set ed(ymax) $ap($tt,graph,y,max)

    DialogCreate $w Range -borderwidth 2
    frame $w.param -relief groove -borderwidth 2
    frame $w.buttons -relief groove -borderwidth 2
    pack $w.param $w.buttons -fill x -ipadx 4 -ipady 4

    label $w.param.xlabel -text "X Axis"
    entry $w.param.xmin -textvariable ed(xmin) -width 12 -relief sunken -bd 2
    label $w.param.xlabel2 -text "to"
    entry $w.param.xmax -textvariable ed(xmax) -width 12 -relief sunken -bd 2
    checkbutton $w.param.xauto -text "Auto" -variable ed(xauto)

    label $w.param.ylabel -text "Y Axis"
    entry $w.param.ymin -textvariable ed(ymin) -width 12 -relief sunken -bd 2
    label $w.param.ylabel2 -text "to"
    entry $w.param.ymax -textvariable ed(ymax) -width 12 -relief sunken -bd 2
    checkbutton $w.param.yauto -text "Auto" -variable ed(yauto)

    grid $w.param.xlabel $w.param.xmin $w.param.xlabel2 $w.param.xmax \
	$w.param.xauto  -padx 4 -pady 1 -sticky w
    grid $w.param.ylabel $w.param.ymin $w.param.ylabel2 $w.param.ymax \
	$w.param.yauto  -padx 4 -pady 1 -sticky w

    button $w.buttons.ok -text "OK" -default active -command {set ed(ok) 1}
    button $w.buttons.cancel -text "Cancel" -command {set ed(ok) 0}
    pack $w.buttons.ok -side left -padx 10
    pack $w.buttons.cancel -side right -padx 10

    bind $w <Return> {set ed(ok) 1}
    bind $w <Alt-o> "tkButtonInvoke $w.buttons.ok"
    bind $w <Alt-c> "tkButtonInvoke $w.buttons.cancel"

    DialogCenter $w 
    DialogWait $w ed(ok) $w.param.xmin
    DialogDismiss $w

    if {$ed(ok)} {
	set ap($tt,graph,x,auto) $ed(xauto)
	set ap($tt,graph,x,min) $ed(xmin) 
	set ap($tt,graph,x,max) $ed(xmax) 
	set ap($tt,graph,y,auto) $ed(yauto) 
	set ap($tt,graph,y,min) $ed(ymin) 
	set ap($tt,graph,y,max) $ed(ymax) 

	APUpdate $tt
    }
    
    unset ed
}

proc APTitle {tt} {
    global ap
    global ed

    set w ".aptitle"

    set ed(ok) 0
    set ed(title) $ap($tt,graph,title)
    set ed(xaxis) $ap($tt,graph,xaxis)
    set ed(yaxis) $ap($tt,graph,yaxis)

    DialogCreate $w Labels -borderwidth 2
    frame $w.param -relief groove -borderwidth 2
    frame $w.buttons -relief groove -borderwidth 2
    pack $w.param $w.buttons -fill x -ipadx 4 -ipady 4

    label $w.param.label -text "Plot Title"
    entry $w.param.title -textvariable ed(title) -width 23 -relief sunken -bd 2
    label $w.param.xlabel -text "X Axis Label"
    entry $w.param.xtitle -textvariable ed(xaxis) \
	-width 23 -relief sunken -bd 2
    label $w.param.ylabel -text "Y Axis Label"
    entry $w.param.ytitle -textvariable ed(yaxis) \
	-width 23 -relief sunken -bd 2

    grid $w.param.label $w.param.title -padx 4 -pady 1 -sticky w
    grid $w.param.xlabel $w.param.xtitle -padx 4 -pady 1 -sticky w
    grid $w.param.ylabel $w.param.ytitle -padx 4 -pady 1 -sticky w

    button $w.buttons.ok -text "OK" -default active -command {set ed(ok) 1}
    button $w.buttons.cancel -text "Cancel" -command {set ed(ok) 0}
    pack $w.buttons.ok -side left -padx 10
    pack $w.buttons.cancel -side right -padx 10

    bind $w <Return> {set ed(ok) 1}
    bind $w <Alt-o> "tkButtonInvoke $w.buttons.ok"
    bind $w <Alt-c> "tkButtonInvoke $w.buttons.cancel"

    DialogCenter $w 
    DialogWait $w ed(ok) $w.param.title
    DialogDismiss $w

    if {$ed(ok)} {
	set ap($tt,graph,title) $ed(title)
	set ap($tt,graph,xaxis) $ed(xaxis)
	set ap($tt,graph,yaxis) $ed(yaxis)
	APUpdate $tt
    }
    
    unset ed
}

proc APCreateLineMenu {which var1 var2 cmd} {
    global ap
    global menu

    menu $which -tearoff 0 -selectcolor $menu(selectcolor)
    $which add radiobutton -label 1 -variable $var1 -value 1 -command $cmd
    $which add radiobutton -label 2 -variable $var1 -value 2 -command $cmd
    $which add radiobutton -label 3 -variable $var1 -value 3 -command $cmd
    $which add radiobutton -label 4 -variable $var1 -value 4 -command $cmd
    $which add separator
    $which add radiobutton -label Solid -variable $var2 -value " " \
	-command $cmd
    $which add radiobutton -label Dash  -variable $var2 -value "8 3" \
	-command $cmd
}

proc APCreateColorMenu {which var cmd} {
    global ap
    global menu

    menu $which -tearoff 0 -selectcolor $menu(selectcolor)
    $which add radiobutton -label "Black" -variable $var -value black \
	-command $cmd
    $which add radiobutton -label "White" -variable $var -value white \
	-command $cmd
    $which add radiobutton -label "Red" -variable $var -value red \
	-command $cmd
    $which add radiobutton -label "Green" -variable $var -value green \
	-command $cmd
    $which add radiobutton -label "Blue" -variable $var -value blue \
	-command $cmd
    $which add radiobutton -label "Cyan" -variable $var -value cyan \
	-command $cmd
    $which add radiobutton -label "Magenta" -variable $var -value magenta \
	-command $cmd
    $which add radiobutton -label "Yellow" -variable $var -value yellow \
	-command $cmd
}

proc APNextColor {which} {
    switch $which {
	black {return white}
	white {return black}
	red {return green}
	green {return blue}
	blue {return red}
	cyan {return magenta}
	magenta {return yellow}
	yellow {return cyan}
    }
}

proc APCreateFontMenu {which var1 var2 var3 cmd} {
    global ap
    global menu

    menu $which -tearoff 0 -selectcolor $menu(selectcolor)
    $which add radiobutton -label Times -variable $var1 -value times \
	-command $cmd
    $which add radiobutton -label Helvetica -variable $var1 -value helvetica \
	-command $cmd
    $which add radiobutton -label Symbol -variable $var1 -value symbol \
	-command $cmd
    $which add radiobutton -label Courier -variable $var1 -value courier \
	-command $cmd
    $which add separator
    $which add radiobutton -label 9 -variable $var2 -value 9 -command $cmd
    $which add radiobutton -label 10 -variable $var2 -value 10 -command $cmd
    $which add radiobutton -label 12 -variable $var2 -value 12 -command $cmd
    $which add radiobutton -label 14 -variable $var2 -value 14 -command $cmd
    $which add radiobutton -label 18 -variable $var2 -value 18 -command $cmd
    $which add radiobutton -label 24 -variable $var2 -value 24 -command $cmd
    $which add radiobutton -label 30 -variable $var2 -value 30 -command $cmd
    $which add radiobutton -label 36 -variable $var2 -value 36 -command $cmd
    $which add separator
    $which add radiobutton -label Plain -variable $var3 -value normal \
	-command $cmd
    $which add radiobutton -label Bold -variable $var3 -value bold \
	-command $cmd
    $which add radiobutton -label Italic -variable $var3 -value italic \
	-command $cmd
}

proc APPrint {tt} {
    global tcl_platform

    if {[PrintDialog ap]} {
	if {$tcl_platform(platform)!= "windows"} {
	    set w .status
	    DisplayStatusMsg $w "Printing, please wait..."
	    if [catch {APPostScript $tt} printError] {
		Error "A printing error has occured: $printError"
	    }
	    DestroyStatusMsg $w
	} else {
	    if [catch {APPostScript $tt} printError] {
		Error "A printing error has occured: $printError"
	    }
	}
    }
}

proc APPostScript {tt} {
    global ps
    global ap

    set options "-decorations false -colormode $ps(color2)"

    # Orientation

    switch $ps(orient) {
	portrait {set options "$options -landscape false"}
	landscape {set options "$options -landscape true"}
    }

    # Page size

    switch $ps(size) {
	letter {APPageSize 8.5i 11.i options $tt}
	legal {APPageSize 8.5i 14.i options $tt}
	tabloid {APPageSize 11.i 17.i options $tt}
	poster {APPageSize 36.i 48.i options $tt}
	a4 {APPageSize 195m 282m options $tt}
	other {
	    if {$ps(width) != "" && $ps(height) != ""} {
		set w [expr $ps(width)]
		set h [expr $ps(height)]
		APPageSize [append w i] [append h i] options $tt
	    }
	}
	othermm {
	    if {$ps(width) != "" && $ps(height) != ""} {
		set w [expr $ps(width)]
		set h [expr $ps(height)]
		APPageSize [append w m] [append h m] options $tt
	    }
	}
    }

    if {$ps(dest) == "file" && $ps(filename) != ""} {
	eval $ap($tt,graph) postscript output $ps(filename) $options
    } else {
	set ch [open "| $ps(cmd)" w]
	puts $ch [eval $ap($tt,graph) postscript output $options]
	close $ch
    }
}

proc APPageSize {w h optname tt} {
    upvar $optname options
    global ps
    global ap

    set options "$options -paperwidth $w -paperheight $h"

    set width [winfo width $ap($tt,graph)]
    set height [winfo height $ap($tt,graph)]
    set aspect [expr double($height)/$width]

    if {$ps(scale) == "scaled"} {
	regexp {([0-9.]*)([icmp])?} $w foo a b
	set options "$options -width $w -height [expr $a*$aspect]${b}"
    } else {
	set options "$options -width 0 -height 0"
    }
}

proc APPrefsMenu {} {
    global ds9
    global menu
    global prefs

    set mb $ds9(mb).prefs.analysis.plot

    menu $mb -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $mb add checkbutton -label "Always Create New Plot" \
	-variable prefs(ap,unique)
    $mb add separator
    $mb add cascade -label "View" -menu $mb.view
    $mb add cascade -label "Grid" -menu $mb.grid
    $mb add cascade -label "Line" -menu $mb.line
    $mb add cascade -label "Color" -menu $mb.color
    $mb add cascade -label "Font" -menu $mb.font

    # Analysis Plot View Prefs

    menu $mb.view -tearoff $menu(tearoff) -selectcolor $menu(selectcolor)
    $mb.view add checkbutton -label Discrete -variable prefs(ap,discrete) 
    $mb.view add checkbutton -label Line -variable prefs(ap,linear) 
    $mb.view add checkbutton -label Step -variable prefs(ap,step) 
    $mb.view add checkbutton -label Quadratic -variable prefs(ap,quadratic)

    # Analysis Plot Grid Prefs

    menu $mb.grid -tearoff $menu(tearoff) -selectcolor $menu(selectcolor)
    $mb.grid add checkbutton -label "Grid" -variable prefs(ap,grid)
    $mb.grid add separator
    $mb.grid add radiobutton -label "Linear-Linear" \
	-variable prefs(ap,grid,log) -value linearlinear
    $mb.grid add radiobutton -label "Linear-Log" \
	-variable prefs(ap,grid,log) -value linearlog
    $mb.grid add radiobutton -label "Log-Linear" \
	-variable prefs(ap,grid,log) -value loglinear
    $mb.grid add radiobutton -label "Log-Log" \
	-variable prefs(ap,grid,log) -value loglog

    # Analysis Plot Color Prefs

    menu $mb.color -tearoff $menu(tearoff) -selectcolor $menu(selectcolor)
    $mb.color add cascade -label Discrete -menu $mb.color.discrete
    $mb.color add cascade -label Line -menu $mb.color.linear
    $mb.color add cascade -label Step -menu $mb.color.step
    $mb.color add cascade -label Quadratic -menu $mb.color.quadratic
    $mb.color add cascade -label Errorbar -menu $mb.color.error

    APCreateColorPrefsMenu $mb.color.discrete prefs(ap,discrete,color)
    APCreateColorPrefsMenu $mb.color.linear prefs(ap,linear,color)
    APCreateColorPrefsMenu $mb.color.step prefs(ap,step,color)
    APCreateColorPrefsMenu $mb.color.quadratic prefs(ap,quadratic,color)
    APCreateColorPrefsMenu $mb.color.error prefs(ap,error,color)

    # Analysis Plot Line Prefs

    menu $mb.line -tearoff $menu(tearoff) -selectcolor $menu(selectcolor)
    $mb.line add cascade -label Discrete -menu $mb.line.discrete
    $mb.line add cascade -label Line -menu $mb.line.linear
    $mb.line add cascade -label Step -menu $mb.line.step
    $mb.line add cascade -label Quadratic -menu $mb.line.quadratic
    $mb.line add cascade -label Errorbar -menu $mb.line.error

    menu $mb.line.discrete -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $mb.line.discrete add radiobutton -label "Circle" \
	-variable prefs(ap,discrete,symbol) -value circle 	
    $mb.line.discrete add radiobutton -label "Diamond" \
	-variable prefs(ap,discrete,symbol) -value diamond 	
    $mb.line.discrete add radiobutton -label "Plus" \
	-variable prefs(ap,discrete,symbol) -value plus 	
    $mb.line.discrete add radiobutton -label "Cross" \
	-variable prefs(ap,discrete,symbol) -value cross 	

    APCreateLinePrefsMenu $mb.line.linear prefs(ap,linear,width) \
	prefs(ap,linear,dash)
    APCreateLinePrefsMenu $mb.line.step prefs(ap,step,width) \
	prefs(ap,step,dash)
    APCreateLinePrefsMenu $mb.line.quadratic prefs(ap,quadratic,width) \
	prefs(ap,quadratic,dash)

    menu $mb.line.error -tearoff $menu(tearoff) -selectcolor $menu(selectcolor)
    $mb.line.error add radiobutton -label 0 \
	-variable prefs(ap,error,width) -value 0 
    $mb.line.error add radiobutton -label 1 \
	-variable prefs(ap,error,width) -value 1 
    $mb.line.error add radiobutton -label 2 \
	-variable prefs(ap,error,width) -value 2 
    $mb.line.error add radiobutton -label 3 \
	-variable prefs(ap,error,width) -value 3 
    $mb.line.error add separator
    $mb.line.error add radiobutton -label "Style 1" \
	-variable prefs(ap,error,style) -value 0 
    $mb.line.error add radiobutton -label "Style 2" \
	-variable prefs(ap,error,style) -value 1 

    # Analysis Plot Font Prefs

    menu $mb.font -tearoff $menu(tearoff) -selectcolor $menu(selectcolor)
    $mb.font add cascade -label "Axis Numbers" -menu $mb.font.numlab
    $mb.font add cascade -label "Axis Label" -menu $mb.font.textlab
    $mb.font add cascade -label "Title" -menu $mb.font.title

    APCreateFontPrefsMenu $mb.font.numlab \
	prefs(ap,numlabFont) prefs(ap,numlabSize) prefs(ap,numlabStyle)
    APCreateFontPrefsMenu $mb.font.textlab \
	prefs(ap,textlabFont) prefs(ap,textlabSize) prefs(ap,textlabStyle)
    APCreateFontPrefsMenu $mb.font.title \
	prefs(ap,titleFont) prefs(ap,titleSize) prefs(ap,titleStyle)
}

proc APCreateLinePrefsMenu {which var1 var2} {
    global menu
    global prefs

    menu $which -tearoff $menu(tearoff) -selectcolor $menu(selectcolor)
    $which add radiobutton -label 0 -variable $var1 -value 0
    $which add radiobutton -label 1 -variable $var1 -value 1
    $which add radiobutton -label 2 -variable $var1 -value 2
    $which add radiobutton -label 3 -variable $var1 -value 3
    $which add separator
    $which add radiobutton -label Solid -variable $var2 -value " "
    $which add radiobutton -label Dash  -variable $var2 -value "8 3"
}

proc APCreateColorPrefsMenu {which var} {
    global menu
    global prefs

    menu $which -tearoff $menu(tearoff) -selectcolor $menu(selectcolor)
    $which add radiobutton -label "Black" -variable $var -value black
    $which add radiobutton -label "White" -variable $var -value white
    $which add radiobutton -label "Red" -variable $var -value red
    $which add radiobutton -label "Green" -variable $var -value green
    $which add radiobutton -label "Blue" -variable $var -value blue
    $which add radiobutton -label "Cyan" -variable $var -value cyan
    $which add radiobutton -label "Magenta" -variable $var -value magenta
    $which add radiobutton -label "Yellow" -variable $var -value yellow
}

proc APCreateFontPrefsMenu {which var1 var2 var3} {
    global menu
    global prefs

    menu $which -tearoff $menu(tearoff) -selectcolor $menu(selectcolor)
    $which add radiobutton -label Times -variable $var1 -value times
    $which add radiobutton -label Helvetica -variable $var1 -value helvetica
    $which add radiobutton -label Symbol -variable $var1 -value symbol
    $which add radiobutton -label Courier -variable $var1 -value courier
    $which add separator
    $which add radiobutton -label 9 -variable $var2 -value 9
    $which add radiobutton -label 10 -variable $var2 -value 10
    $which add radiobutton -label 12 -variable $var2 -value 12
    $which add radiobutton -label 14 -variable $var2 -value 14
    $which add radiobutton -label 18 -variable $var2 -value 18
    $which add radiobutton -label 24 -variable $var2 -value 24
    $which add radiobutton -label 30 -variable $var2 -value 30
    $which add radiobutton -label 36 -variable $var2 -value 36
    $which add separator
    $which add radiobutton -label Plain -variable $var3 -value normal
    $which add radiobutton -label Bold -variable $var3 -value bold
    $which add radiobutton -label Italic -variable $var3 -value italic
}

proc APUpdateVector {tt dim data xx yy ee yy2 ee2} {
    global ap
    global $xx $yy $ee $yy2 $ee2

    set ap($tt,dim) $dim

    # substitute all separtors
    regsub -all {[\n\r\t, ]+} $data { } data
    # remove all non-numeric data
    regsub -all {[^0-9.e\- ]+} $data {} data

    if {[$xx length] > 0} {
	$xx delete :
    }
    if {[$yy length] > 0} {
	$yy delete :
    }
    if {[$ee length] > 0} {
	$ee delete :
    }
    if {[$yy2 length] > 0} {
	$yy2 delete :
    }
    if {[$ee2 length] > 0} {
	$ee2 delete :
    }

    set l [llength $data]
    switch $dim {
	2 {
	    set x {}
	    set y {}
	    for {set i 0} {$i<$l} {incr i 2} {
		lappend x [lindex $data $i]
		lappend y [lindex $data [expr $i+1]]
	    }
	    $xx set $x
	    $yy set $y
	}

	3 {
	    set x {}
	    set y {}
	    set e {}
	    for {set i 0} {$i<$l} {incr i 3} {
		lappend x [lindex $data $i]
		lappend y [lindex $data [expr $i+1]]
		lappend e [lindex $data [expr $i+2]]
	    }
	    $xx set $x
	    $yy set $y
	    $ee set $e
	}

	4 {
	    set x {}
	    set y {}
	    set e {}
	    set y2 {}
	    for {set i 0} {$i<$l} {incr i 4} {
		lappend x [lindex $data $i]
		lappend y [lindex $data [expr $i+1]]
		lappend e [lindex $data [expr $i+2]]
		lappend y2 [lindex $data [expr $i+3]]
	    }
	    $xx set $x
	    $yy set $y
	    $ee set $e
	    $yy2 set $y2
	}

	5 {
	    set x {}
	    set y {}
	    set e {}
	    set y2 {}
	    set e2 {}
	    for {set i 0} {$i<$l} {incr i 5} {
		lappend x [lindex $data $i]
		lappend y [lindex $data [expr $i+1]]
		lappend e [lindex $data [expr $i+2]]
		lappend y2 [lindex $data [expr $i+3]]
		lappend e2 [lindex $data [expr $i+4]]
	    }
	    $xx set $x
	    $yy set $y
	    $ee set $e
	    $yy2 set $y2
	    $ee2 set $e2
	}
    }
}

