package provide DS9 1.0

proc ButtonExamine {which x y} {
    global current
    global ds9
    global examine
    global slave
    global master

    if {![$current(frame) has fits]} {
	return
    }

    if {[$which has bin]} {
	set coord [$which get coordinates canvas $x $y physical]
    } else {
	set coord [$which get coordinates canvas $x $y image]
    }

    # go to tile mode in case
    set ds9(displaymode) tile

    switch $examine(mode) {
	new {
	    CreateNamedFrame FrameEx
	    set f $current(frame)
	}
	one {
	    if {[info exists examine(one)]} {
		set f $examine(one)
		$f clear
	    } else {
		CreateNamedFrame FrameEx
		set examine(one) $current(frame)
		set f $examine(one)
	    }
	}
    }

    $f load fits slave [$which get fits master]
    lappend slave($which) $f
    lappend master($f) $which

    $f zoom to [$which get zoom]
    $f orient [$which get orient]
    $f rotate [$which get rotate]
    $f wcs align [$which get wcs align]

    update idletasks

    # zoom to about
    if {[$f has bin]} {
	$f bin factor [expr 1./$examine(zoom)] about \
	    physical [lindex $coord 0] [lindex $coord 1]
    } else {
	$f zoom $examine(zoom) about \
	image [lindex $coord 0] [lindex $coord 1]
    }

    set ds9(next) $which
    GotoFrame
    $which magnifier on
}

proc DeleteExamine {which} {
    global master
    global slave
    global examine

    # check to see if it has any slaves
    if {[info exists slave($which)]} {
	foreach f $slave($which) {
	    DeleteFrame $f
	}
	unset slave($which)
    }

    # cleck to see if it has any masters
    if {[info exists master($which)]} {
	set m $master($which)
	if {[info exists slave($m)]} {
	    set i [lsearch $slave($m) $which]
	    set slave($m) [lreplace $slave($m) $i $i]
	}
	unset master($which)
    }

    # check to see if its an examine(one) frame
    if {[info exists examine(one)]} {
	if {$which == $examine(one)} {
	    unset examine(one)
	}
    }
}
