package provide DS9 1.0

proc HelpRef {} {
    global help
    HelpApp "openURL($help(ref))"
}

proc HelpRefPref {} {
    global help
    set result $help(ref)
    if [EntryDialog "Help" "Enter Reference Documentation Location (URL):" \
	    80 result] {
	set help(ref) $result
    }
}

proc HelpUser {} {
    global help
    HelpApp "openURL($help(user))"
}

proc HelpUserPref {} {
    global help
    set result $help(user)
    if [EntryDialog "Help" "Enter User Documentation Location (URL):" \
	    80 result] {
	set help(user) $result
    }
}

proc HelpCommands {} {
    global help

    set tt cmdln
    set w ".${tt}"
    if {[winfo exist $w]} {
	raise $w
    } else {
	SimpleTextDialog $tt "Command Line Options" 80 20 insert top \
	    "$help(commands)\n"
    }
}

proc HelpShortCuts {} {
    global help

    set tt shtcts
    set w ".${tt}"
    if {[winfo exist $w]} {
	raise $w
    } else {
	SimpleTextDialog $tt "Keyboard Shortcuts" 80 20 insert top \
	    "$help(shortcuts)\n"
    }
}

proc HelpDesk {} {
    global help
    HelpApp "mailto($help(email))"
}

proc HelpApp {command} {
    global help

    set w ".help"
    DisplayStatusMsg $w "Starting Help, please wait..."
    if [catch {exec $help(app) -remote "$command"}] {
	catch {exec $help(app) &}
	after 5000
	for {set i 0} {$i < 10} {incr i} {
	    if {![catch {exec $help(app) -remote "$command"}]} {
		DestroyStatusMsg $w
		return
	    }
	    after 1000
	}
	DestroyStatusMsg $w
	Error "Help: Unable to execute $help(app)."
	return
    }
    DestroyStatusMsg $w
}

proc DumpHelp {} {
    global help
    puts "$help(commands)"
}

proc InitHelp {} {
    global help

    set help(about) "Display credits"

    set help(bin) "\t\[about <x> <y>\]\n\t\t\[buffersize <value>\]\n\t\t\[cols <x> <y>\]\n\t\t\[factor <value>\]\n\t\t\[filter <string>\]\n\t\t\[function average|sum\]\n\t\t\[to fit\]"

    set help(contour) "\[yes|no\]\n\t\t\[copy\]\n\t\t\[paste <coordinate system> <color> <width>\]\n\t\t\[load <filename> <color> <width>\]\n\t\t\[save <filename> <coordinate system>\]"

    set help(cmap) "\t\[<colormap>\]\n\t\t\[file <filename>\]\n\t\t\[invert yes|no\]\n\t\t\[value <constrast> <bias>\]"

    set help(dss) "\t\[<object>\]\n\t\t\[name <object>\]\n\t\t\[coord <ra> <dec>\]\n\t\t\[server sao|stsci|eso\]\n\t\t\[survey dss|dss2red|dss2blue\]\n\t\t\[size <width> <height>\]"

    set help(grid) "\t\[yes|no]\n\t\t\[load <filename>\]\n\t\t\[save <filename>\]"

    set help(minmax) "\t\[\]\n\t\t\[scan|sample|datamin|irafmin\]\n\t\t\[mode scan|sample|datamin|irafmin\]\n\t\t\[interval <value>\]"

    set help(nsvr) "\[<object>\]\n\t\t\[name <object>\]\n\t\t\[server ned-sao|ned-eso|simbad-sao|simbad-eso\]\n\t\t\[format degrees|sexagesimal\]"

    set help(orient) "\t\[none|x|y|xy\]"

    set help(pagesetup)	"\[orientation portrait|landscape\]\n\t\t\[pagescale scaled|fixed\]\n\t\t\[pagesize letter|legal|a4\]"

    set help(pan) "\t\[x y image|physical|fk4|fk5|icrs|galactic|ecliptic|linear\]\n\t\t\[to x y image|physical|fk4|fk5|icrs|galactic|ecliptic|linear\]"

    set help(print) "\t\[destination printer|file\]\n\t\t\[command <command>\]\n\t\t\[filename <filename>\]\n\t\t\[palette rgb|cmyk|gray\]\n\t\t\[level 1|2\]\n\t\t\[interpolate yes|no\]\n\t\t\[resolution 53|72|75|150|300|600\]"

    set help(rotate) "\t\[<value>\]\n\t\t\[to <value>\]"

    set help(saveas) "\t\[jpeg|tiff|png|ppm <filename>\]"

    set help(scale) "\t\[linear|log|squared|sqrt|histequ\]\n\t\t\[datasec yes|no\]\n\t\t\[limits <minvalue> <maxvalue>\]\n\t\t\[mode minmax|<value>|zscale|zmax\]\n\t\t\[scope local|global\]"

    set help(shm) "\t\[<key> <size> \[<filename>\]\] \n\t\t\[key <key> <size> \[<filename>\]\]\n\t\t\[shmid <shmid> <size> \[<filename>\]\]\n\t\t\[mosaicimage \[key|shmid\] <id> <size> \[<filename>\]\]\n\t\t\[mosaic \[key|shmid\] <id> <size> \[<filename>\]\]\n\t\t\[array \[key|shmid\] <id> <size> \[dim=<dim>,bitpix=<b>,\[skip=<s>\]\]"

    set help(tile) "\t\[yes|no\]\n\t\t\[mode grid|row|column\]\n\t\t\[grid\]\n\t\t\[grid mode \[automatic|manual\]\]\n\t\t\[grid layout <row> <col>\]\n\t\t\[grid gap <pixels>\]\n\t\t\[row\]\n\t\t\[column\]"

    set help(view) "\t\[info yes|no\]\n\t\t\[panner yes|no\]\n\t\t\[magnifier yes|no\]\n\t\t\[buttons yes|no\]\n\t\t\[colorbar yes|no\]\n\t\t\[horzgraph yes|no\]\n\t\t\[vertgraph yes|no\]\n\t\t\[wcs yes|no\]\n\t\t\[detector yes|no\]\n\t\t\[amplifier yes|no\]\n\t\t\[physical yes|no\]\n\t\t\[image yes|no\]" 

    set help(version) "-- display version"

    set help(zoom) "\t\[<value>\]\n\t\t\[to fit\]\n\t\t\[to <value>\]"

    global ds9
    set help(commands) " DS9 version $ds9(version)\n\
          Usage: ds9 \[options\] \[filename(s)...\]\n\
          \-?\t\tDisplay this message\n\
          \-about \t$help(about)\n\
          \-align\n\
          \-analysis \t<filename>\n\
          \-array \t<filename>\n\
          \-bin \t$help(bin)\n\
          \-blink\n\
          \-cmap \t$help(cmap)\n\
          \-contour \t$help(contour)\n\
          \-coords \t\[wcs|detector|amplifier|physical|image\] \[yes|no\]\n\
          \-dss \t$help(dss)\n\
          \-exit\n\
          \-fifo \t\t<name>\n\
          \-fifo_only\n\
          \-file \t\t<filename>\n\
          \-geometry \t<value>\n\
          \-grid \t$help(grid)\n\
          \-histequ\n\
          \-\iconify\n\
          \-\inet_only\n\
          \-invert\n\
          \-linear\n\
          \-log\n\
          \-lower\n\
          \-minmax $help(minmax)\n\
          \-mode \t\t\[pointer|crosshair|colorbar|pan|zoom|rotate|examine\]\n\
          \-mosaic \t<filename>\n\
          \-mosaicimage \t<filename>\n\
          \-nameserver \t$help(nsvr)\n\
          \-orient $help(orient)\n\
          \-pagesetup \t$help(pagesetup)\n\
          \-pan \t$help(pan)\n\
          \-\[no\]pixeltable\n\
          \-print $help(print)\n\
          \-private\n\
          \-port \t\t<number>\n\
          \-port_only\n\
          \-quit\n\
          \-raise\n\
          \-region \t<filename>\n\
          \-rotate $help(rotate)\n\
          \-saveas $help(saveas)\n\
          \-scale $help(scale)\n\
          \-shm \t$help(shm)\n\
          \-single\n\
          \-squared\n\
          \-sqrt\n\
          \-source \t<filename>\n\
          \-tile \t$help(tile)\n\
          \-title \t<name>\n\
          \-unix \t\t<name>\n\
          \-unix_only\n\
          \-url \t\t<url>\n\
          \-view \t$help(view)\n\
          \-version \t$help(version)\n\
          \-visual \t\[pseudocolor8|truecolor8|truecolor16|truecolor24\]\n\
          \-wcs \t\t\[fk4|fk5|galactic|ecliptic\]\n\
          \-wcsformat \t\[degrees|sexagesimal\]\n\
          \-zmax\n\
          \-zscale\n\
          \-zoom \t$help(zoom)\n
"
    set help(shortcuts) " DS9 version $ds9(version)\n\n\
          Key Stroke       Description\n\
          ----------       -----------\n\
          TAB              Goto next frame\n\
          DELETE           Deletes selected regions\n\
          C                Print Mouse Coordinates and Pixel value.\n\
          F                Toggles Infobox freeze\n\
          I                Set include property for region\n\
          E                Set exclude property for region\n\
          S                Set source property for region\n\
          B                Set background property for region\n\
          +                Goto next 3D Fits Slice\n\
          -                Goto previous 3D Fits Slice\n\
          Up Arrow         Move selected regions/cursor up one pixel.\n\
          Right Arrow      Move selected regions/cursor right one pixel.\n\
          Left Arrow       Move selected regions/cursor left one pixel.\n\
          Down Arrow       Move selected regions/cursor down one pixel.\n\
          Shift-Drag       Select all regions within the indicated region.\n\
          Control-Drag     Selected ANNULUS Regions, will create new radii.\n
"
}

