package provide DS9 1.0

proc CreateMenuBar {} {
    global ds9
    global menu
    global tcl_platform

    menu $ds9(mb) -selectcolor $menu(selectcolor)
    $ds9(mb) add cascade -label "File" -menu $ds9(mb).file -underline 0
    $ds9(mb) add cascade -label "Edit" -menu $ds9(mb).edit -underline 0
    $ds9(mb) add cascade -label "Frame" -menu $ds9(mb).frame -underline 3
    $ds9(mb) add cascade -label "Bin" -menu $ds9(mb).bin -underline 0
    $ds9(mb) add cascade -label "Zoom" -menu $ds9(mb).zoom -underline 0
    $ds9(mb) add cascade -label "Scale" -menu $ds9(mb).scale -underline 0
    $ds9(mb) add cascade -label "Color" -menu $ds9(mb).color -underline 0
    $ds9(mb) add cascade -label "Region" -menu $ds9(mb).region -underline 0
    $ds9(mb) add cascade -label "Analysis" -menu $ds9(mb).analysis -underline 0

    if {$tcl_platform(platform) != "windows"} {
	$ds9(mb) add cascade -label "Help" -menu $ds9(mb).help -underline 0
    }

    # File Menu

    menu $ds9(mb).file -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 File"
    $ds9(mb).file add command -label "About DS9..." \
	-command AboutBox -underline 0
    $ds9(mb).file add separator
    $ds9(mb).file add command -label "Open..." -command OpenFits -underline 0
    $ds9(mb).file add cascade -label "Open Other" -menu $ds9(mb).file.open
    $ds9(mb).file add separator
    $ds9(mb).file add cascade -label "Save as" -menu $ds9(mb).file.save
    $ds9(mb).file add separator
    $ds9(mb).file add command -label "Display Fits Header" \
	-command DisplayHeaderMenu -underline 0
    $ds9(mb).file add command -label "Source TCL..." \
	-command OpenSource -underline 0
    $ds9(mb).file add separator
    $ds9(mb).file add command -label "Print..." \
	-command Print -underline 0
    $ds9(mb).file add command -label "Page Setup..." -command PageDialog
    $ds9(mb).file add separator
    $ds9(mb).file add command -label "Exit" -command QuitDS9 -underline 0

    menu $ds9(mb).file.open -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 File Open"
    $ds9(mb).file.open add command -label "Open Array..." -command OpenArray
    $ds9(mb).file.open add command -label "Open URL..." -command OpenURL
    $ds9(mb).file.open add separator
    $ds9(mb).file.open add command -label "Open Mosaic Image..." \
	-command OpenMosaicImageFits
    $ds9(mb).file.open add command -label "Open Mosaic Segment..." \
	-command OpenMosaicFits

    menu $ds9(mb).file.save -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 File Save"
    $ds9(mb).file.save add command -label "Fits..." -command SaveFits
    $ds9(mb).file.save add command -label "Image..." -command SaveAsDialog

    # Edit Menu

    menu $ds9(mb).edit -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Edit"
    $ds9(mb).edit add command -label "Undo" -command UndoFrame
    $ds9(mb).edit add separator
    $ds9(mb).edit add command -label "Cut" -command CutFrame
    $ds9(mb).edit add command -label "Copy" -command CopyFrame
    $ds9(mb).edit add command -label "Paste" -command PasteFrame
    $ds9(mb).edit add separator
    $ds9(mb).edit add radiobutton -label "Pointer" \
	-variable ds9(mode) -value pointer -command ChangeMode -underline 0
    $ds9(mb).edit add radiobutton -label "Crosshair" \
	-variable ds9(mode) -value crosshair -command ChangeMode -underline 0
    $ds9(mb).edit add radiobutton -label "Colorbar" \
	-variable ds9(mode) -value colorbar -command ChangeMode -underline 5
    $ds9(mb).edit add radiobutton -label "Pan" \
	-variable ds9(mode) -value pan -command ChangeMode -underline 1
    $ds9(mb).edit add radiobutton -label "Zoom" \
	-variable ds9(mode) -value zoom -command ChangeMode -underline 0
    $ds9(mb).edit add radiobutton -label "Rotate" \
	-variable ds9(mode) -value rotate -command ChangeMode -underline 0
    $ds9(mb).edit add radiobutton -label "Examine" \
	-variable ds9(mode) -value examine -command ChangeMode -underline 0
    $ds9(mb).edit add separator
    $ds9(mb).edit add radiobutton -label "Equatorial B1950" \
	-variable wcs(system) -value fk4 -underline 11
    $ds9(mb).edit add radiobutton -label "Equatorial J2000" \
	-variable wcs(system) -value fk5 -underline 11
    $ds9(mb).edit add radiobutton -label "ICRS" \
	-variable wcs(system) -value icrs -underline 0
    $ds9(mb).edit add radiobutton -label "Galactic" \
	-variable wcs(system) -value galactic -underline 0
    $ds9(mb).edit add radiobutton -label "Ecliptic" \
	-variable wcs(system) -value ecliptic -underline 5
    $ds9(mb).edit add separator
    $ds9(mb).edit add radiobutton -label "Degrees" \
	-variable wcs(format) -value degrees -underline 0
    $ds9(mb).edit add radiobutton -label "Sexagesimal" \
	-variable wcs(format) -value sexagesimal -underline 0
    $ds9(mb).edit add separator
    $ds9(mb).edit add cascade -label "Preferences" -menu $ds9(mb).prefs

    # Prefs Menu

    menu $ds9(mb).prefs -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Preferences"
    $ds9(mb).prefs add cascade -label "File Menu" \
	-menu $ds9(mb).prefs.file
    $ds9(mb).prefs add cascade -label "Edit Menu" \
	-menu $ds9(mb).prefs.edit
    $ds9(mb).prefs add cascade -label "Frame Menu" \
	-menu $ds9(mb).prefs.frame
    $ds9(mb).prefs add cascade -label "Bin Menu" \
	-menu $ds9(mb).prefs.bin
    $ds9(mb).prefs add cascade -label "Zoom Menu" \
	-menu $ds9(mb).prefs.zoom
    $ds9(mb).prefs add cascade -label "Scale Menu" \
	-menu $ds9(mb).prefs.scale
    $ds9(mb).prefs add cascade -label "Color Menu" \
	-menu $ds9(mb).prefs.color
    $ds9(mb).prefs add cascade -label "Region Menu" \
	-menu $ds9(mb).prefs.region
    $ds9(mb).prefs add cascade -label "Analysis Menu" \
	-menu $ds9(mb).prefs.analysis
    $ds9(mb).prefs add cascade -label "Help Menu" -menu $ds9(mb).prefs.help
    $ds9(mb).prefs add separator
    $ds9(mb).prefs add cascade -label "View" -menu $ds9(mb).prefs.view
    $ds9(mb).prefs add cascade -label "View Info Panel" \
	-menu $ds9(mb).prefs.info
    $ds9(mb).prefs add cascade -label "Mosaics" -menu $ds9(mb).prefs.mosaic
    $ds9(mb).prefs add cascade -label "Panner" -menu $ds9(mb).prefs.panner
    $ds9(mb).prefs add cascade -label "Magnifier" \
	-menu $ds9(mb).prefs.magnifier
    $ds9(mb).prefs add cascade -label "Truecolor Colorbar" \
	-menu $ds9(mb).prefs.colorbar
    $ds9(mb).prefs add cascade -label "Dialog Box" \
	-menu $ds9(mb).prefs.dialog
    $ds9(mb).prefs add cascade -label "Pan" -menu $ds9(mb).prefs.pan
    $ds9(mb).prefs add cascade -label "Print Coordinates" \
	-menu $ds9(mb).prefs.coord
    $ds9(mb).prefs add cascade -label "Examine" -menu $ds9(mb).prefs.examine
    $ds9(mb).prefs add cascade -label "URL" -menu $ds9(mb).prefs.url
    $ds9(mb).prefs add cascade -label "Misc" -menu $ds9(mb).prefs.misc
    $ds9(mb).prefs add separator
    $ds9(mb).prefs add command -label "Save Preferences" -command SavePrefs
    $ds9(mb).prefs add command -label "Clear Preferences" -command ClearPrefs

    # File Prefs

    menu $ds9(mb).prefs.file -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.file add command -label "Page Setup..." \
	-command PrefsPageDialog

    # Frame Prefs

    menu $ds9(mb).prefs.frame -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.frame add cascade -label "Tile" \
	-menu $ds9(mb).prefs.frame.tile
    $ds9(mb).prefs.frame add cascade -label "Blink Interval" \
	-menu $ds9(mb).prefs.frame.blink
    $ds9(mb).prefs.frame add separator
    $ds9(mb).prefs.frame add checkbutton -label "Auto Size" \
	-variable canvas(auto) -command UpdateView
    $ds9(mb).prefs.frame add separator
    $ds9(mb).prefs.frame add radiobutton -label "256x256" \
	-variable canvas(size) -value 256 -command UpdateView
    $ds9(mb).prefs.frame add radiobutton -label "512x512" \
	-variable canvas(size) -value 512 -command UpdateView
    $ds9(mb).prefs.frame add radiobutton -label "1024x1024" \
	-variable canvas(size) -value 1024 -command UpdateView

    # Frame Tile Prefs

    menu $ds9(mb).prefs.frame.tile -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.frame.tile add radiobutton -label "Grid" \
	-variable prefs(tile,mode) -value grid
    $ds9(mb).prefs.frame.tile add radiobutton -label "Column" \
	-variable prefs(tile,mode) -value column
    $ds9(mb).prefs.frame.tile add radiobutton -label "Row" \
	-variable prefs(tile,mode) -value row

    # Frame Blink Prefs

    menu $ds9(mb).prefs.frame.blink -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.frame.blink add radiobutton -label "1/4 Second" \
	-variable prefs(blink,interval) -value 250
    $ds9(mb).prefs.frame.blink add radiobutton -label "1/2 Second" \
	-variable prefs(blink,interval) -value 500
    $ds9(mb).prefs.frame.blink add radiobutton -label "1 Second" \
	-variable prefs(blink,interval) -value 1000
    $ds9(mb).prefs.frame.blink add radiobutton -label "2 Seconds" \
	-variable prefs(blink,interval) -value 2000
    $ds9(mb).prefs.frame.blink add radiobutton -label "4 Seconds" \
	-variable prefs(blink,interval) -value 4000
    $ds9(mb).prefs.frame.blink add radiobutton -label "8 Seconds" \
	-variable prefs(blink,interval) -value 8000

    # Edit Prefs

    menu $ds9(mb).prefs.edit -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.edit add radiobutton -label "Pointer" \
	-variable prefs(ds9,mode) -value pointer
    $ds9(mb).prefs.edit add radiobutton -label "Crosshair" \
	-variable prefs(ds9,mode) -value crosshair
    $ds9(mb).prefs.edit add radiobutton -label "Colorbar" \
	-variable prefs(ds9,mode) -value colorbar
    $ds9(mb).prefs.edit add radiobutton -label "Pan" \
	-variable prefs(ds9,mode) -value pan
    $ds9(mb).prefs.edit add radiobutton -label "Zoom" \
	-variable prefs(ds9,mode) -value zoom
    $ds9(mb).prefs.edit add radiobutton -label "Rotate" \
	-variable prefs(ds9,mode) -value rotate
    $ds9(mb).prefs.edit add radiobutton -label "Examine" \
	-variable prefs(ds9,mode) -value examine
    $ds9(mb).prefs.edit add separator
    $ds9(mb).prefs.edit add radiobutton -label "Equatorial B1950" \
	-variable prefs(wcs,system) -value fk4
    $ds9(mb).prefs.edit add radiobutton -label "Equatorial J2000" \
	-variable prefs(wcs,system) -value fk5
    $ds9(mb).prefs.edit add radiobutton -label "ICRS" \
	-variable prefs(wcs,system) -value icrs
    $ds9(mb).prefs.edit add radiobutton -label "Galactic" \
	-variable prefs(wcs,system) -value galactic
    $ds9(mb).prefs.edit add radiobutton -label "Ecliptic" \
	-variable prefs(wcs,system) -value ecliptic
    $ds9(mb).prefs.edit add separator
    $ds9(mb).prefs.edit add radiobutton -label "Degrees" \
	-variable prefs(wcs,format) -value degrees
    $ds9(mb).prefs.edit add radiobutton -label "Sexagesimal" \
	-variable prefs(wcs,format) -value sexagesimal

    # Bin Prefs

    menu $ds9(mb).prefs.bin -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.bin add radiobutton -label "Average" \
	-variable prefs(binfunction) -value average
    $ds9(mb).prefs.bin add radiobutton -label "Sum" \
	-variable prefs(binfunction) -value sum
    $ds9(mb).prefs.bin add separator
    $ds9(mb).prefs.bin add radiobutton -label "Block 1" \
	-variable prefs(binfactor) -value 1
    $ds9(mb).prefs.bin add radiobutton -label "Block 2" \
	-variable prefs(binfactor) -value 2
    $ds9(mb).prefs.bin add radiobutton -label "Block 4" \
	-variable prefs(binfactor) -value 4
    $ds9(mb).prefs.bin add radiobutton -label "Block 8" \
	-variable prefs(binfactor) -value 8
    $ds9(mb).prefs.bin add radiobutton -label "Block 16" \
	-variable prefs(binfactor) -value 16
    $ds9(mb).prefs.bin add radiobutton -label "Block 32" \
	-variable prefs(binfactor) -value 32
    $ds9(mb).prefs.bin add radiobutton -label "Block 64" \
	-variable prefs(binfactor) -value 64
    $ds9(mb).prefs.bin add radiobutton -label "Block 128" \
	-variable prefs(binfactor) -value 128
    $ds9(mb).prefs.bin add separator
    $ds9(mb).prefs.bin add radiobutton -label "512x512" \
	-variable prefs(binbuffersize) -value 512
    $ds9(mb).prefs.bin add radiobutton -label "1024x1024" \
	-variable prefs(binbuffersize) -value 1024
    $ds9(mb).prefs.bin add radiobutton -label "2048x2048" \
	-variable prefs(binbuffersize) -value 2048
    $ds9(mb).prefs.bin add radiobutton -label "4096x4096" \
	-variable prefs(binbuffersize) -value 4096

    # Zoom Prefs

    menu $ds9(mb).prefs.zoom -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.zoom add checkbutton -label "Align to Equatorial WCS" \
	-variable prefs(wcsalign)
    $ds9(mb).prefs.zoom add separator
    $ds9(mb).prefs.zoom add radiobutton -label "1/16" \
	-variable prefs(zoom) -value 0.0625
    $ds9(mb).prefs.zoom add radiobutton -label "1/8" \
	-variable prefs(zoom) -value 0.125
    $ds9(mb).prefs.zoom add radiobutton -label "1/4" \
	-variable prefs(zoom) -value 0.25
    $ds9(mb).prefs.zoom add radiobutton -label "1/2" \
	-variable prefs(zoom) -value 0.5
    $ds9(mb).prefs.zoom add radiobutton -label "1" \
	-variable prefs(zoom) -value 1
    $ds9(mb).prefs.zoom add radiobutton -label "2" \
	-variable prefs(zoom) -value 2
    $ds9(mb).prefs.zoom add radiobutton -label "4" \
	-variable prefs(zoom) -value 4
    $ds9(mb).prefs.zoom add radiobutton -label "8" \
	-variable prefs(zoom) -value 8
    $ds9(mb).prefs.zoom add radiobutton -label "16" \
	-variable prefs(zoom) -value 16
    $ds9(mb).prefs.zoom add separator
    $ds9(mb).prefs.zoom add radiobutton  -label "None" \
	-variable prefs(orient) -value none
    $ds9(mb).prefs.zoom add radiobutton  -label "Invert X" \
	-variable prefs(orient) -value x
    $ds9(mb).prefs.zoom add radiobutton -label "Invert Y" \
	-variable prefs(orient) -value y
    $ds9(mb).prefs.zoom add radiobutton -label "Invert X&Y" \
	-variable prefs(orient) -value xy
    $ds9(mb).prefs.zoom add separator
    $ds9(mb).prefs.zoom add radiobutton -label "0 deg" \
	-variable prefs(rotate) -value 0 
    $ds9(mb).prefs.zoom add radiobutton -label "90 deg" \
	-variable prefs(rotate) -value 90
    $ds9(mb).prefs.zoom add radiobutton -label "180 deg" \
	-variable prefs(rotate) -value 180
    $ds9(mb).prefs.zoom add radiobutton -label "270 deg" \
	-variable prefs(rotate) -value 270

    # Scale Prefs

    menu $ds9(mb).prefs.scale -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.scale add radiobutton -label Linear \
	-variable prefs(scale) -value linear
    $ds9(mb).prefs.scale add radiobutton -label Log \
	-variable prefs(scale) -value log
    $ds9(mb).prefs.scale add radiobutton -label Squared \
	-variable prefs(scale) -value squared
    $ds9(mb).prefs.scale add radiobutton -label "Square Root" \
	-variable prefs(scale) -value sqrt
    $ds9(mb).prefs.scale add radiobutton -label "Histogram Equalization" \
	-variable prefs(scale) -value histequ
    $ds9(mb).prefs.scale add separator
    $ds9(mb).prefs.scale add radiobutton -label MinMax \
	-variable prefs(scalemode) -value minmax
    $ds9(mb).prefs.scale add radiobutton -label "99.5%" \
	-variable prefs(scalemode) -value 99.5
    $ds9(mb).prefs.scale add radiobutton -label "99%" \
	-variable prefs(scalemode) -value 99
    $ds9(mb).prefs.scale add radiobutton -label "98%" \
	-variable prefs(scalemode) -value 98
    $ds9(mb).prefs.scale add radiobutton -label "95%" \
	-variable prefs(scalemode) -value 95
    $ds9(mb).prefs.scale add radiobutton -label "90%" \
	-variable prefs(scalemode) -value 90
    $ds9(mb).prefs.scale add radiobutton -label "ZScale" \
	-variable prefs(scalemode) -value zscale
    $ds9(mb).prefs.scale add radiobutton -label "ZMax" \
	-variable prefs(scalemode) -value zmax
    $ds9(mb).prefs.scale add separator
    $ds9(mb).prefs.scale add cascade -label "Scope" \
	-menu $ds9(mb).prefs.scale.scope
    $ds9(mb).prefs.scale add cascade -label "MinMax" \
	-menu $ds9(mb).prefs.scale.minmax
    $ds9(mb).prefs.scale add separator
    $ds9(mb).prefs.scale add checkbutton -label "use DATASEC" \
	-variable prefs(scale,datasec)

    menu $ds9(mb).prefs.scale.scope -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.scale.scope add radiobutton \
	-label "Global" -variable prefs(scalescope) -value global
    $ds9(mb).prefs.scale.scope add radiobutton \
	-label "Local" -variable prefs(scalescope) -value local

    menu $ds9(mb).prefs.scale.minmax -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.scale.minmax add radiobutton \
	-label "Scan Data" -variable prefs(minmaxmode) -value scan
    $ds9(mb).prefs.scale.minmax add radiobutton \
	-label "Sample Data" -variable prefs(minmaxmode) -value sample
    $ds9(mb).prefs.scale.minmax add radiobutton \
	-label "DATAMIN DATAMAX" -variable prefs(minmaxmode) -value datamin
    $ds9(mb).prefs.scale.minmax add radiobutton \
	-label "IRAF-MIN IRAF-MAX" -variable prefs(minmaxmode) -value irafmin
    $ds9(mb).prefs.scale.minmax add separator
    $ds9(mb).prefs.scale.minmax add command -label "Sample Increment..." \
	-command "MinMaxSampleDialog prefs(minmaxsample) 0"

    # Color Prefs

    menu $ds9(mb).prefs.color -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.color add separator
    $ds9(mb).prefs.color add checkbutton -label "Invert Colormap" \
	-variable prefs(colorbarinvert)

    # Region Prefs

    menu $ds9(mb).prefs.region -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.region add cascade -label "Shape" \
	-menu $ds9(mb).prefs.region.shape
    $ds9(mb).prefs.region add separator
    $ds9(mb).prefs.region add command -label "Circle..." \
	-command CircleDefaultDialog
    $ds9(mb).prefs.region add command -label "Ellipse..." \
	-command EllipseDefaultDialog
    $ds9(mb).prefs.region add command -label "Box..." \
	-command BoxDefaultDialog
    $ds9(mb).prefs.region add command -label "Projection..." \
	-command ProjectionDefaultDialog
    $ds9(mb).prefs.region add separator
    $ds9(mb).prefs.region add command -label "Annulus..." \
	-command AnnulusDefaultDialog
    $ds9(mb).prefs.region add command -label "Elliptical Annulus..." \
	-command EllipseAnnulusDefaultDialog
    $ds9(mb).prefs.region add command -label "Box Annulus..." \
	-command BoxAnnulusDefaultDialog
    $ds9(mb).prefs.region add command -label "Panda..." \
	-command PandaDefaultDialog
    $ds9(mb).prefs.region add separator
    $ds9(mb).prefs.region add cascade -label "File Format" \
	-menu $ds9(mb).prefs.region.format
    $ds9(mb).prefs.region add cascade -label "File Coordinate" \
	-menu $ds9(mb).prefs.region.coord

    menu $ds9(mb).prefs.region.shape -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.region.shape add radiobutton \
	-label Circle -variable prefs(shape) -value circle
    $ds9(mb).prefs.region.shape add radiobutton \
	-label Ellipse -variable prefs(shape) -value ellipse
    $ds9(mb).prefs.region.shape add radiobutton \
	-label Box -variable prefs(shape) -value box
    $ds9(mb).prefs.region.shape add radiobutton \
	-label Polygon -variable prefs(shape) -value polygon
    $ds9(mb).prefs.region.shape add radiobutton \
	-label Line -variable prefs(shape) -value line
    $ds9(mb).prefs.region.shape add radiobutton \
	-label Text -variable prefs(shape) -value text
    $ds9(mb).prefs.region.shape add separator
    $ds9(mb).prefs.region.shape add radiobutton \
	-label Ruler -variable prefs(shape) -value ruler
    $ds9(mb).prefs.region.shape add radiobutton \
	-label Projection -variable prefs(shape) -value projection
    $ds9(mb).prefs.region.shape add separator
    $ds9(mb).prefs.region.shape add radiobutton \
	-label Annulus -variable prefs(shape) -value annulus
    $ds9(mb).prefs.region.shape add radiobutton \
	-label "Elliptical Annulus" -variable prefs(shape) \
	-value "ellipse annulus"
    $ds9(mb).prefs.region.shape add radiobutton \
	-label "Box Annulus" -variable prefs(shape) -value "box annulus"
    $ds9(mb).prefs.region.shape add radiobutton \
	-label Panda -variable prefs(shape) -value panda
    $ds9(mb).prefs.region.shape add separator
    $ds9(mb).prefs.region.shape add radiobutton \
	-label "Circle Point" -variable prefs(shape) -value "circle point" 
    $ds9(mb).prefs.region.shape add radiobutton \
	-label "Box Point" -variable prefs(shape) -value "box point"
    $ds9(mb).prefs.region.shape add radiobutton \
	-label "Diamond Point" -variable prefs(shape) -value "diamond point"
    $ds9(mb).prefs.region.shape add radiobutton \
	-label "Cross Point" -variable prefs(shape) -value "cross point"
    $ds9(mb).prefs.region.shape add radiobutton \
	-label "X Point" -variable prefs(shape) -value "x point"
    $ds9(mb).prefs.region.shape add radiobutton \
	-label "Arrow Point" -variable prefs(shape) -value "arrow point" 
    $ds9(mb).prefs.region.shape add radiobutton \
	-label "BoxCircle Point" -variable prefs(shape) \
	-value "boxcircle point"

    menu $ds9(mb).prefs.region.format -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.region.format add radiobutton -label "DS9/Funtools" \
	-variable prefs(marker,format) -value ds9 \
	-command "UpdateMarkerFormatMenu prefs(marker,format) prefs(marker,coord) prefs(marker,coordformat) $ds9(mb).prefs.region"
    $ds9(mb).prefs.region.format add radiobutton -label "Ciao" \
	-variable prefs(marker,format) -value ciao \
	-command "UpdateMarkerFormatMenu prefs(marker,format) prefs(marker,coord) prefs(marker,coordformat) $ds9(mb).prefs.region"
    $ds9(mb).prefs.region.format add radiobutton -label "SAOtng" \
	-variable prefs(marker,format) -value saotng \
	-command "UpdateMarkerFormatMenu prefs(marker,format) prefs(marker,coord) prefs(marker,coordformat) $ds9(mb).prefs.region"
    $ds9(mb).prefs.region.format add radiobutton -label "SAOimage" \
	-variable prefs(marker,format) -value saoimage \
	-command "UpdateMarkerFormatMenu prefs(marker,format) prefs(marker,coord) prefs(marker,coordformat) $ds9(mb).prefs.region"
    $ds9(mb).prefs.region.format add radiobutton -label "IRAF PROS" \
	-variable prefs(marker,format) -value pros \
	-command "UpdateMarkerFormatMenu prefs(marker,format) prefs(marker,coord) prefs(marker,coordformat) $ds9(mb).prefs.region"
    $ds9(mb).prefs.region.format add radiobutton -label "X Y" \
	-variable prefs(marker,format) -value xy \
	-command "UpdateMarkerFormatMenu prefs(marker,format) prefs(marker,coord) prefs(marker,coordformat) $ds9(mb).prefs.region"
    $ds9(mb).prefs.region.format add separator
    $ds9(mb).prefs.region.format add checkbutton -label "Strip Output" \
	-variable prefs(marker,strip)

    menu $ds9(mb).prefs.region.coord -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.region.coord add radiobutton -label "Equatorial B1950" \
	-variable prefs(marker,coord) -value fk4
    $ds9(mb).prefs.region.coord add radiobutton -label "Equatorial J2000" \
	-variable prefs(marker,coord) -value fk5
    $ds9(mb).prefs.region.coord add radiobutton -label "ICRS" \
	-variable prefs(marker,coord) -value icrs
    $ds9(mb).prefs.region.coord add radiobutton -label "Galactic" \
	-variable prefs(marker,coord) -value galactic
    $ds9(mb).prefs.region.coord add radiobutton -label "Ecliptic" \
	-variable prefs(marker,coord) -value ecliptic
    $ds9(mb).prefs.region.coord add separator
    $ds9(mb).prefs.region.coord add radiobutton -label "Linear" \
	-variable prefs(marker,coord) -value linear
    $ds9(mb).prefs.region.coord add separator
    $ds9(mb).prefs.region.coord add radiobutton -label "Detector" \
	-variable prefs(marker,coord) -value detector
    $ds9(mb).prefs.region.coord add radiobutton -label "Amplifier" \
	-variable prefs(marker,coord) -value amplifier
    $ds9(mb).prefs.region.coord add radiobutton -label "Physical" \
	-variable prefs(marker,coord) -value physical
    $ds9(mb).prefs.region.coord add radiobutton -label "Image" \
	-variable prefs(marker,coord) -value image
    $ds9(mb).prefs.region.coord add separator
    $ds9(mb).prefs.region.coord add radiobutton -label "Degrees" \
	-variable prefs(marker,coordformat) -value degrees
    $ds9(mb).prefs.region.coord add radiobutton -label "Sexagesimal" \
	-variable prefs(marker,coordformat) -value sexagesimal

    # Analysis Prefs

    menu $ds9(mb).prefs.analysis -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.analysis add cascade -label "Horizontal Cut Graph" \
	-menu $ds9(mb).prefs.analysis.horz
    $ds9(mb).prefs.analysis add cascade -label "Vertical Cut Graph" \
	-menu $ds9(mb).prefs.analysis.vert
    $ds9(mb).prefs.analysis add separator
    $ds9(mb).prefs.analysis add cascade -label "Contour" \
	-menu $ds9(mb).prefs.analysis.contour
    $ds9(mb).prefs.analysis add separator
    $ds9(mb).prefs.analysis add cascade -label "DSS Server" \
	-menu $ds9(mb).prefs.analysis.dsssvr
    $ds9(mb).prefs.analysis add cascade -label "Name Server" \
	-menu $ds9(mb).prefs.analysis.namesvr
    $ds9(mb).prefs.analysis add separator
    $ds9(mb).prefs.analysis add command -label "Virtual Observatory..." \
	-command VOPref
    $ds9(mb).prefs.analysis add separator
    $ds9(mb).prefs.analysis add checkbutton -label "Analysis Command Log" \
	-variable prefs(analysis,log)
    $ds9(mb).prefs.analysis add separator
    $ds9(mb).prefs.analysis add command -label "Preload Analysis File 1..." \
	-command "AnalysisPref prefs(analysis,user)"
    $ds9(mb).prefs.analysis add command -label "Preload Analysis File 2..." \
	-command "AnalysisPref prefs(analysis,user2)"
    $ds9(mb).prefs.analysis add command -label "Preload Analysis File 3..." \
	-command "AnalysisPref prefs(analysis,user3)"
    $ds9(mb).prefs.analysis add command -label "Preload Analysis File 4..." \
	-command "AnalysisPref prefs(analysis,user4)"
    $ds9(mb).prefs.analysis add separator
    $ds9(mb).prefs.analysis add cascade -label "Analysis Plot" \
	-menu $ds9(mb).prefs.analysis.plot

    # Analysis Horizontal Prefs

    menu $ds9(mb).prefs.analysis.horz -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.analysis.horz add checkbutton -label "Grid" \
	-variable graphHorz(grid) -command UpdateGraphGrid
    $ds9(mb).prefs.analysis.horz add separator
    $ds9(mb).prefs.analysis.horz add radiobutton -label "Linear" \
	-variable graphHorz(log) -value false -command UpdateGraphYAxis
    $ds9(mb).prefs.analysis.horz add radiobutton -label "Log" \
	-variable graphHorz(log) -value true -command UpdateGraphYAxis

    # Analysis Vertical Prefs

    menu $ds9(mb).prefs.analysis.vert -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.analysis.vert add checkbutton -label "Grid" \
	-variable graphVert(grid) -command  UpdateGraphGrid
    $ds9(mb).prefs.analysis.vert add separator
    $ds9(mb).prefs.analysis.vert add radiobutton -label "Linear" \
	-variable graphVert(log) -value false -command UpdateGraphYAxis
    $ds9(mb).prefs.analysis.vert add radiobutton -label "Log" \
	-variable graphVert(log) -value true -command UpdateGraphYAxis

    # Analysis Contour Prefs

    menu $ds9(mb).prefs.analysis.contour -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.analysis.contour add cascade -label "Color" \
	-menu $ds9(mb).prefs.analysis.contour.color
    $ds9(mb).prefs.analysis.contour add cascade -label "Width" \
	-menu $ds9(mb).prefs.analysis.contour.width
    $ds9(mb).prefs.analysis.contour add cascade -label "Method" \
	-menu $ds9(mb).prefs.analysis.contour.method

    # Analysis Contour Color Prefs

    menu $ds9(mb).prefs.analysis.contour.color -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.analysis.contour.color add radiobutton -label "Black" \
	-variable prefs(contour,color) -value black 
    $ds9(mb).prefs.analysis.contour.color add radiobutton -label "White" \
	-variable prefs(contour,color) -value white 
    $ds9(mb).prefs.analysis.contour.color add radiobutton -label "Red" \
	-variable prefs(contour,color) -value red 
    $ds9(mb).prefs.analysis.contour.color add radiobutton -label "Green" \
	-variable prefs(contour,color) -value green 
    $ds9(mb).prefs.analysis.contour.color add radiobutton -label "Blue" \
	-variable prefs(contour,color) -value blue 
    $ds9(mb).prefs.analysis.contour.color add radiobutton -label "Cyan" \
	-variable prefs(contour,color) -value cyan 
    $ds9(mb).prefs.analysis.contour.color add radiobutton -label "Magenta" \
	-variable prefs(contour,color) -value magenta 
    $ds9(mb).prefs.analysis.contour.color add radiobutton -label "Yellow" \
	-variable prefs(contour,color) -value yellow 

    # Analysis Contour Width Prefs

    menu $ds9(mb).prefs.analysis.contour.width -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.analysis.contour.width add radiobutton -label "1" \
	-variable prefs(contour,width) -value 1
    $ds9(mb).prefs.analysis.contour.width add radiobutton -label "2" \
	-variable prefs(contour,width) -value 2
    $ds9(mb).prefs.analysis.contour.width add radiobutton -label "3" \
	-variable prefs(contour,width) -value 3
    $ds9(mb).prefs.analysis.contour.width add radiobutton -label "4" \
	-variable prefs(contour,width) -value 4

    # Analysis Contour Method Prefs

    menu $ds9(mb).prefs.analysis.contour.method -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.analysis.contour.method add radiobutton -label "Faster" \
	-variable prefs(contour,method) -value block
    $ds9(mb).prefs.analysis.contour.method add radiobutton -label "Better" \
	-variable prefs(contour,method) -value smooth

    # Analysis DSS Server Prefs

    menu $ds9(mb).prefs.analysis.dsssvr -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.analysis.dsssvr add radiobutton -label "DSS@SAO" \
	-variable dss(server) -value sao
    $ds9(mb).prefs.analysis.dsssvr add radiobutton -label "DSS@STSCI" \
	-variable dss(server) -value stsci
    $ds9(mb).prefs.analysis.dsssvr add radiobutton -label "DSS@ESO" \
	-variable dss(server) -value eso

    # Analysis Name Server Prefs

    menu $ds9(mb).prefs.analysis.namesvr -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.analysis.namesvr add radiobutton -label "NED@SAO" \
	-variable nsvr(server) -value ned-sao
    $ds9(mb).prefs.analysis.namesvr add radiobutton -label "NED@ESO" \
	-variable nsvr(server) -value ned-eso
    $ds9(mb).prefs.analysis.namesvr add radiobutton -label "SIMBAD@SAO" \
	-variable nsvr(server) -value simbad-sao
    $ds9(mb).prefs.analysis.namesvr add radiobutton -label "SIMBAD@ESO" \
	-variable nsvr(server) -value simbad-eso

    # Analysis Plot Prefs

    APPrefsMenu

    # Help Prefs

    menu $ds9(mb).prefs.help -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.help add command -label "Reference Manual URL..." \
	-command HelpRefPref
#    $ds9(mb).prefs.help add command -label "Users Manual URL..."
#	-command HelpUserPref
    $ds9(mb).prefs.help add separator
    $ds9(mb).prefs.help add radiobutton -label "Netscape" \
	-variable help(app) -value netscape
    $ds9(mb).prefs.help add radiobutton -label "Mozilla" \
	-variable help(app) -value mozilla

    # View Prefs

    menu $ds9(mb).prefs.view -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.view add checkbutton -label "Information Panel" \
	-variable info(view) -command UpdateView
    $ds9(mb).prefs.view add checkbutton -label "Panner" \
	-variable pan(view) -command UpdateView
    $ds9(mb).prefs.view add checkbutton -label "Magnifier" \
	-variable mag(view) -command UpdateView
    $ds9(mb).prefs.view add checkbutton -label "Buttons" \
	-variable buttons(view) -command UpdateView
    $ds9(mb).prefs.view add checkbutton -label "Colorbar" \
	-variable colorbar(view) -command UpdateView

    # View Info Panel Prefs

    menu $ds9(mb).prefs.info -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.info add checkbutton -label "Filename" \
	-variable info(filename) -command UpdateInfoPanel
    $ds9(mb).prefs.info add checkbutton -label "Object" \
	-variable info(object) -command UpdateInfoPanel
    $ds9(mb).prefs.info add checkbutton -label "Min Max" \
	-variable info(minmax) -command UpdateInfoPanel
    $ds9(mb).prefs.info add checkbutton -label "Frame Info" \
	-variable info(frame) -command UpdateInfoPanel
    $ds9(mb).prefs.info add separator
    $ds9(mb).prefs.info add checkbutton -label "WCS" \
	-variable info(wcs) -command UpdateInfoPanel
    $ds9(mb).prefs.info add checkbutton -label "Detector" \
	-variable info(detector) -command UpdateInfoPanel
    $ds9(mb).prefs.info add checkbutton -label "Amplifier" \
	-variable info(amplifier) -command UpdateInfoPanel
    $ds9(mb).prefs.info add checkbutton -label "Physical" \
	-variable info(physical) -command UpdateInfoPanel
    $ds9(mb).prefs.info add checkbutton -label "Image" \
	-variable info(image) -command UpdateInfoPanel

    # Mosaic Prefs

    menu $ds9(mb).prefs.mosaic -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.mosaic add radiobutton -label "Auto Detect" \
	-variable mosaic(type) -value auto
    $ds9(mb).prefs.mosaic add radiobutton -label "Force IRAF" \
	-variable mosaic(type) -value iraf
    $ds9(mb).prefs.mosaic add radiobutton -label "Force WCS" \
	-variable mosaic(type) -value wcs
    $ds9(mb).prefs.mosaic add radiobutton -label "Force HST WFPC2" \
	-variable mosaic(type) -value wfpc2
    $ds9(mb).prefs.mosaic add separator
    $ds9(mb).prefs.mosaic add checkbutton -label "Fast Mosaic Render" \
	-variable mosaic(fast) -command ChangeMosaicFast

    # Dialog Prefs

    menu $ds9(mb).prefs.dialog -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    if {$tcl_platform(platform) != "windows"} {
	$ds9(mb).prefs.dialog add radiobutton -label "Motif" \
		-variable ds9(dialog) -value motif
    }
    $ds9(mb).prefs.dialog add radiobutton -label "Windows" \
	-variable ds9(dialog) -value windows
    $ds9(mb).prefs.dialog add radiobutton -label "Blue Plate Special" \
	-variable ds9(dialog) -value blueplate

    # Panner Prefs

    menu $ds9(mb).prefs.panner -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.panner add checkbutton -label "Orientation Compass" \
	-variable pan(imagecompass) -command ChangeImageCompass
    $ds9(mb).prefs.panner add checkbutton -label "WCS Compass" \
	-variable pan(wcscompass) -command ChangeWCSCompass
    $ds9(mb).prefs.panner add checkbutton -label "WCS Compass Tangent Point" \
	-variable pan(wcstanpoint) -command ChangeWCSTanPoint

    # Magnifier Prefs

    menu $ds9(mb).prefs.magnifier -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.magnifier add checkbutton -label "Graphics" \
	-variable mag(region) -command ChangeMagnifierRegion
    $ds9(mb).prefs.magnifier add checkbutton -label "Cursor" \
	-variable mag(cursor) -command ChangeMagnifierCursor
    $ds9(mb).prefs.magnifier add separator
    $ds9(mb).prefs.magnifier add radiobutton -label "Faster" \
	-variable mag(mode) -value fast -command ChangeMagnifierMode
    $ds9(mb).prefs.magnifier add radiobutton -label "More Accurate" \
	-variable mag(mode) -value accurate -command ChangeMagnifierMode
    $ds9(mb).prefs.magnifier add separator
    $ds9(mb).prefs.magnifier add radiobutton -label "2x" \
	-variable mag(zoom) -value 2 -command MagnifierZoomTo
    $ds9(mb).prefs.magnifier add radiobutton -label "4x" \
	-variable mag(zoom) -value 4 -command MagnifierZoomTo
    $ds9(mb).prefs.magnifier add radiobutton -label "8x" \
	-variable mag(zoom) -value 8 -command MagnifierZoomTo
    $ds9(mb).prefs.magnifier add radiobutton -label "16x" \
	-variable mag(zoom) -value 16 -command MagnifierZoomTo
    $ds9(mb).prefs.magnifier add radiobutton -label "32x" \
	-variable mag(zoom) -value 32 -command MagnifierZoomTo

    # Pan Prefs

    menu $ds9(mb).prefs.pan -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.pan add radiobutton -label "Click to Center" \
	-variable pan(mode) -value click
    $ds9(mb).prefs.pan add radiobutton -label "Drag to Center" \
	-variable pan(mode) -value drag
    $ds9(mb).prefs.pan add radiobutton -label "Pan then Zoom" \
	-variable pan(mode) -value panzoom

    # Colorbar Prefs

    menu $ds9(mb).prefs.colorbar -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.colorbar add radiobutton -label "Update Full Screen" \
	-variable colorbar(area) -value 0 -command ColorbarArea
    $ds9(mb).prefs.colorbar add separator
    $ds9(mb).prefs.colorbar add radiobutton -label "128x128" \
	-variable colorbar(area) -value 128 -command ColorbarArea
    $ds9(mb).prefs.colorbar add radiobutton -label "256x256" \
	-variable colorbar(area) -value 256 -command ColorbarArea
    $ds9(mb).prefs.colorbar add radiobutton -label "512x512" \
	-variable colorbar(area) -value 512 -command ColorbarArea
    $ds9(mb).prefs.colorbar add separator
    $ds9(mb).prefs.colorbar add radiobutton -label "About Center" \
	-variable colorbar(mode) -value center -command ColorbarArea
    $ds9(mb).prefs.colorbar add radiobutton -label "About Mouse Click" \
	-variable colorbar(mode) -value click -command ColorbarArea

    # Display Coords Prefs

    menu $ds9(mb).prefs.coord -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.coord add checkbutton -label "Equatorial B1950" \
	-variable coord(fk4)
    $ds9(mb).prefs.coord add checkbutton -label "Equatorial J2000" \
	-variable coord(fk5)
    $ds9(mb).prefs.coord add checkbutton -label "ICRS" \
	-variable coord(icrs)
    $ds9(mb).prefs.coord add checkbutton -label "Galactic" \
	-variable coord(galactic)
    $ds9(mb).prefs.coord add checkbutton -label "Ecliptic" \
	-variable coord(ecliptic)
    $ds9(mb).prefs.coord add separator
    $ds9(mb).prefs.coord add checkbutton -label "Linear" \
	-variable coord(linear)
    $ds9(mb).prefs.coord add separator
    $ds9(mb).prefs.coord add checkbutton -label "Detector" \
	-variable coord(detector)
    $ds9(mb).prefs.coord add checkbutton -label "Amplifier" \
	-variable coord(amplifier)
    $ds9(mb).prefs.coord add checkbutton -label "Physical" \
	-variable coord(physical)
    $ds9(mb).prefs.coord add checkbutton -label "Image" \
	-variable coord(image)
    $ds9(mb).prefs.coord add separator
    $ds9(mb).prefs.coord add checkbutton -label "Pixel Value" \
	-variable coord(value)
    $ds9(mb).prefs.coord add separator
    $ds9(mb).prefs.coord add radiobutton -label "Degrees" \
	-variable coord(format) -value degrees
    $ds9(mb).prefs.coord add radiobutton -label "Sexagesimal" \
	-variable coord(format) -value sexagesimal

    # Examine Prefs

    menu $ds9(mb).prefs.examine -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.examine add radiobutton -label "New Frame each Time" \
	-variable examine(mode) -value new
    $ds9(mb).prefs.examine add radiobutton -label "Examine Frame" \
	-variable examine(mode) -value one
    $ds9(mb).prefs.examine add separator
    $ds9(mb).prefs.examine add radiobutton -label "1x" \
	-variable examine(zoom) -value 1
    $ds9(mb).prefs.examine add radiobutton -label "2x" \
	-variable examine(zoom) -value 2
    $ds9(mb).prefs.examine add radiobutton -label "4x" \
	-variable examine(zoom) -value 4
    $ds9(mb).prefs.examine add radiobutton -label "8x" \
	-variable examine(zoom) -value 8
    $ds9(mb).prefs.examine add radiobutton -label "16x" \
	-variable examine(zoom) -value 16

    # URL Prefs

    menu $ds9(mb).prefs.url -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.url add checkbutton -label "Show FTP Log" \
	-variable ftp(log)
    $ds9(mb).prefs.url add checkbutton -label "Show HTTP Log" \
	-variable http(log)

    # Misc Prefs
    
    menu $ds9(mb).prefs.misc -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.misc add checkbutton -label "Use Cursors" \
	-variable ds9(cursor)
    $ds9(mb).prefs.misc add checkbutton -label "Autoload FITS Regions" \
	-variable ds9(automarker)

    # Color Menu

    menu $ds9(mb).color -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Colormap"
    $ds9(mb).color add separator
    $ds9(mb).color add checkbutton -label "Invert Colormap" \
	-variable colorbar(invert) -command InvertColorbar -underline 0
    $ds9(mb).color add separator
    $ds9(mb).color add command -label "Contrast/Bias..." \
	-command ColormapDialog
    $ds9(mb).color add separator
    $ds9(mb).color add command -label "Load Colormap..." \
	-command LoadColormap -underline 0
    $ds9(mb).color add command -label "Save Colormap..." \
	-command SaveColormap -underline 0

    # Frame Menu

    menu $ds9(mb).frame -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Frame"
    $ds9(mb).frame add command -label "New Frame" \
	-command CreateFrame -underline 0
    $ds9(mb).frame add command -label "Delete Frame" \
	-command DeleteFrameMenu -underline 0
    $ds9(mb).frame add separator
    $ds9(mb).frame add command -label "Clear Frame" \
	-command ClearCurrentFrame -underline 0
    $ds9(mb).frame add command -label "Reset Frame" \
	-command ResetCurrentFrame -underline 0
    $ds9(mb).frame add command -label "Refresh Frame" \
	-command UpdateCurrentFrame
    $ds9(mb).frame add separator
    $ds9(mb).frame add radiobutton -label "Single Frame" \
	-variable ds9(displaymode) -value single -command DisplayMode
    $ds9(mb).frame add radiobutton -label "Tile Frames" \
	-variable ds9(displaymode) -value tile -command DisplayMode
    $ds9(mb).frame add radiobutton -label "Blink Frames" \
	-variable ds9(displaymode) -value blink -command DisplayMode
    $ds9(mb).frame add separator
    $ds9(mb).frame add cascade -label "Tile" -menu $ds9(mb).frame.tile
    $ds9(mb).frame add cascade -label "Blink Interval" \
	-menu $ds9(mb).frame.blink
    $ds9(mb).frame add separator
    $ds9(mb).frame add cascade -label "Match Frames" -menu $ds9(mb).frame.match
    $ds9(mb).frame add cascade -label "Lock Crosshairs" \
	-menu $ds9(mb).frame.crosshair
    $ds9(mb).frame add separator
    $ds9(mb).frame add command -label "Match Colorbars" \
	-command "MatchColorbars"
#    $ds9(mb).frame add checkbutton -label "Lock Colorbars" 
#        -variable colorbar(lock)
    $ds9(mb).frame add separator
    $ds9(mb).frame add command -label "Data Cube..." -command CubeDialog
    $ds9(mb).frame add separator
    $ds9(mb).frame add cascade -label "Show/Hide Frames" \
	-menu $ds9(mb).frame.active
    $ds9(mb).frame add separator

    menu $ds9(mb).frame.active -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Frame Show/Hide"
    $ds9(mb).frame.active add command -label "Show All" -command ActiveFrameAll
    $ds9(mb).frame.active add command -label "Hide All" \
	-command ActiveFrameNone
    $ds9(mb).frame.active add separator

    menu $ds9(mb).frame.match -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Frame Frame"
    $ds9(mb).frame.match add command -label "WCS" -command MatchFramesWCS
    $ds9(mb).frame.match add command -label "Detector"
    $ds9(mb).frame.match add command -label "Amplifier"
    $ds9(mb).frame.match add command -label "Physical"
    $ds9(mb).frame.match add command -label "Image" -command MatchFramesImage

    menu $ds9(mb).frame.crosshair -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Frame Crosshair"
    $ds9(mb).frame.crosshair add radiobutton -label "None" \
	-variable crosshair(lock) -value none
    $ds9(mb).frame.crosshair add radiobutton -label "WCS" \
	-variable crosshair(lock) -value fk5
    $ds9(mb).frame.crosshair add radiobutton -label "Detector" \
	-variable crosshair(lock) -value detector
    $ds9(mb).frame.crosshair add radiobutton -label "Amplifier" \
	-variable crosshair(lock) -value amplifier
    $ds9(mb).frame.crosshair add radiobutton -label "Physical" \
	-variable crosshair(lock) -value physical
    $ds9(mb).frame.crosshair add radiobutton -label "Image" \
	-variable crosshair(lock) -value image

    menu $ds9(mb).frame.tile -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).frame.tile add radiobutton -label "Grid" \
	-variable tile(mode) -value grid -command DisplayMode
    $ds9(mb).frame.tile add radiobutton -label "Column" \
	-variable tile(mode) -value column -command DisplayMode
    $ds9(mb).frame.tile add radiobutton -label "Row" \
	-variable tile(mode) -value row -command DisplayMode
    $ds9(mb).frame.tile add separator
    $ds9(mb).frame.tile add command -label "Tile Parameters..." \
	-command TileDialog

    menu $ds9(mb).frame.blink -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).frame.blink add radiobutton -label "1/4 Second" \
	-variable blink(interval) -value 250
    $ds9(mb).frame.blink add radiobutton -label "1/2 Second" \
	-variable blink(interval) -value 500
    $ds9(mb).frame.blink add radiobutton -label "1 Second" \
	-variable blink(interval) -value 1000
    $ds9(mb).frame.blink add radiobutton -label "2 Seconds" \
	-variable blink(interval) -value 2000
    $ds9(mb).frame.blink add radiobutton -label "4 Seconds" \
	-variable blink(interval) -value 4000
    $ds9(mb).frame.blink add radiobutton -label "8 Seconds" \
	-variable blink(interval) -value 8000

    # Bin Menu

    menu $ds9(mb).bin -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Bin"
    $ds9(mb).bin add radiobutton -label "Average" \
	-variable bin(function) -value average -command ChangeBinFunction \
	-underline 0
    $ds9(mb).bin add radiobutton -label "Sum" \
	-variable bin(function) -value sum \
	-command ChangeBinFunction -underline 0
    $ds9(mb).bin add separator
    $ds9(mb).bin add command -label "Block In" \
	-command "Bin .5" -underline 6
    $ds9(mb).bin add command -label "Block Out" \
	-command "Bin 2" -underline 6
    $ds9(mb).bin add separator
    $ds9(mb).bin add command -label "Block to Fit Frame" \
	-command "BinToFit"
    $ds9(mb).bin add separator
    $ds9(mb).bin add radiobutton -label "Block 1" \
	-variable bin(factor) -value 1 -command ChangeBinFactor
    $ds9(mb).bin add radiobutton -label "Block 2" \
	-variable bin(factor) -value 2 -command ChangeBinFactor
    $ds9(mb).bin add radiobutton -label "Block 4" \
	-variable bin(factor) -value 4 -command ChangeBinFactor
    $ds9(mb).bin add radiobutton -label "Block 8" \
	-variable bin(factor) -value 8 -command ChangeBinFactor
    $ds9(mb).bin add radiobutton -label "Block 16" \
	-variable bin(factor) -value 16 -command ChangeBinFactor
    $ds9(mb).bin add radiobutton -label "Block 32" \
	-variable bin(factor) -value 32 -command ChangeBinFactor
    $ds9(mb).bin add radiobutton -label "Block 64" \
	-variable bin(factor) -value 64 -command ChangeBinFactor
    $ds9(mb).bin add radiobutton -label "Block 128" \
	-variable bin(factor) -value 128 -command ChangeBinFactor
    $ds9(mb).bin add separator
    $ds9(mb).bin add radiobutton -label "512x512" \
	-variable bin(buffersize) -value 512 -command ChangeBinBufferSize 
    $ds9(mb).bin add radiobutton -label "1024x1024" \
	-variable bin(buffersize) -value 1024 -command ChangeBinBufferSize
    $ds9(mb).bin add radiobutton -label "2048x2048" \
	-variable bin(buffersize) -value 2048 -command ChangeBinBufferSize
    $ds9(mb).bin add radiobutton -label "4096x4096" \
	-variable bin(buffersize) -value 4096 -command ChangeBinBufferSize
    $ds9(mb).bin add separator
    $ds9(mb).bin add command -label "Binning Parameters..." \
	-command BinDialog

    # Zoom Menu

    menu $ds9(mb).zoom -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Zoom"
    $ds9(mb).zoom add checkbutton -label "Align to Equatorial WCS" \
	-variable wcs(align) -command AlignWCSFrame -underline 0
    $ds9(mb).zoom add separator
    $ds9(mb).zoom add command -label "Zoom In" -command "Zoom 2" -underline 5
    $ds9(mb).zoom add command -label "Zoom Out" -command "Zoom .5" -underline 5
    $ds9(mb).zoom add separator
    $ds9(mb).zoom add command -label "Zoom to Fit Frame" -command "ZoomToFit"
    $ds9(mb).zoom add separator
    $ds9(mb).zoom add radiobutton -label "1/16" \
	-variable current(zoom) -value 0.0625 -command ChangeZoom
    $ds9(mb).zoom add radiobutton -label "1/8" \
	-variable current(zoom) -value 0.125 -command ChangeZoom
    $ds9(mb).zoom add radiobutton -label "1/4" \
	-variable current(zoom) -value 0.25 -command ChangeZoom
    $ds9(mb).zoom add radiobutton -label "1/2" \
	-variable current(zoom) -value 0.5 -command ChangeZoom
    $ds9(mb).zoom add radiobutton -label "1" \
	-variable current(zoom) -value 1 -command ChangeZoom
    $ds9(mb).zoom add radiobutton -label "2" \
	-variable current(zoom) -value 2 -command ChangeZoom
    $ds9(mb).zoom add radiobutton -label "4" \
	-variable current(zoom) -value 4 -command ChangeZoom
    $ds9(mb).zoom add radiobutton -label "8" \
	-variable current(zoom) -value 8 -command ChangeZoom
    $ds9(mb).zoom add radiobutton -label "16" \
	-variable current(zoom) -value 16 -command ChangeZoom
    $ds9(mb).zoom add separator
    $ds9(mb).zoom add command -label "Center" \
	-command CenterCurrentFrame -underline 0
    $ds9(mb).zoom add separator
    $ds9(mb).zoom add radiobutton  -label "None" \
	-variable current(orient) -value none \
	-command ChangeOrient -underline 0
    $ds9(mb).zoom add radiobutton  -label "Invert X" \
	-variable current(orient) -value x -command ChangeOrient -underline 7
    $ds9(mb).zoom add radiobutton -label "Invert Y" \
	-variable current(orient) -value y -command ChangeOrient -underline 7
    $ds9(mb).zoom add radiobutton -label "Invert X&Y" \
	-variable current(orient) -value xy -command ChangeOrient
    $ds9(mb).zoom add separator
    $ds9(mb).zoom add radiobutton -label "0 deg" \
	-variable current(rotate) -value 0 -command ChangeRotate
    $ds9(mb).zoom add radiobutton -label "90 deg" \
	-variable current(rotate) -value 90 -command ChangeRotate
    $ds9(mb).zoom add radiobutton -label "180 deg" \
	-variable current(rotate) -value 180 -command ChangeRotate
    $ds9(mb).zoom add radiobutton -label "270 deg" \
	-variable current(rotate) -value 270 -command ChangeRotate
    $ds9(mb).zoom add separator
    $ds9(mb).zoom add command -label "Pan Zoom Rotate To..." \
	-command PanZoomDialog

    # Scale Menu

    menu $ds9(mb).scale -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Scale"
    $ds9(mb).scale add radiobutton -label "Linear" \
	-variable scale(type) -command ChangeScale \
	-value linear -underline 0
    $ds9(mb).scale add radiobutton -label "Log" \
	-variable scale(type) -command ChangeScale \
	-value log -underline 2
    $ds9(mb).scale add radiobutton -label "Squared" \
	-variable scale(type) -command ChangeScale \
	-value squared -underline 1
    $ds9(mb).scale add radiobutton -label "Square Root" \
	-variable scale(type) -command ChangeScale \
	-value sqrt -underline 0
    $ds9(mb).scale add radiobutton -label "Histogram Equalization" \
	-variable scale(type) -command ChangeScale \
	-value histequ -underline 0
    $ds9(mb).scale add separator
    $ds9(mb).scale add radiobutton -label MinMax -variable scale(mode) \
	-command ChangeScaleMode -value minmax
    $ds9(mb).scale add radiobutton -label "99.5%" -variable scale(mode) \
	-command ChangeScaleMode -value 99.5
    $ds9(mb).scale add radiobutton -label "99%" -variable scale(mode) \
	-command ChangeScaleMode -value 99
    $ds9(mb).scale add radiobutton -label "98%" -variable scale(mode) \
	-command ChangeScaleMode -value 98
    $ds9(mb).scale add radiobutton -label "95%" -variable scale(mode) \
	-command ChangeScaleMode -value 95
    $ds9(mb).scale add radiobutton -label "90%" -variable scale(mode) \
	-command ChangeScaleMode -value 90
    $ds9(mb).scale add radiobutton -label "ZScale" -variable scale(mode) \
	-command ChangeScaleMode -value zscale
    $ds9(mb).scale add radiobutton -label "ZMax" -variable scale(mode) \
	-command ChangeScaleMode -value zmax
    $ds9(mb).scale add separator
    $ds9(mb).scale add cascade -label "Scope" -menu $ds9(mb).scale.scope
    $ds9(mb).scale add cascade -label "MinMax" -menu $ds9(mb).scale.minmax
    $ds9(mb).scale add separator
    $ds9(mb).scale add checkbutton -label "use DATASEC" \
	-variable scale(datasec) -command ChangeDATASEC
    $ds9(mb).scale add separator
    $ds9(mb).scale add command -label "Scale Parameters..." \
	-command ScaleDialog

    menu $ds9(mb).scale.scope -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Scale Scope"
    $ds9(mb).scale.scope add radiobutton -label "Global" \
	-variable scale(scope) -command ChangeScaleScope -value global
    $ds9(mb).scale.scope add radiobutton -label "Local" \
	-variable scale(scope) -command ChangeScaleScope -value local

    menu $ds9(mb).scale.minmax -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Scale MinMax"
    $ds9(mb).scale.minmax add radiobutton -label "Scan Data" \
	-variable minmax(mode) -value scan -command ChangeMinMaxMode
    $ds9(mb).scale.minmax add radiobutton -label "Sample Data" \
	-variable minmax(mode) -value sample -command ChangeMinMaxMode
    $ds9(mb).scale.minmax add radiobutton -label "DATAMIN DATAMAX" \
	-variable minmax(mode) -value datamin -command ChangeMinMaxMode
    $ds9(mb).scale.minmax add radiobutton -label "IRAF-MIN IRAF-MAX" \
	-variable minmax(mode) -value irafmin -command ChangeMinMaxMode
    $ds9(mb).scale.minmax add separator
    $ds9(mb).scale.minmax add command -label "Sample Increment..." \
	-command "MinMaxSampleDialog minmax(sample) 1"

    # Region Menu

    menu $ds9(mb).region -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Region"
    $ds9(mb).region add command -label "Get Info..." \
	-command InfoMarker -underline 0
    $ds9(mb).region add separator
    $ds9(mb).region add cascade -label "Shape" \
	-menu $ds9(mb).region.shape -underline 0
    $ds9(mb).region add cascade -label "Color" \
	-menu $ds9(mb).region.color -underline 0
    $ds9(mb).region add cascade -label "Width" \
	-menu $ds9(mb).region.width -underline 0
    $ds9(mb).region add cascade -label "Properties" \
	-menu $ds9(mb).region.properties -underline 0
    $ds9(mb).region add cascade -label "Font" \
	-menu $ds9(mb).region.font -underline 3
    $ds9(mb).region add separator
    $ds9(mb).region add command -label "Move to Front" \
	-command FrontMarker -underline 8
    $ds9(mb).region add command -label "Move to Back" \
	-command BackMarker -underline 8
    $ds9(mb).region add separator
    $ds9(mb).region add command -label "Select All" \
	-command SelectAllMarker -underline 7
    $ds9(mb).region add command -label "Select None" \
	-command UnselectAllMarker -underline 7
    $ds9(mb).region add separator
    $ds9(mb).region add command -label "Delete All" \
	-command DeleteAllMarker -underline 0
    $ds9(mb).region add separator
    $ds9(mb).region add command -label "Load Regions..." \
	-command OpenMarkerFile -underline 0
    $ds9(mb).region add command -label "Save Regions..." -command SaveMarker
    $ds9(mb).region add separator
    $ds9(mb).region add command -label "List Regions" \
	-command DisplayMarkerList
    $ds9(mb).region add separator
    $ds9(mb).region add cascade -label "File Format" \
	-menu $ds9(mb).region.format
    $ds9(mb).region add cascade -label "File Coordinate System" \
	-menu $ds9(mb).region.coord

    menu $ds9(mb).region.shape -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Region Shape"
    $ds9(mb).region.shape add radiobutton \
	-label Circle -variable marker(shape) -value circle  -underline 0
    $ds9(mb).region.shape add radiobutton \
	-label Ellipse -variable marker(shape) -value ellipse -underline 0
    $ds9(mb).region.shape add radiobutton \
	-label Box -variable marker(shape) -value box -underline 0
    $ds9(mb).region.shape add radiobutton \
	-label Polygon -variable marker(shape) -value polygon -underline 0
    $ds9(mb).region.shape add radiobutton \
	-label Line -variable marker(shape) -value line -underline 0
    $ds9(mb).region.shape add radiobutton \
	-label Text -variable marker(shape) -value text -underline 0
    $ds9(mb).region.shape add separator
    $ds9(mb).region.shape add radiobutton \
	-label Ruler -variable marker(shape) -value ruler -underline 1
    $ds9(mb).region.shape add radiobutton \
	-label Projection -variable marker(shape) -value projection
    $ds9(mb).region.shape add separator
    $ds9(mb).region.shape add radiobutton \
	-label Annulus -variable marker(shape) -value annulus
    $ds9(mb).region.shape add radiobutton \
	-label "Elliptical Annulus" -variable marker(shape) \
	-value "ellipse annulus"
    $ds9(mb).region.shape add radiobutton \
	-label "Box Annulus" -variable marker(shape) -value "box annulus"
    $ds9(mb).region.shape add radiobutton \
	-label Panda -variable marker(shape) -value panda
    $ds9(mb).region.shape add separator
    $ds9(mb).region.shape add radiobutton \
	-label "Circle Point" -variable marker(shape) -value "circle point" 
    $ds9(mb).region.shape add radiobutton \
	-label "Box Point" -variable marker(shape) -value "box point"
    $ds9(mb).region.shape add radiobutton \
	-label "Diamond Point" -variable marker(shape) -value "diamond point"
    $ds9(mb).region.shape add radiobutton \
	-label "Cross Point" -variable marker(shape) -value "cross point"
    $ds9(mb).region.shape add radiobutton \
	-label "X Point" -variable marker(shape) -value "x point"
    $ds9(mb).region.shape add radiobutton \
	-label "Arrow Point" -variable marker(shape) -value "arrow point" 
    $ds9(mb).region.shape add radiobutton \
	-label "BoxCircle Point" -variable marker(shape) \
	-value "boxcircle point"

    menu $ds9(mb).region.color -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Region Color"
    $ds9(mb).region.color add radiobutton -label "Black" \
	-variable marker(color) -value black \
	-command ChangeMarkerColor -underline 4
    $ds9(mb).region.color add radiobutton -label "White" \
	-variable marker(color) -value white \
	-command ChangeMarkerColor -underline 0
    $ds9(mb).region.color add radiobutton -label "Red" \
	-variable marker(color) -value red \
	-command ChangeMarkerColor -underline 0
    $ds9(mb).region.color add radiobutton -label "Green" \
	-variable marker(color) -value green \
	-command ChangeMarkerColor -underline 0
    $ds9(mb).region.color add radiobutton -label "Blue" \
	-variable marker(color) -value blue \
	-command ChangeMarkerColor -underline 0
    $ds9(mb).region.color add radiobutton -label "Cyan" \
	-variable marker(color) -value cyan \
	-command ChangeMarkerColor -underline 0
    $ds9(mb).region.color add radiobutton -label "Magenta" \
	-variable marker(color) -value magenta \
	-command ChangeMarkerColor -underline 0
    $ds9(mb).region.color add radiobutton -label "Yellow" \
	-variable marker(color) -value yellow \
	-command ChangeMarkerColor -underline 0

    menu $ds9(mb).region.width -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Region Width"
    $ds9(mb).region.width add radiobutton -label "1" \
	-variable marker(width) -value 1 -command ChangeMarkerWidth
    $ds9(mb).region.width add radiobutton -label "2" \
	-variable marker(width) -value 2 -command ChangeMarkerWidth
    $ds9(mb).region.width add radiobutton -label "3" \
	-variable marker(width) -value 3 -command ChangeMarkerWidth
    $ds9(mb).region.width add radiobutton -label "4" \
	-variable marker(width) -value 4 -command ChangeMarkerWidth

    menu $ds9(mb).region.properties -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Region Properties"
    $ds9(mb).region.properties add checkbutton -label "Can Edit" \
	-variable marker(edit) -command "ChangeMarkerProp edit" -underline 4
    $ds9(mb).region.properties add checkbutton -label "Can Move" \
	-variable marker(move) -command "ChangeMarkerProp move" -underline 4
    $ds9(mb).region.properties add checkbutton -label "Can Rotate" \
	-variable marker(rotate) -command "ChangeMarkerProp rotate" \
	-underline 4
    $ds9(mb).region.properties add checkbutton -label "Can Delete" \
	-variable marker(delete) -command "ChangeMarkerProp delete" \
	-underline 4
    $ds9(mb).region.properties add checkbutton -label "Fixed in Size" \
	-variable marker(fixed) -command "ChangeMarkerProp fixed" \
	-underline 0

    $ds9(mb).region.properties add separator
    $ds9(mb).region.properties add radiobutton -label Include \
	-variable marker(include) -value 1 -command "ChangeMarkerProp include"
    $ds9(mb).region.properties add radiobutton -label Exclude \
	-variable marker(include) -value 0 -command "ChangeMarkerProp include"
    $ds9(mb).region.properties add separator
    $ds9(mb).region.properties add radiobutton -label Source \
	-variable marker(source) -value 1 -command "ChangeMarkerProp source"
    $ds9(mb).region.properties add radiobutton -label Background \
	-variable marker(source) -value 0 -command "ChangeMarkerProp source"

    menu $ds9(mb).region.font -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Region Font"
    $ds9(mb).region.font add radiobutton -label "Times" \
	-variable marker(font) -value times -command ChangeMarkerFont \
	-underline 0
    $ds9(mb).region.font add radiobutton -label "Helvetica" \
	-variable marker(font) -value helvetica -command ChangeMarkerFont \
	-underline 0
    $ds9(mb).region.font add radiobutton -label "Symbol" \
	-variable marker(font) -value symbol -command ChangeMarkerFont \
	-underline 0
    $ds9(mb).region.font add radiobutton -label "Courier" \
	-variable marker(font) -value courier -command ChangeMarkerFont \
	-underline 0
    $ds9(mb).region.font add separator
    $ds9(mb).region.font add radiobutton -label "9" \
	-variable marker(fontSize) -value 9 -command ChangeMarkerFont
    $ds9(mb).region.font add radiobutton -label "10" \
	-variable marker(fontSize) -value 10 -command ChangeMarkerFont
    $ds9(mb).region.font add radiobutton -label "12" \
	-variable marker(fontSize) -value 12 -command ChangeMarkerFont
    $ds9(mb).region.font add radiobutton -label "14" \
	-variable marker(fontSize) -value 14 -command ChangeMarkerFont
    $ds9(mb).region.font add radiobutton -label "18" \
	-variable marker(fontSize) -value 18 -command ChangeMarkerFont
    $ds9(mb).region.font add radiobutton -label "24" \
	-variable marker(fontSize) -value 24 -command ChangeMarkerFont
    $ds9(mb).region.font add radiobutton -label "30" \
	-variable marker(fontSize) -value 30 -command ChangeMarkerFont
    $ds9(mb).region.font add radiobutton -label "36" \
	-variable marker(fontSize) -value 36 -command ChangeMarkerFont
    $ds9(mb).region.font add separator
    $ds9(mb).region.font add radiobutton -label "Plain" \
	-variable marker(fontStyle) -value normal -command ChangeMarkerFont \
	-underline 0
    $ds9(mb).region.font add radiobutton -label "Bold" \
	-variable marker(fontStyle) -value bold -command ChangeMarkerFont \
	-underline 0
    $ds9(mb).region.font add radiobutton -label "Italic" \
	-variable marker(fontStyle) -value italic -command ChangeMarkerFont \
	-underline 0

    menu $ds9(mb).region.format -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Region Format"
    $ds9(mb).region.format add radiobutton -label "DS9/Funtools" \
	-variable marker(format) -value ds9 \
	-command "UpdateMarkerFormatMenu marker(format) marker(coord) marker(coordformat) $ds9(mb).region"
    $ds9(mb).region.format add radiobutton -label "Ciao" \
	-variable marker(format) -value ciao \
	-command "UpdateMarkerFormatMenu marker(format) marker(coord) marker(coordformat) $ds9(mb).region"
    $ds9(mb).region.format add radiobutton -label "SAOtng" \
	-variable marker(format) -value saotng \
	-command "UpdateMarkerFormatMenu marker(format) marker(coord) marker(coordformat) $ds9(mb).region"
    $ds9(mb).region.format add radiobutton -label "SAOimage" \
	-variable marker(format) -value saoimage \
	-command "UpdateMarkerFormatMenu marker(format) marker(coord) marker(coordformat) $ds9(mb).region"
    $ds9(mb).region.format add radiobutton -label "IRAF PROS" \
	-variable marker(format) -value pros \
	-command "UpdateMarkerFormatMenu marker(format) marker(coord) marker(coordformat) $ds9(mb).region"
    $ds9(mb).region.format add radiobutton -label "X Y" \
	-variable marker(format) -value xy \
	-command "UpdateMarkerFormatMenu marker(format) marker(coord) marker(coordformat) $ds9(mb).region"
    $ds9(mb).region.format add separator
    $ds9(mb).region.format add checkbutton -label "Strip Output" \
	-variable marker(strip)

    menu $ds9(mb).region.coord -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Region Coordinate"
    $ds9(mb).region.coord add radiobutton -label "Equatorial B1950" \
	-variable marker(coord) -value fk4
    $ds9(mb).region.coord add radiobutton -label "Equatorial J2000" \
	-variable marker(coord) -value fk5
    $ds9(mb).region.coord add radiobutton -label "ICRS" \
	-variable marker(coord) -value icrs
    $ds9(mb).region.coord add radiobutton -label "Galactic" \
	-variable marker(coord) -value galactic
    $ds9(mb).region.coord add radiobutton -label "Ecliptic" \
	-variable marker(coord) -value ecliptic
    $ds9(mb).region.coord add separator
    $ds9(mb).region.coord add radiobutton -label "Linear" \
	-variable marker(coord) -value linear
    $ds9(mb).region.coord add separator
    $ds9(mb).region.coord add radiobutton -label "Detector" \
	-variable marker(coord) -value detector
    $ds9(mb).region.coord add radiobutton -label "Amplifier" \
	-variable marker(coord) -value amplifier
    $ds9(mb).region.coord add radiobutton -label "Physical" \
	-variable marker(coord) -value physical
    $ds9(mb).region.coord add radiobutton -label "Image" \
	-variable marker(coord) -value image
    $ds9(mb).region.coord add separator
    $ds9(mb).region.coord add radiobutton -label "Degrees" \
	-variable marker(coordformat) -value degrees
    $ds9(mb).region.coord add radiobutton -label "Sexagesimal" \
	-variable marker(coordformat) -value sexagesimal

    # Analysis Menu

    menu $ds9(mb).analysis -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Analysis"
    $ds9(mb).analysis add checkbutton -label "Horizontal Cut Graph" \
	-variable graphHorz(view) -command UpdateView
    $ds9(mb).analysis add checkbutton -label "Vertical Cut Graph" \
	-variable graphVert(view) -command UpdateView
    $ds9(mb).analysis add separator
    $ds9(mb).analysis add command -label "Pixel Table..." \
	-command PixelTableDisplay
    $ds9(mb).analysis add separator
    $ds9(mb).analysis add checkbutton -label "Display Contours" \
	-variable contour(view) -command ContourUpdate
    $ds9(mb).analysis add command -label "Contours Parameters..." \
	-command ContourDialog
    $ds9(mb).analysis add separator
    $ds9(mb).analysis add checkbutton -label "Display Coordinate Grid" \
	-variable grid(view) -command GridUpdate
    $ds9(mb).analysis add command -label "Coordinate Grid Parameters..." \
	-command GridDialog
    $ds9(mb).analysis add separator
    $ds9(mb).analysis add command -label "Name Resolution..." \
	-command NSVRDialog
    $ds9(mb).analysis add command -label "DSS Server..." -command DSSDialog
    $ds9(mb).analysis add separator
    $ds9(mb).analysis add command -label "Virtual Observatory..." \
	-command VODialog
    $ds9(mb).analysis add command -label "Plot Tool..." \
	-command AnalysisPlotTool
    $ds9(mb).analysis add separator
    $ds9(mb).analysis add checkbutton -label "Analysis Command Log" \
	-variable analysis(log)
    $ds9(mb).analysis add separator
    $ds9(mb).analysis add command -label "Load Analysis Commands..." \
	-command LoadAnalysisDialog
    $ds9(mb).analysis add command -label "Clear Analysis Commands" \
	-command ClearAnalysisDialog

    # Help Menu

    menu $ds9(mb).help -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Help"
    $ds9(mb).help add command -label "Reference Manual" -command HelpRef
#    $ds9(mb).help add command -label "User's Manual" -command HelpUser
    $ds9(mb).help add separator
    $ds9(mb).help add command -label "Command Line Options" \
	-command HelpCommands
    $ds9(mb).help add command -label "Keyboard ShortCuts" \
	-command HelpShortCuts
    $ds9(mb).help add separator
    $ds9(mb).help add command -label "Help Desk" -command HelpDesk
}

proc UpdateDS9 {} {
    global debug
    if {$debug(tcl,update)} {
	puts "UpdateDS9 begin..."
    }

    UpdateFitsMenu
    UpdateEditMenu
    UpdateFrameMenu
    UpdateCubeDialog
    UpdateBinMenu
    UpdateBinDialog
    UpdatePanZoomMenu
    UpdatePanZoomDialog
    UpdateScaleMenu
    UpdateScaleDialog
    UpdateColormapDialog
    UpdateMarkerMenu
    UpdateWCSMenu
    UpdateAnalysisMenu

    UpdateContourMenu
    UpdateContourDialog
    UpdateGridMenu
    UpdateGridDialog
    UpdateDSSDialog

    UpdateGraphYAxis
    UpdateGraphXAxis

    if {$debug(tcl,update)} {
	puts "UpdateDS9 end...\n"
    }
}

# full wcs menu

proc UpdateCoordMenu {which defnoframe defnofits hasFormat} {
    global current

    # no frame

    if {$current(frame) == ""} {
	if {$defnoframe} {
	    SetCoordMenu $which normal $hasFormat
	} else {
	    SetCoordMenu $which disabled $hasFormat
	}
	return
    }

    # unloaded frame

    if {![$current(frame) has fits]} {
	if {$defnofits} {
	    SetCoordMenu $which normal $hasFormat
	} else {
	    SetCoordMenu $which disabled $hasFormat
	}
	return
    }

    # loaded frame

    if {[$current(frame) has wcs equatorial]} {
	$which entryconfig "Equatorial B1950" -state normal
	$which entryconfig "Equatorial J2000" -state normal
	$which entryconfig "ICRS" -state normal
	$which entryconfig "Galactic" -state normal
	$which entryconfig "Ecliptic" -state normal

	if {$hasFormat} {
	    $which entryconfig "Degrees" -state normal
	    $which entryconfig "Sexagesimal" -state normal
	}
    } else {
	$which entryconfig "Equatorial B1950" -state disabled
	$which entryconfig "Equatorial J2000" -state disabled
	$which entryconfig "ICRS" -state disabled
	$which entryconfig "Galactic" -state disabled
	$which entryconfig "Ecliptic" -state disabled

	if {$hasFormat} {
	    $which entryconfig "Degrees" -state disabled
	    $which entryconfig "Sexagesimal" -state disabled
	}
    }

    if {[$current(frame) has wcs linear]} {
	$which entryconfig "Linear" -state normal
    } else {
	$which entryconfig "Linear" -state disabled
    }

    if {[$current(frame) has detector]} {
	$which entryconfig "Detector" -state normal
    } else {
	$which entryconfig "Detector" -state disabled
    }

    if {[$current(frame) has amplifier]} {
	$which entryconfig "Amplifier" -state normal
    } else {
	$which entryconfig "Amplifier" -state disabled
    }

    $which entryconfig "Physical" -state normal
    $which entryconfig "Image" -state normal
}

proc SetCoordMenu {which value hasFormat} {
    $which entryconfig "Equatorial B1950" -state $value
    $which entryconfig "Equatorial J2000" -state $value
    $which entryconfig "ICRS" -state $value
    $which entryconfig "Galactic" -state $value
    $which entryconfig "Ecliptic" -state $value
    $which entryconfig "Linear" -state $value
    $which entryconfig "Detector" -state $value
    $which entryconfig "Amplifier" -state $value
    $which entryconfig "Physical" -state $value
    $which entryconfig "Image" -state $value

    if {$hasFormat} {
	$which entryconfig "Degrees" -state $value
	$which entryconfig "Sexagesimal" -state $value
    }
}

# abrev wcs menu

proc UpdateCoordMenu2 {which defnoframe defnofits} {
    global current

    # no frame

    if {$current(frame) == ""} {
	if {$defnoframe} {
	    SetCoordMenu2 $which normal
	} else {
	    SetCoordMenu2 $which disabled
	}
	return
    }

    # unloaded frame

    if {![$current(frame) has fits]} {
	if {$defnofits} {
	    SetCoordMenu2 $which normal
	} else {
	    SetCoordMenu2 $which disabled
	}
	return
    }

    # loaded frame

    if {[$current(frame) has wcs]} {
	$which entryconfig "WCS" -state normal
    } else {
	$which entryconfig "WCS" -state disabled
    }

    if {[$current(frame) has detector]} {
	$which entryconfig "Detector" -state normal
    } else {
	$which entryconfig "Detector" -state disabled
    }

    if {[$current(frame) has amplifier]} {
	$which entryconfig "Amplifier" -state normal
    } else {
	$which entryconfig "Amplifier" -state disabled
    }

    $which entryconfig "Physical" -state normal
    $which entryconfig "Image" -state normal
}

proc SetCoordMenu2 {which value} {
    $which entryconfig "WCS" -state $value
    $which entryconfig "Detector" -state $value
    $which entryconfig "Amplifier" -state $value
    $which entryconfig "Physical" -state $value
    $which entryconfig "Image" -state $value
}

proc AdjustCoordSystem {varvar} {
    upvar $varvar var
    global current

    if {$current(frame) != ""} {
	if {[$current(frame) has fits]} {
	    if {![$current(frame) has wcs equatorial]} {
		switch $var {
		    "fk4" -
		    "fk5" -
		    "icrs" -
		    "galactic" -
		    "ecliptic" {set var "image"}
		}
	    }

	    if {![$current(frame) has wcs linear]} {
		if {$var == "linear"} {
		    set var "image"
		}
	    }

	    if {!([$current(frame) has detector])} {
		if {$var == "detector"} {
		    set var image
		}
	    }

	    if {![$current(frame) has amplifier]} {
		if {$var == "amplifier"} {
		    set var image
		}
	    }

	    if {![$current(frame) has physical]} {
		if {$var == "physical"} {
		    set var image
		}
	    }
	}
    }
}

proc DebugMenu {} {
    global ds9
    global menu
    global debug

    if {[winfo exist $ds9(mb).debug]} {
	return
    }

    $ds9(mb) add cascade -label "Debug" -menu $ds9(mb).debug

    menu $ds9(mb).debug -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "Debug"
    $ds9(mb).debug add cascade -label "Tcl" -menu $ds9(mb).debug.tcl
    $ds9(mb).debug add cascade -label "SAOTk" -menu $ds9(mb).debug.saotk
    $ds9(mb).debug add cascade -label "IIS" -menu $ds9(mb).debug.iis

    menu $ds9(mb).debug.tcl -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "Debug Tcl"
    $ds9(mb).debug.tcl add checkbutton -label "Events" \
	-variable debug(tcl,events)
    $ds9(mb).debug.tcl add checkbutton -label "Update" \
	-variable debug(tcl,update)
    $ds9(mb).debug.tcl add checkbutton -label "Layout" \
	-variable debug(tcl,layout)
    $ds9(mb).debug.tcl add checkbutton -label "Info" \
	-variable debug(tcl,info)
    $ds9(mb).debug.tcl add checkbutton -label "Watch" \
	-variable debug(tcl,watch)

    menu $ds9(mb).debug.saotk -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "Debug SAOTk"
    $ds9(mb).debug.saotk add checkbutton -label "AST" \
	-variable debug(saotk,ast) \
	-command "Debug ast debug(saotk,ast)"
    $ds9(mb).debug.saotk add checkbutton -label "Mosaic" \
	-variable debug(saotk,mosaic) \
	-command "Debug mosaic debug(saotk,mosaic)"
    $ds9(mb).debug.saotk add checkbutton -label "Parser" \
	-variable debug(saotk,parser) \
	-command "Debug parser debug(saotk,parser)"    
    $ds9(mb).debug.saotk add checkbutton -label "Perf" \
	-variable debug(saotk,perf) \
	-command "Debug perf debug(saotk,perf)"    
    $ds9(mb).debug.saotk add checkbutton -label "WCS" \
	-variable debug(saotk,wcs) \
	-command "Debug wcs debug(saotk,wcs)"    
    $ds9(mb).debug.saotk add checkbutton -label "GZ" \
	-variable debug(saotk,gz) \
	-command "Debug gz debug(saotk,gz)"    

    menu $ds9(mb).debug.iis -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "Debug IIS"
    $ds9(mb).debug.iis add checkbutton -label "IIS" \
	-variable debug(iis) -command IISDebug
}
