package provide DS9 1.0

proc InitPanner {} {
    global pan

    # other bindings
    BindEventsPanner

    # freeze
    bind $pan(name) <f> {ToggleFreeze}
}

proc FreezePanner {} {
    UnBindEventsPanner
}

proc UnFreezePanner {} {
    BindEventsPanner
}

proc BindEventsPanner {} {
    global pan

    bind $pan(name) <Enter> [list EnterPanner]
    bind $pan(name) <Leave> [list LeavePanner]
    bind $pan(name) <Motion> [list TrackPanner %x %y]
    bind $pan(name) <Button-1> [list Button1Panner %x %y]
    bind $pan(name) <B1-Motion> [list Motion1Panner %x %y]
    bind $pan(name) <ButtonRelease-1> [list Release1Panner %x %y]

    bind $pan(name) <ButtonRelease-2> [list Release2Panner %x %y]

    bind $pan(name) <Up> [list ArrowKeyPanner 0 -1]
    bind $pan(name) <Down> [list ArrowKeyPanner 0 1]
    bind $pan(name) <Left> [list ArrowKeyPanner -1 0]
    bind $pan(name) <Right> [list ArrowKeyPanner 1 0]
}

proc UnBindEventsPanner {} {
    global pan

    bind $pan(name) <Enter> {}
    bind $pan(name) <Leave> {}
    bind $pan(name) <Motion> {}
    bind $pan(name) <Button-1> {}
    bind $pan(name) <B1-Motion> {}
    bind $pan(name) <ButtonRelease-1> {}

    bind $pan(name) <ButtonRelease-2> {}

    bind $pan(name) <Up> {}
    bind $pan(name) <Down> {}
    bind $pan(name) <Left> {}
    bind $pan(name) <Right> {}
}

proc EnterPanner {} {
    global pan

    focus $pan(name)
    $pan(name) focus panner
}

proc LeavePanner {} {
    global pan

    panner highlite off
    ClearInfoBox
    ClearPixelTable
    $pan(name) focus {}
    focus {}
}

proc TrackPanner {x y} {
    global ds9
    global current
    global pixel

    panner highlite $x $y
    if {$current(frame) != ""} {
	UpdateInfoBox $current(frame) $x $y panner
	UpdatePixelTable $current(frame) $x $y panner
    }
}

proc Button1Panner {x y} {
    global ds9

    panner pan begin $x $y
}

proc Motion1Panner {x y} {
    global ds9

    panner pan motion $x $y
}

proc Release1Panner {x y} {
    global ds9
    global current

    if {$current(frame) != ""} {
	SetWatchCursor
	panner pan end $x $y
	$current(frame) pan bbox [panner get bbox]
	UpdateGraphXAxis
	UpdatePanZoomDialog
	UnsetWatchCursor
    }
}

proc Release2Panner {x y} {
    global ds9
    global current

    if {$current(frame) != ""} {
	SetWatchCursor
	panner pan to $x $y
	$current(frame) pan bbox [panner get bbox]
	UpdateGraphXAxis
	UpdatePanZoomDialog
	UnsetWatchCursor
    }
}

proc ArrowKeyPanner {x y} {
    panner warp $x $y
}

proc ChangeImageCompass {} {
    global pan
    
    panner image compass $pan(imagecompass)
}

proc ChangeWCSCompass {} {
    global pan

    panner wcs compass $pan(wcscompass)
}

proc ChangeWCSTanPoint {} {
    global pan

    panner wcs compass tangent point $pan(wcstanpoint)
}
