#! /bin/sh

echo "Analysis Tests"
echo

echo "Starting DS9..."
if [ `xpaaccess ds9` = no ]
then
    ../ds9&
fi

i=1
while [ "$i" -le 15 ]
do
    sleep 4
    if [ `xpaaccess ds9` = yes ]
    then
	break
    fi

    i=`expr $i + 1`
done

xpaset -p ds9 file img16.fits
xpaset -p ds9 regions file analysis.reg
xpaset -p ds9 analysis load analysis.ans

# Main

echo "Test Help"
xpaset -p ds9 analysis 1

# Basics

echo "Test Basic Help"
xpaset -p ds9 analysis 2
echo "Test \$xpa"
xpaset -p ds9 analysis 3
echo "Test \$filename"
xpaset -p ds9 analysis 4
echo "Test \$filename(root)"
xpaset -p ds9 analysis 5
echo "Test \$xdim $ydim $bitpix"
xpaset -p ds9 analysis 6

# Regions

echo "Test Regions Help"
xpaset -p ds9 analysis 7
echo "Test \$regions"
xpaset -p ds9 analysis 8
echo "Test \$include_regions_pixels"
xpaset -p ds9 analysis 9
echo "Test \$filename $regions"
xpaset -p ds9 analysis 10
echo "Test \$regions()"
xpaset -p ds9 analysis 11

# Output

echo "Test Output Help"
xpaset -p ds9 analysis 12
echo "Test \$text"
xpaset -p ds9 analysis 13
echo "Test \$plot"
xpaset -p ds9 analysis 14
echo "Test \$plot(title,x,y,3)"
xpaset -p ds9 analysis 15
echo "Test \$plot(title,x,y,4)"
xpaset -p ds9 analysis 16
echo "Test \$plot(title,x,y,5)"
xpaset -p ds9 analysis 17
echo "Test \$plot(stdin)"
xpaset -p ds9 analysis 18
echo "Test \$plot(stdin) text"
xpaset -p ds9 analysis 19
echo "Test \$plot(stdin) error"
xpaset -p ds9 analysis 20
echo "Test \$data"
xpaset -p ds9 analysis 21
echo "Test \$image"
xpaset -p ds9 analysis 22

# Dialogs

echo "Test Dialog Help"
xpaset -p ds9 analysis 23
echo "Test \$message(message)"
xpaset -p ds9 analysis 24
echo "Test \$message(ok,message)"
xpaset -p ds9 analysis 25
echo "Test \$entry(message)"
xpaset -p ds9 analysis 26

# Params

echo "Test Param Help"
xpaset -p ds9 analysis 27
echo "Test \$param"
xpaset -p ds9 analysis 28
echo "Test \$param @file"
xpaset -p ds9 analysis 29

# Other

xpaset -p ds9 analysis message {press 'x' and 'y' to test interactive}

#xpaset -p ds9 quit
echo "Done"
