#! /bin/sh

echo "Fits Tests"

echo "Starting DS9..."
if [ `xpaaccess ds9` = no ]; then
    ../ds9&

    i=1
    while [ "$i" -le 15 ]
	do
	sleep 4
	if [ `xpaaccess ds9` = yes ]; then
	    break
	fi

	i=`expr $i + 1`
    done
fi

# default
xpaset -p ds9 scale zscale

if [ "$1" = "8" -o  -z "$1" ]; then
echo "Testing Bitpix = 8"
xpaset -p ds9 file fits img8.fits
sleep 1
xpaset -p ds9 frame clear
echo "PASSED"
fi

if [ "$1" = "16" -o  -z "$1" ]; then
echo "Testing Bitpix = 16"
xpaset -p ds9 file fits img16.fits
sleep 1
xpaset -p ds9 frame clear
echo "PASSED"
fi

if [ "$1" = "32" -o  -z "$1" ]; then
echo "Testing Bitpix = 32"
xpaset -p ds9 file fits img32.fits
sleep 1
xpaset -p ds9 frame clear
echo "PASSED"
fi

if [ "$1" = "-32" -o  -z "$1" ]; then
echo "Testing Bitpix = -32"
xpaset -p ds9 file fits img-32.fits
sleep 1
xpaset -p ds9 frame clear
echo "PASSED"
fi

if [ "$1" = "-64" -o  -z "$1" ]; then
echo "Testing Bitpix = -64"
xpaset -p ds9 file fits img-64.fits
sleep 1
xpaset -p ds9 frame clear
echo "PASSED"
fi

if [ "$1" = "bscale" -o  -z "$1" ]; then
echo "Testing BSCALE"
xpaset -p ds9 file fits imgbscale.fits
sleep 1
xpaset -p ds9 frame clear
echo "PASSED"
fi

if [ "$1" = "blank" -o  -z "$1" ]; then
echo "Testing BLANK"
xpaset -p ds9 file fits imgblank.fits
sleep 1
xpaset -p ds9 frame clear
echo "PASSED"
fi

if [ "$1" = "nan" -o  -z "$1" ]; then
echo "Testing NaN"
xpaset -p ds9 file fits imgnan.fits
sleep 1
xpaset -p ds9 frame clear
echo "PASSED"
fi

if [ "$1" = "inf" -o  -z "$1" ]; then
echo "Testing INF"
xpaset -p ds9 file fits imginf.fits
sleep 1
xpaset -p ds9 frame clear
echo "PASSED"
fi

if [ -z "$1" ]; then
xpaset -p ds9 quit
fi

echo "DONE"
