package provide DS9 1.0

proc InitXPA {} {
    global xpa
    global ds9
    global help

    set xpa [xpacmdnew "DS9" $ds9(title)]

    xpacmdadd $xpa about \
	"$help(about)" \
	XPASendAbout "" "" \
	"" "" ""
    xpacmdadd $xpa analysis \
	"\[task number\]\n\t\t\[clear\]\n\t\t\[clear\]\[load <filename>\]\n\t\t\[message ok|okcancel|yesno \{<message>\}\]\n\t\t\[entry \{<message>\}\]\n\t\t\[text\]\n\t\t\[plot\]\n\t\t\[plot stdin\]\n\t\t\[plot {<title>} {<xaxis>} {<yaxis>} \[2|3\]\]" \
	XPASendAnalysis "" "" \
	XPARcvdAnalysis "" ""

    xpacmdadd $xpa array \
	"\t\[new\]\[\[xdim=<x>,ydim=<y>|dim=<dim>\],bitpix=<b>,\[skip=<s>\]\]"\
	XPASendArray "" "" \
	XPARcvdArray "" "fillbuf=false"

    xpacmdadd $xpa blink \
	"" \
	XPASendBlink "" "" \
	XPARcvdBlink "" ""

    xpacmdadd $xpa bin \
	"$help(bin)" \
	XPASendBin "" "" \
	XPARcvdBin "" ""

    xpacmdadd $xpa cmap \
	"$help(cmap)" \
	XPASendColormap "" "" \
	XPARcvdColormap "" ""

    xpacmdadd $xpa contour \
	"$help(contour)" \
	XPASendContour "" "" \
	XPARcvdContour "" ""

    xpacmdadd $xpa crosshair \
	"\[x y image|physical|fk4|fk5|icrs|galactic|ecliptic|linear\]" \
	XPASendCrosshair "" "" \
	XPARcvdCrosshair "" ""

    xpacmdadd $xpa cursor \
	"\t\[x y\] -- move pointer or crosshair" \
	"" "" "" \
	XPARcvdCursor "" ""

    xpacmdadd $xpa dss \
	"$help(dss)" \
	XPASendDSS "" "" \
	XPARcvdDSS "" ""

    xpacmdadd $xpa exit \
	"\t-- exit application" \
	"" "" "" \
	XPARcvdExit "" ""

    xpacmdadd $xpa file \
	"\t\[new\]\[<filename>\]\n\t\t\[new\]\[fits <filename>\]\n\t\t\[new\]\[mosaic <filename>\]\n\t\t\[new\]\[mosaicimage <filename>\]\n\t\t\[new\]\[array <filename>\]\n\t\t\[new\]\[url <url>\]\n\t\t\[save \[gz\] <filename>\]" \
	XPASendFile "" "" \
	XPARcvdFile "" ""

    xpacmdadd $xpa fits \
	"\t\[type|image|table\] \[gz\]\n\t\t\[new\]\[<options>\]\n\t\t\[new\]\[mosaic <options>\]\n\t\t\[new\]\[mosaicimage <options>\]" \
	XPASendFits "" "fillbuf=false" \
	XPARcvdFits "" "fillbuf=false"

    xpacmdadd $xpa frame \
	"\t\[center \[ |\#|all\] | clear \[ |\#|all\] | delete \[ |\#|all\]\]\n\t\t\[new | reset \[ |\#|all\] | refresh \[ |\#|all\]\]\n\t\t\[hide \[ |\#|all\] | show  \[\#|all\]\]\n\t\t\[first | next | prev | last | frameno \#| \#\]" \
	XPASendFrame "" "" \
	XPARcvdFrame "" ""

    xpacmdadd $xpa grid \
	"$help(grid)" \
	XPASendGrid "" "" \
	XPARcvdGrid "" ""

    xpacmdadd $xpa iconify \
	"\[yes|no]" \
	XPASendIconify "" "" \
	XPARcvdIconify "" ""

    xpacmdadd $xpa lower \
	"\t-- lower window" \
	"" "" "" \
	XPARcvdLower "" ""

    xpacmdadd $xpa minmax \
	"$help(minmax)" \
	XPASendMinMax "" "" \
	XPARcvdMinMax "" ""

    xpacmdadd $xpa mode \
	"\t\[pointer|crosshair|colorbar|pan|zoom|rotate|examine\]" \
	XPASendMode "" "" \
	XPARcvdMode "" ""

    xpacmdadd $xpa nameserver \
	"$help(nsvr)" \
	XPASendNSVR "" "" \
	XPARcvdNSVR "" ""

    xpacmdadd $xpa orient \
	"$help(orient)" \
	XPASendOrient "" "" \
	XPARcvdOrient "" ""

    xpacmdadd $xpa {page setup} \
	"$help(pagesetup)" \
	XPASendPageSetup "" "" \
	XPARcvdPageSetup "" ""

    xpacmdadd $xpa pan \
	"$help(pan)" \
	XPASendPan "" "" \
	XPARcvdPan "" ""

    xpacmdadd $xpa pixeltable \
	"\[yes|no\]" \
	XPASendPixelTable "" "" \
	XPARcvdPixelTable "" ""

    xpacmdadd $xpa print \
	"$help(print)" \
	XPASendPrint "" "" \
	XPARcvdPrint "" ""

    xpacmdadd $xpa quit \
	"\t-- exit application" \
	"" "" "" \
	XPARcvdExit "" ""

    xpacmdadd $xpa raise \
	"\t-- raise window" \
	"" "" "" \
	XPARcvdRaise "" ""

    xpacmdadd $xpa regions \
	"\[movefront\]\n\t\t\[moveback\]\n\t\t\[selectall\]\n\t\t\[selectnone\]\n\t\t\[deleteall\]\n\t\t\[load <filename>\]\n\t\t\[save <filename>\]\n\t\t\[format\]\n\t\t\[-format ds9|saotng|saoimage|pros\]\n\t\t\[coord\]\n\t\t\[-coord image|physical|fk4|fk5|icrs|galactic|ecliptic|linear\]\n\t\t\[coordformat\]\n\t\t\[-coordformat degrees|sexagesimal\]\n\t\t\[strip\]\n\t\t\[-strip yes|no\]\n\t\t\[shape <shape>\]\n\t\t\[color <color>\]\n\t\t\[width <width>\]\n\t\t\[include|exclude|source|background\]\n\t\t\[-prop select|edit|move|rotate|delete|fixed|include|source\]" \
	XPASendRegions "" "" \
	XPARcvdRegions "" "fillbuf=false"

    xpacmdadd $xpa rotate \
	"$help(rotate)" \
	XPASendRotate "" "" \
	XPARcvdRotate "" ""

    xpacmdadd $xpa saveas \
	"$help(saveas)" \
	"" "" "" \
	XPARcvdSaveAs "" ""

    xpacmdadd $xpa scale \
	"$help(scale)" \
	XPASendScale "" "" \
	XPARcvdScale "" ""

    xpacmdadd $xpa single \
	"" \
	XPASendSingle "" "" \
	XPARcvdSingle "" ""

    xpacmdadd $xpa shm \
	"$help(shm)" \
	XPASendShm "" "" \
	XPARcvdShm "" ""

    xpacmdadd $xpa source \
	"\t\[filename\] -- source tcl source code" \
	"" "" "" \
	XPARcvdSource "" ""

    xpacmdadd $xpa tcl \
	"\t\[<tcl command>\] -- execute tcl command" \
	"" "" "" \
	XPARcvdTcl "" ""

    xpacmdadd $xpa tile \
	"$help(tile)" \
	XPASendTile "" "" \
	XPARcvdTile "" ""

    xpacmdadd $xpa update \
	"\t\[\]\n\t\t\[\# x1 y1 x2 y2\]\n\t\t\[now\]\n\t\t\[now \# x1 y1 x2 y2\]" \
	"" "" "" \
	XPARcvdUpdate "" ""

    xpacmdadd $xpa view \
	"$help(view)" \
	XPASendView "" "" \
	XPARcvdView "" ""

    xpacmdadd $xpa version \
	"$help(version)" \
	XPASendVersion "" "" \
	"" "" ""
    xpacmdadd $xpa wcs \
	"\t\[fk4|fk5|icrs|galactic|ecliptic|linear\]\n\t\t\[align yes|no\]\n\t\t\[format degrees|sexagesimal\]\n\t\t\[reset|replace|append\]\n\t\t\[replace \[file <filename>\]\]\n\t\t\[append \[file <filename>\]\]" \
	XPASendWCS "" "" \
	XPARcvdWCS "" "fillbuf=false"

    xpacmdadd $xpa zoom \
	"$help(zoom)" \
	XPASendZoom "" "" \
	XPARcvdZoom "" ""
}

proc XPASendAbout {xpa cdata param} {
    global about

    InitXPAError
    catch {xpasetbuf $xpa $about(message)}
    CatchXPAError $xpa
}

proc XPASendAnalysis {xpa cdata param} {
    global analysis

    InitXPAError
    catch {
	set result {}
	switch -- [string tolower [lindex $param 0]] {
	    entry {
		AnalysisEntry [lrange $param 1 end] result
		append result "\n"
	    }
	    default {
		for {set i 0} {$i<$analysis(menu,count)} {incr i} {
		    set result "$result\#$i menu"
		    set result "$result\n$analysis(menu,$i,item)"
		    set result "$result\n$analysis(menu,$i,template)"
		    set result "$result\n$analysis(menu,$i,cmd)"
		    set result "$result\n\n"
		}
		for {set i 0} {$i<$analysis(bind,count)} {incr i} {
		    set result "$result\#$i bind"
		    set result "$result\n$analysis(bind,$i,item)"
		    set result "$result\n$analysis(bind,$i,template)"
		    set result "$result\n$analysis(bind,$i,cmd)"
		    set result "$result\n\n"
		}
	    }
	}
	xpasetbuf $xpa $result
    }
    CatchXPAError $xpa
}

proc XPARcvdAnalysis {xpa cdata param buf len} {
    global ds9
    global prefs

    InitXPAError
    catch {
	set ds9(xpa) $xpa
	switch -- [string tolower [lindex $param 0]] {
	    message {
		switch [llength $param] {
		    0 -
		    1 {}
		    2 {AnalysisMessage ok [lindex $param 1]}
		    3 {AnalysisMessage [lindex $param 1] [lindex $param 2]}
		}
	    }
	    text {AnalysisText analysisXPAtext Analysis $buf append}
	    plot {
		if {[string tolower [lindex $param 1]] == "stdin"} {
		    AnalysisPlotStdin analysisXPAplot Plot buf
		} elseif {[llength $param] == 1} {
		    AnalysisPlot $prefs(ap,unique) \
			analysisXPAplot Plot {} X Y 2 $buf
		} elseif {[llength $param] == 5}  {
		    AnalysisPlot $prefs(ap,unique) analysisXPAplot Plot \
			[lindex $param 1] \
			[lindex $param 2] \
			[lindex $param 3] \
			[lindex $param 4] $buf
		}
	    }
	    load {XPASendAnalysisLoad $xpa buf [lindex $param 1]}
	    clear {
		ClearAnalysis
		switch [lindex $param 1] {
		    load {XPASendAnalysisLoad $xpa buf [lindex $param 2]}
		}
	    }
	    default {AnalysisTask [expr $param-1] menu {} 0 0}
	}
	set ds9(xpa) 0
    }
    CatchXPAError $xpa
}

proc XPASendAnalysisLoad {xpa bufname fn} {
    upvar $bufname buf

    InitXPAError
    catch {
	if {$fn != ""} {
	    ProcessAnalysisFile $fn
	    LayoutFrames
	} else {
	    ProcessAnalysis buf
	    LayoutFrames
	}
    }
    CatchXPAError $xpa
}

proc XPASendArray {xpa cdata param} {
    global current

    InitXPAError
    catch {
	if {$current(frame) != ""} {
	    xpasetbuf $xpa "[$current(frame) get fits full file names]\n"
	}
    }
    CatchXPAError $xpa
}

proc XPARcvdArray {xpa cdata param buf len} {
    global current

    InitXPAError
    catch {
	switch -- [string tolower [lindex $param 0]] {
	    new {
		CreateFrame
		set param [lreplace $param 0 0]
	    }
	}

	if {$current(frame) != ""} {
	    StartLoad
	    if {[catch {$current(frame) load array socket gz \
			    [xparec $xpa datafd] [lindex $param 0]}]} {
		xpaerror $xpa "Unable to load Array File"
	    }
	    FinishLoad
	}

    }

    # flush buffer
    xparec $xpa datafd

    CatchXPAError $xpa
}

proc XPASendBlink {xpa cdata param} {
    global ds9

    InitXPAError
    catch {
	if {$ds9(displaymode) == "blink"} {
	    xpasetbuf $xpa [ToYesNo 1]
	} else {
	    xpasetbuf $xpa [ToYesNo 0]
	}
    }
    CatchXPAError $xpa
}

proc XPARcvdBlink {xpa cdata param buf len} {
    global ds9

    InitXPAError
    catch {
	set ds9(displaymode) blink
	DisplayMode
    }
    CatchXPAError $xpa
}

proc XPASendBin {xpa cdata param} {
    global bin
    global current

    InitXPAError
    catch {
	switch -- [string tolower $param] {
	    about {
		if {$current(frame) != ""} {
		    xpasetbuf $xpa "[$current(frame) get bin cursor]\n"
		}
	    }
	    buffersize {xpasetbuf $xpa "$bin(buffersize)\n"}
	    cols {
		if {$current(frame) != ""} {
		    xpasetbuf $xpa "[$current(frame) get bin cols]\n"
		}
	    }
	    factor {xpasetbuf $xpa "$bin(factor)\n"}
	    filter {
		if {$current(frame) != ""} {
		    xpasetbuf $xpa "[$current(frame) get bin filter]\n"
		}
	    }
	    function {xpasetbuf $xpa "$bin(function)\n"}
	}
    }
    CatchXPAError $xpa
}

proc XPARcvdBin {xpa cdata param buf len} {
    set i 0

    InitXPAError
    catch {ProcessBinCmd param i}
    CatchXPAError $xpa
}

proc XPASendContour {xpa cdata param} {
    global contour

    InitXPAError
    catch {xpasetbuf $xpa [ToYesNo $contour(view)]}
    CatchXPAError $xpa
}

proc XPARcvdContour {xpa cdata param buf len} {
    set i 0

    InitXPAError
    catch {ProcessContourCmd param i}
    CatchXPAError $xpa
}

proc XPASendColormap {xpa cdata param} {
    global colorbar

    InitXPAError
    catch {
	switch -- [string tolower $param] {
	    file {xpasetbuf $xpa "[colorbar get file name]\n"}
	    invert {xpasetbuf $xpa [ToYesNo $colorbar(invert)]}
	    value {
		xpasetbuf $xpa \
		    "[colorbar get contrast] [colorbar get bias]\n"
	    }
	    {} {xpasetbuf $xpa "$colorbar(map)\n"}
	    default {xpaerror $xpa "Illegal option: $param"}
	}
    }
    CatchXPAError $xpa
}

proc XPARcvdColormap {xpa cdata param buf len} {
    set i 0

    InitXPAError
    catch {ProcessCmapCmd param i}
    CatchXPAError $xpa
}

proc XPASendCrosshair {xpa cdata param} {
    global current

    InitXPAError
    catch {
	set sys [lindex $param 0]
	set format [lindex $param 1]
	if {$current(frame) != ""} {
	    if {$sys == ""} {
		set sys physical
	    }
	    if {$format == ""} {
		set format pixels
	    }
	    xpasetbuf $xpa "[$current(frame) get crosshair $sys $format]\n"
	}
    }
    CatchXPAError $xpa
}

proc XPARcvdCrosshair {xpa cdata param buf len} {
    global current
    global ds9

    InitXPAError
    catch {
	if {$current(frame) != ""} {
	    set x [lindex $param 0]
	    set y [lindex $param 1]
	    set sys [lindex $param 2]
	    if {$sys == ""} {
		set sys physical
	    }
	    set ds9(mode) crosshair
	    ChangeMode
	    $current(frame) crosshair $sys $x $y
	    set coord [$current(frame) get crosshair canvas]
	    UpdateInfoBox $current(frame) \
		[lindex $coord 0] [lindex $coord 1] canvas
	}
    }
    CatchXPAError $xpa
}

proc XPARcvdCursor {xpa cdata param buf len} {
    global current

    InitXPAError
    catch {
	if {$current(frame) != ""} {
	    set x [lindex $param 0]
	    set y [lindex $param 1]
	    ArrowKeyFrame $current(frame) $x $y
	}
    }
    CatchXPAError $xpa
}

proc XPASendDSS {xpa cdata param} {
    global dss

    InitXPAError
    catch {
	switch -- [string tolower [lindex $param 0]] {
	    server {xpasetbuf $xpa "$dss(server)\n"}
	    survey {xpasetbuf $xpa "$dss(survey)\n"}
	    coord {xpasetbuf $xpa "$dss(x) $dss(y)\n"}
	    x {xpasetbuf $xpa "$dss(x)\n"}
	    y {xpasetbuf $xpa "$dss(y)\n"}
	    size {xpasetbuf $xpa "$dss(width) $dss(height)\n"}
	    width {xpasetbuf $xpa "$dss(width)\n"}
	    height {xpasetbuf $xpa "$dss(height)\n"}
	    name -
	    default {xpasetbuf $xpa "$dss(name)\n"}
	}
    }
    CatchXPAError $xpa
}

proc XPARcvdDSS {xpa cdata param buf len} {
    set i 0

    InitXPAError
    catch {ProcessDSSCmd param i 0 foobar}
    CatchXPAError $xpa
}

proc XPARcvdExit {xpa cdata param buf len} {
    QuitDS9
}

proc XPASendFile {xpa cdata param} {
    global current

    InitXPAError
    catch {
	if {$current(frame) != ""} {
	    xpasetbuf $xpa "[$current(frame) get fits full file names]\n"
	}
    }
    CatchXPAError $xpa
}

proc XPARcvdFile {xpa cdata param buf len} {
    global ds9
    global current

    InitXPAError
    catch {
	set ds9(xpa) $xpa
	switch -- [string tolower [lindex $param 0]] {
	    new {
		CreateFrame
		set param [lreplace $param 0 0]
	    }
	}

	switch -- [lindex $param 0] {
	    fits {
		StartLoad
		LoadFits [lindex $param 1]
		FinishLoad
	    }
	    array {
		StartLoad
		LoadArray [lindex $param 1]
		FinishLoad
	    }
	    mosaicimage {
		StartLoad
		LoadMosaicImageFits [lindex $param 1]
		FinishLoad
	    }
	    mosaic {
		StartLoad
		LoadMosaicFits [lindex $param 1]
		FinishLoad
	    }
	    url {
		StartLoad
		LoadURL [lindex $param 1]
		FinishLoad
	    }
	    save {
		switch [lindex $param 1] {
		    gz {
			$current(frame) save fits image file \
			    [lindex $param 2] gz
		    }
		    resample {
			switch [lindex $param 2] {
			    gz {
				$current(frame) save fits resample file \
				    [lindex $param 3] gz
			    }
			    default {
				$current(frame) save fits resample file \
				    [lindex $param 2]
			    }
			}
		    }
		    default {
			$current(frame) save fits image file [lindex $param 1]
		    }
		}

	    }
	    default {
		StartLoad
		LoadFits [lindex $param 0]
		FinishLoad
	    }
	}
	set ds9(xpa) 0
    }
    CatchXPAError $xpa
}

proc XPASendFits {xpa cdata param} {
    global current

    InitXPAError
    catch {
	if {$current(frame) != ""} {
	    if {[$current(frame) has fits]} {
		switch -- [string tolower [lindex $param 0]] {
		    type {
			if {[$current(frame) has fits image]} {
			    xpasetbuf $xpa "image\n"
			} elseif {[$current(frame) has fits table]} {
			    xpasetbuf $xpa "table\n"
			}
		    }
		    table {
			switch [lindex $param 1] {
			    gz {
				$current(frame) save fits table socket \
				    [xparec $xpa datafd] gz
			    }
			    default {
				$current(frame) save fits table socket \
				    [xparec $xpa datafd]
			    }
			}
		    }
		    image {
			switch [lindex $param 1] {
			    gz {
				$current(frame) save fits image socket \
				    [xparec $xpa datafd] gz
			    }
			    default {
				$current(frame) save fits image socket \
				    [xparec $xpa datafd]
			    }
			}
		    }
		    resample {
			switch [lindex $param 1] {
			    gz {
				$current(frame) save fits resample socket \
				    [xparec $xpa datafd] gz
			    }
			    default {
				$current(frame) save fits resample socket \
				    [xparec $xpa datafd]
			    }
			}
		    }
		    gz {
			$current(frame) save fits image socket \
			    [xparec $xpa datafd] gz
		    }
		    default {
			$current(frame) save fits image socket \
			    [xparec $xpa datafd]
		    }
		}
	    } else {
		xpaerror $xpa "No Fits file loaded"
	    }
	} else {
	    xpaerror $xpa "No Fits file loaded"
	}
    }
    CatchXPAError $xpa
}

proc XPARcvdFits {xpa cdata param buf len} {
    global current

    InitXPAError
    catch {
	switch -- [string tolower [lindex $param 0]] {
	    new {
		CreateFrame
		set param [lreplace $param 0 0]
	    }
	}

	if {$current(frame) != ""} {
	    StartLoad
	    switch [lindex $param 0] {
		mosaic {
		    if {[catch {$current(frame) load fits mosaic socket gz \
				    [xparec $xpa datafd] [lindex $param 1]}]} {
			xpaerror $xpa "Unable to load Mosaic Segment Fits File"
		    }
		}
		mosaicimage {
		    if {[catch {$current(frame) load fits mosaic image socket \
				    gz [xparec $xpa datafd] \
				    [lindex $param 1]}]} {
			xpaerror $xpa "Unable to load Mosaic Image Fits File"
		    }
		}
		default {
		    if {[catch {$current(frame) load fits socket gz \
				    [xparec $xpa datafd] [lindex $param 0]}]} {
			xpaerror $xpa "Unable to load Fits File"
		    }
		}
	    }
	    FinishLoad
	}
    }

    # flush buffer
    xparec $xpa datafd

    CatchXPAError $xpa
}

proc XPASendFrame {xpa cdata param} {
    global current

    InitXPAError
    catch {
	switch [lindex $param 0] {
	    active {
		global ds9

		set r ""
		foreach f $ds9(active) {
		    append r "[string range $f 5 end] "
		}
		xpasetbuf $xpa "$r\n"
	    }
	    all {
		global ds9

		set r ""
		foreach f $ds9(frames) {
		    append r "[string range $f 5 end] "
		}
		xpasetbuf $xpa "$r\n"
	    }
	    default {xpasetbuf $xpa "[string range $current(frame) 5 end]\n"}
	}
    }
    CatchXPAError $xpa
}

proc XPARcvdFrame {xpa cdata param buf len} {
    global current
    global ds9
    global active

    InitXPAError
    catch {
	set cmd [string tolower [lindex $param 0]]
	switch -- $cmd {
	    center {
		switch [lindex $param 1] {
		    all {CenterAllFrame}
		    "" {CenterCurrentFrame}
		    default {
			set f "Frame[lindex $param 1]"
			CenterFrame $f
		    }
		}
	    }
	    clear {
		switch [lindex $param 1] {
		    all {ClearAllFrame}
		    "" {ClearCurrentFrame}
		    default {
			set f "Frame[lindex $param 1]"
			ClearFrame $f
		    }
		}
	    }
	    delete {
		switch [lindex $param 1] {
		    all {DeleteAllFrame}
		    "" {DeleteCurrentFrame}
		    default {
			set f "Frame[lindex $param 1]"
			DeleteFrame $f
		    }
		}
	    }
	    new {CreateFrame}
	    reset {
		switch [lindex $param 1] {
		    all {ResetAllFrame}
		    "" {ResetCurrentFrame}
		    default {
			set f "Frame[lindex $param 1]"
			ResetFrame $f
		    }
		}
	    }
	    refresh {
		switch [lindex $param 1] {
		    all {UpdateAllFrame}
		    "" {UpdateCurrentFrame}
		    default {
			set f "Frame[lindex $param 1]"
			UpdateFrame $f
		    }
		}
	    }
	    hide {
		switch [lindex $param 1] {
		    all {ActiveFrameNone}
		    "" {
			set active($current(frame)) 0
			UpdateActiveFrames
		    }
		    default {
			set f "Frame[lindex $param 1]"
			set active($f) 0
			UpdateActiveFrames
		    }
		}
	    }
	    show {
		switch [lindex $param 1] {
		    all {ActiveFrameAll}
		    default {
			set f "Frame[lindex $param 1]"
			set active($f) 1
			UpdateActiveFrames
		    }
		}
	    }
	    first {FirstFrame}
	    next {NextFrame}
	    prev {PrevFrame}
	    last {LastFrame}
	    frameno {CreateGotoFrame [lindex $param 1]}
	    default {CreateGotoFrame [lindex $param 0]}
	}
    }
    CatchXPAError $xpa
}

proc XPASendGrid {xpa cdata param} {
    global grid

    InitXPAError
    catch {xpasetbuf $xpa [ToYesNo $grid(view)]}
    CatchXPAError $xpa
}

proc XPARcvdGrid {xpa cdata param buf len} {
    set i 0

    InitXPAError
    catch {ProcessGridCmd param i}
    CatchXPAError $xpa
}

proc XPASendIconify {xpa cdata param} {
    global ds9

    InitXPAError
    catch {
	if {[wm state $ds9(top)] == "normal"} {
	    xpasetbuf $xpa "no\n"
	} else {
	    xpasetbuf $xpa "yes\n"
	}
    }
    CatchXPAError $xpa
}

proc XPARcvdIconify {xpa cdata param buf len} {
    global ds9

    InitXPAError
    catch {
	if {[FromYesNo $param]} {
	    wm iconify $ds9(top)
	} else {
	    wm deiconify $ds9(top)
	}
    }
    CatchXPAError $xpa
}

proc XPARcvdLower {xpa cdata param buf len} {
    global ds9

    InitXPAError
    catch {lower $ds9(top)}
    CatchXPAError $xpa
}

proc XPASendMinMax {xpa cdata param} {
    global current
    global minmax

    InitXPAError
    catch {
	switch -- [string tolower $param] {
	    mode {xpasetbuf $xpa "$minmax(mode)\n"}
	    interval {xpasetbuf $xpa "$minmax(sample)\n"}
	    default {xpasetbuf $xpa "$minmax(mode)\n"}
	}
    }
    CatchXPAError $xpa
}

proc XPARcvdMinMax {xpa cdata param buf len} {
    set i 0

    InitXPAError
    catch {ProcessMinMaxCmd param i}
    CatchXPAError $xpa
}

proc XPASendMode {xpa cdata param} {
    global ds9

    InitXPAError
    catch {xpasetbuf $xpa "$ds9(mode)\n"}
    CatchXPAError $xpa
}

proc XPARcvdMode {xpa cdata param buf len} {
    global ds9

    InitXPAError
    catch {
	set ds9(mode) [string tolower $param]
	ChangeMode
    }
    CatchXPAError $xpa
}

proc XPASendNSVR {xpa cdata param} {
    global nsvr

    InitXPAError
    catch {
	switch -- [string tolower [lindex $param 0]] {
	    server {xpasetbuf $xpa "$nsvr(server)\n"}
	    format {xpasetbuf $xpa "$nsvr(format)\n"}
	}
    }
    CatchXPAError $xpa
}

proc XPARcvdNSVR {xpa cdata param buf len} {
    set i 0

    InitXPAError
    catch {ProcessNSVRCmd param i}
    CatchXPAError $xpa
}

proc XPASendOrient {xpa cdata param} {
    global current

    InitXPAError
    catch {xpasetbuf $xpa "$current(orient)\n"}
    CatchXPAError $xpa
}

proc XPARcvdOrient {xpa cdata param buf len} {
    set i 0

    InitXPAError
    catch {ProcessOrientCmd param i}
    CatchXPAError $xpa
}

proc XPASendPageSetup {xpa cdata param} {
    global ps

    InitXPAError
    catch {
	switch -- [string tolower $param] {
	    orientation {xpasetbuf $xpa "$ps(orient)\n"}
	    pagescale {xpasetbuf $xpa "$ps(scale)\n"}
	    pagesize {xpasetbuf $xpa "$ps(size)\n"}
	}
    }
    CatchXPAError $xpa
}

proc XPARcvdPageSetup {xpa cdata param buf len} {
    set i 0

    InitXPAError
    catch {ProcessPageSetupCmd param i}
    CatchXPAError $xpa
}

proc XPASendPan {xpa cdata param} {
    global current

    InitXPAError
    catch {
	if {$current(frame) != ""} {
	    set sys [lindex $param 0]
	    if {$sys == ""} {
		set sys physical
	    }
	    set format [lindex $param 1]
	    if {$format == ""} {
		set format pixels
	    }
	    xpasetbuf $xpa "[$current(frame) get pan $sys $format]\n"
	}
    }
    CatchXPAError $xpa
}

proc XPARcvdPan {xpa cdata param buf len} {
    set i 0

    InitXPAError
    catch {ProcessPanCmd param i}
    CatchXPAError $xpa
}

proc XPASendPixelTable {xpa cdata param} {
    global pixel

    InitXPAError
    catch {xpasetbuf $xpa [ToYesNo $pixel(view)]}
    CatchXPAError $xpa
}

proc XPARcvdPixelTable {xpa cdata param buf len} {
    InitXPAError
    catch {
	if {[llength $param] > 0 } {
	    if {[FromYesNo [lindex $param 0]]} {
		PixelTableDisplay
	    } else {
		PixelTableDestroy
	    }
	} else {
	    PixelTableDisplay
	}
    }
    CatchXPAError $xpa
}

proc XPASendPrint {xpa cdata param} {
    global ps

    InitXPAError
    catch {
	switch -- [string tolower $param] {
	    destination {xpasetbuf $xpa "$ps(dest)\n"}
	    command {xpasetbuf $xpa "$ps(cmd)\n"}
	    filename {xpasetbuf $xpa "$ps(filename)\n"}
	    palette {xpasetbuf $xpa "$ps(color)\n"}
	    level {xpasetbuf $xpa "$ps(level)\n"}
	    interpolate {xpasetbuf $xpa [ToYesNo $ps(interpolate)]}
	    resolution {xpasetbuf $xpa "$ps(resolution)\n"}
	}
    }
    CatchXPAError $xpa
}

proc XPARcvdPrint {xpa cdata param buf len} {
    global ds9

    InitXPAError
    catch {
	set ds9(xpa) $xpa
	set i 0
	ProcessPrintCmd param i
	set ds9(xpa) 0
    }
    CatchXPAError $xpa
}

proc XPARcvdRaise {xpa cdata param buf len} {
    global ds9

    InitXPAError
    catch {raise $ds9(top)}
    CatchXPAError $xpa
}

proc XPASendRegions {xpa cdata param} {
    global current
    global marker

    InitXPAError
    catch {
	if {$current(frame) != ""} {
	    set item [lindex $param 0]
	    switch -- $item {
		format {xpasetbuf $xpa "$marker(format)\n"}
		coord {xpasetbuf $xpa "$marker(coord)\n"}
		coordformat {xpasetbuf $xpa "$marker(coordformat)\n"}
		strip {xpasetbuf $xpa "[ToYesNo $marker(strip)]\n"}
		delim {
		    if {$marker(strip)} {
			xpasetbuf $xpa "semicolon\n"
		    } else {
			xpasetbuf $xpa "nl\n"
		    }
		}
		shape {xpasetbuf $xpa "$marker(shape)\n"}
		color {xpasetbuf $xpa "$marker(color)\n"}
		width {xpasetbuf $xpa "$marker(width)\n"}

		default {
		    set format $marker(format)
		    set coord $marker(coord)
		    set coordformat $marker(coordformat)
		    set strip $marker(strip)
		    set prop {}
		    set value {}

		    set i 0
		    set l [llength $param]
		    while {$i < $l} {
			switch -- [lindex $param $i] {
			    -format {incr i; set format [lindex $param $i]}
			    -coord  {incr i; set coord [lindex $param $i]}
			    -coordformat {
				incr i;
				set coordformat [lindex $param $i]
			    }
			    -strip {
				incr i; 
				set strip [FromYesNo [lindex $param $i]]
			    }
			    -delim  {
				incr i;
				if {[lindex $param $i] != "nl"} {
				    set strip 1
				} else {
				    set strip 0
				}
			    }

			    include {set prop include; set value 1}
			    exclude {set prop include; set value 0}
			    source {set prop source; set value 1}
			    background {set prop source; set value 0}
			    -prop {
				incr i
				set prop [lindex $param $i]
				incr i
				set value [lindex $param $i]
			    }

			}
			incr i
		    }
		    if {$prop != {} && $value != {}} {
			xpasetbuf $xpa [$current(frame) marker list \
					    $format $coord $coordformat \
					    $strip $prop = $value]
		    } else {
			xpasetbuf $xpa [$current(frame) marker list \
					    $format $coord $coordformat $strip]
		    }
		}
	    }
	}
    }
    CatchXPAError $xpa
}

proc XPARcvdRegions {xpa cdata param buf len} {
    global current
    global marker
    global ds9

    if {$current(frame) == ""} {
	xpaerror $xpa "No frame available"
	# flush the buffer
	xparec $xpa datafd
	return
    }

    if {![$current(frame) has fits]} {
	xpaerror $xpa "No data loaded"
	# flush the buffer
	xparec $xpa datafd
	return
    }
    
    InitXPAError
    catch {
	set ds9(xpa) $xpa
	if {$param != ""} {
	    switch -- [lindex $param 0] {
		movefront {$current(frame) marker move front}
		moveback {$current(frame) marker move back}

		selectall {$current(frame) marker select all}
		selectnone {$current(frame) marker unselect all}
		deleteall {$current(frame) marker delete all}

		file -
		load {LoadMarker [lindex $param 1]}

		save {
		    if {[lindex $param 1] != ""} {
			$current(frame) marker save [lindex $param 1] \
			    $marker(format) $marker(coord) $marker(coordformat)
		    }
		}

		format {
		    set marker(format) [lindex $param 1]
		    UpdateMarkerFormatMenu marker(format) marker(coord) \
			marker(coordformat) $ds9(mb).region
		}
		coord {set marker(coord) [lindex $param 1]}
		coordformat {set marker(coordformat) [lindex $param 1]}
		strip {set marker(strip) [FromYesNo [lindex $param 1]]}
		delim {
		    if {[lindex $param 1] != "nl"} {
			set marker(strip) 1
		    } else {
			set marker(strip) 0
		    }
		}
		shape {
		    if {[llength $param] == 3} {
			set marker(shape) "[lindex $param 1] [lindex $param 2]"
		    } else {
			set marker(shape) [lindex $param 1]
		    }
		}
		color {set marker(color) [lindex $param 1]}
		width {set marker(width) [lindex $param 1]}

		default {
		    $current(frame) marker command $marker(format) "\{$param\}"
		}
	    }
	} else {
	    switch $marker(format) {
		xy {
		    $current(frame) marker load $marker(format) \
			[xparec $xpa datafd] $marker(coord)
		}
		default {
		    $current(frame) marker load $marker(format) \
			[xparec $xpa datafd]
		}
	    }
	}
	set ds9(xpa) 0
    }

    # flush buffer
    xparec $xpa datafd

    CatchXPAError $xpa
}

proc XPASendRotate {xpa cdata param} {
    global current

    InitXPAError
    catch {xpasetbuf $xpa "$current(rotate)\n"}
    CatchXPAError $xpa
}

proc XPARcvdRotate {xpa cdata param buf len} {
    set i 0

    InitXPAError
    catch {ProcessRotateCmd param i}
    CatchXPAError $xpa
}

proc XPARcvdSaveAs {xpa cdata param buf len} {
    set i 0

    InitXPAError
    catch {ProcessSaveAsCmd param i}
    CatchXPAError $xpa
}

proc XPASendScale {xpa cdata param} {
    global current
    global scale

    InitXPAError
    catch {
	switch -- [string tolower $param] {
	    datasec {xpasetbuf $xpa "$scale(datasec)\n"}
	    limits {
		if {$current(frame) != ""} {
		    set lims [$current(frame) get clip]
		    xpasetbuf $xpa "[lindex $lims 0] [lindex $lims 1]\n"
		}
	    }
	    mode {xpasetbuf $xpa "$scale(mode)\n"}
	    scope {xpasetbuf $xpa "$scale(scope)\n"}
	    default {xpasetbuf $xpa "$scale(type)\n"}
	}
    }
    CatchXPAError $xpa
}

proc XPARcvdScale {xpa cdata param buf len} {
    set i 0

    InitXPAError
    catch {ProcessScaleCmd param i}
    CatchXPAError $xpa
}

proc XPASendSingle {xpa cdata param} {
    global ds9

    InitXPAError
    catch {
	if {$ds9(displaymode) == "single"} {
	    xpasetbuf $xpa [ToYesNo 1]
	} else {
	    xpasetbuf $xpa [ToYesNo 0]
	}
    }
    CatchXPAError $xpa
}

proc XPARcvdSingle {xpa cdata param buf len} {
    global ds9

    InitXPAError
    catch {
	set ds9(displaymode) single
	DisplayMode
    }
    CatchXPAError $xpa
}

proc XPASendShm {xpa cdata param} {
    global current

    InitXPAError
    catch {
	if {$current(frame) != ""} {
	    xpasetbuf $xpa "[$current(frame) get fits full file names]\n"
	}
    }
    CatchXPAError $xpa
}

proc XPARcvdShm {xpa cdata param buf len} {
    global ds9

    InitXPAError
    catch {
	set ds9(xpa) $xpa
	set i 0
	ProcessShmCmd param i 0 foobar
	set ds9(xpa) 0
    }
    CatchXPAError $xpa
}

proc XPARcvdSource {xpa cdata param buf len} {
    InitXPAError
    catch {uplevel #0 "source \{$param\}"}
    CatchXPAError $xpa
}

proc XPARcvdTcl {xpa cdata param buf len} {
    InitXPAError
    catch {
	if [string compare $param {}] {
	    uplevel #0 $param
	} else {
	    uplevel #0 $buf
	}
    }
    CatchXPAError $xpa
}

proc XPASendTile {xpa cdata param} {
    global ds9
    global tile

    InitXPAError
    catch {
	switch -- [lindex $param 0] {
	    mode {xpasetbuf $xpa "$tile(mode)\n"}
	    grid {
		switch -- [lindex $param 1] {
		    mode {xpasetbuf $xpa "$tile(grid,mode)\n"}
		    layout {xpasetbuf $xpa "$tile(grid,row) $tile(grid,col)\n"}
		    gap {xpasetbuf $xpa "$tile(grid,gap)\n"}
		}
	    }
	    default {
		if {$ds9(displaymode)=="tile"} {
		    xpasetbuf $xpa [ToYesNo 1]
		} else {
		    xpasetbuf $xpa [ToYesNo 0]
		}
	    }
	}
    }
    CatchXPAError $xpa
}

proc XPARcvdTile {xpa cdata param buf len} {
    set i 0

    InitXPAError
    catch {ProcessTileCmd param i}
    CatchXPAError $xpa
}

proc XPARcvdUpdate {xpa cdata param buf len} {
    global current

    InitXPAError
    catch {
	if {$current(frame) != ""} {
	    if {[lindex $param 0] != "now"} {
		if {[lindex $param 0] != ""} {
		    $current(frame) update \
			[lindex $param 0] \
			[lindex $param 1] [lindex $param 2] \
			[lindex $param 3] [lindex $param 4]
		} else {
		    $current(frame) update
		}
	    } else {
		if {[lindex $param 1] != ""} {
		    $current(frame) update now \
			[lindex $param 1] \
			[lindex $param 2] [lindex $param 3] \
			[lindex $param 4] [lindex $param 5]
		} else {
		    $current(frame) update now
		}
	    }
	}
    }
    CatchXPAError $xpa
}

proc XPASendView {xpa cdata param} {
    global info
    global pan
    global mag
    global buttons
    global colorbar
    global graphHorz
    global graphVert

    InitXPAError
    catch {
	switch -- [string tolower $param] {
	    info {xpasetbuf $xpa [ToYesNo $info(view)]}
	    panner {xpasetbuf $xpa [ToYesNo $pan(view)]}
	    magnifier {xpasetbuf $xpa [ToYesNo $mag(view)]}
	    buttons {xpasetbuf $xpa [ToYesNo $buttons(view)]}
	    colorbar {xpasetbuf $xpa [ToYesNo $colorbar(view)]}
	    horzgraph {xpasetbuf $xpa [ToYesNo $graphHorz(view)]}
	    vertgraph {xpasetbuf $xpa [ToYesNo $graphVert(view)]}

	    wcs {xpasetbuf $xpa [ToYesNo $info(wcs)]}
	    detector {xpasetbuf $xpa [ToYesNo $info(detector)]}
	    amplifier {xpasetbuf $xpa [ToYesNo $info(amplifier)]}
	    physical {xpasetbuf $xpa [ToYesNo $info(physical)]}
	    image {xpasetbuf $xpa [ToYesNo $info(image)]}
	    default {xpaerror $xpa "Illegal option: $param"}
	}
    }
    CatchXPAError $xpa
}

proc XPARcvdView {xpa cdata param buf len} {
    set i 0

    InitXPAError
    catch {ProcessViewCmd param i}
    CatchXPAError $xpa
}

proc XPASendVersion {xpa cdata param} {
    global ds9

    InitXPAError
    catch {xpasetbuf $xpa "$ds9(title) $ds9(version)\n"}
    CatchXPAError $xpa
}

proc XPASendWCS {xpa cdata param} {
    global wcs

    InitXPAError
    catch {
	switch -- [string tolower $param] {
	    align {xpasetbuf $xpa [ToYesNo $wcs(align)]}
	    format {xpasetbuf $xpa "$wcs(format)\n"}
	    default {xpasetbuf $xpa "$wcs(system)\n"}
	}
    }
    CatchXPAError $xpa
}

proc XPARcvdWCS {xpa cdata param buf len} {
    global wcs
    global current

    InitXPAError
    catch {
	set i 0
	set l [llength $param]
	while {$i < $l} {
	    set item [lindex $param $i]
	    switch -- $item {
		align {
		    incr i
		    set wcs(align) [FromYesNo [lindex $param $i]]
		    AlignWCSFrame
		}
		format {
		    incr i
		    set wcs(format) [string tolower [lindex $param $i]]
		}
		reset {
		    $current(frame) wcs reset
		}
		replace {
		    if {[lindex $param [expr $i+1]] == "file"} {
			$current(frame) wcs replace [lindex $param [expr $i+2]]
			incr i 2
		    } else {
			$current(frame) wcs replace [xparec $xpa datafd]
		    }
		}
		append {
		    if {[lindex $param [expr $i+1]] == "file"} {
			$current(frame) wcs append [lindex $param [expr $i+2]]
			incr i 2
		    } else {
			$current(frame) wcs append [xparec $xpa datafd]
		    }
		}
		default {set wcs(system) [string tolower $item]}
	    }
	    incr i
	}
    }

    # flush buffer
    xparec $xpa datafd

    CatchXPAError $xpa
}

proc XPASendZoom {xpa cdata param} {
    global current

    InitXPAError
    catch {xpasetbuf $xpa "$current(zoom)\n"}
    CatchXPAError $xpa
}

proc XPARcvdZoom {xpa cdata param buf len} {
    set i 0

    InitXPAError
    catch {ProcessZoomCmd param i}
    CatchXPAError $xpa
}

