/*
 *      Copyrights:
 *
 *    	  Copyright (c) 1999 Smithsonian Astrophysical Observatory
 *
 *        Permission to use, copy, modify, distribute, and  sell  this
 *        software  and  its  documentation  for any purpose is hereby
 *        granted without  fee,  provided  that  the  above  copyright
 *        notice  appear  in  all  copies and that both that copyright
 *        notice and this permission notice appear in supporting docu-
 *        mentation,  and  that  the  name  of the  Smithsonian Astro-
 *	  physical Observatory not be used in advertising or publicity
 *  	  pertaining to distribution of the software without specific,
 *	  written  prior  permission.   The Smithsonian  Astrophysical 
 *        Observatory makes no representations about  the  suitability
 *	  of  this  software for any purpose.  It is provided  "as is"
 *	  without express or implied warranty.
 *        THE  SMITHSONIAN  ASTROPHYSICAL  OBSERVATORY  DISCLAIMS  ALL
 *	  WARRANTIES  WITH  REGARD  TO  THIS  SOFTWARE,  INCLUDING ALL
 *	  IMPLIED  WARRANTIES  OF  MERCHANTABILITY AND FITNESS, IN  NO
 *	  EVENT SHALL THE  SMITHSONIAN  ASTROPHYSICAL  OBSERVATORY  BE 
 *	  LIABLE FOR  ANY SPECIAL, INDIRECT  OR  CONSEQUENTIAL DAMAGES
 *	  OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS  OF USE,  DATA
 *	  OR  PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 *	  OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION  WITH
 *	  THE  USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 */
#include <prsetup.h>

#ifdef HAVE_STRING_H
#include <string.h>
#endif

#ifdef ANSI_FUNC
void
ColumnLoad(char *ibuf, int size, int n, int convert, void *obuf)
#else
void ColumnLoad(ibuf, size, n, convert, obuf)
     char *ibuf;
     int size;
     int n;
     int convert;
     void *obuf;
#endif
{
  register char *iptr;
  register char *optr;
  int i, j;

  if( convert ){
    optr = (char *)obuf;
    iptr = (char *)ibuf;
    for(i=0; i<n; i++){  
      for(j=size-1; j>=0; j--){
	*optr++ = *(iptr+j);
      }
      iptr += size;
    }
  }
  else{
    memcpy(obuf, ibuf, n*size);
  }
}

