#define REGIONS_H "\n\
#include <stdio.h>\n\
#include <string.h>\n\
#include <math.h>\n\
#include <string.h>\n\
#ifdef __STDC__\n\
#include <stdlib.h>\n\
#include <stdarg.h>\n\
#else\n\
#include <varargs.h>\n\
#endif\n\
\n\
#define MASKINC 	10000\n\
#define PI		3.14159265358979323846\n\
#define SMALL_NUMBER	1.0E-24\n\
#define LARGE_NUMBER	65535\n\
#define PSTOP		-142857.142857\n\
\n\
#ifndef SZ_LINE\n\
#define SZ_LINE 	1024\n\
#endif\n\
#ifndef min\n\
#define min(x,y)	(((x)<(y))?(x):(y))\n\
#endif\n\
#ifndef max\n\
#define max(x,y)	(((x)>(y))?(x):(y))\n\
#endif\n\
#ifndef abs\n\
#define abs(x)		((x)<0?(-x):(x))\n\
#endif\n\
#ifndef feq\n\
#define feq(x,y)	(fabs((double)x-(double)y)<=(double)1.0E-15)\n\
#endif\n\
#ifndef NULL\n\
#define NULL 		(void *)0\n\
#endif\n\
\n\
#ifndef TOK_EREG\n\
#define TOK_EREG	1\n\
#endif\n\
#ifndef TOK_NREG\n\
#define TOK_NREG	2\n\
#endif\n\
#ifndef TOK_IREG\n\
#define TOK_IREG	4\n\
#endif\n\
\n\
#define PIXCEN(a)	(double)(a)\n\
#define PIXNUM(a)	(int)((a)+0.5) \n\
#define PIXSTART(a)	((int)(a)+1)\n\
#define PIXSTOP(a)	(((int)(a))==(a)?((int)(a)-1):((int)(a)))\n\
\n\
\n\
\n\
#define PIXINCL(a)	(int)((a)+1.0) \n\
\n\
\n\
#define EVFIELDONLY \"(evfield(g,1,1,1,(double)x,(double)y))\"\n\
\n\
\n\
#ifndef __filter_h\n\
typedef struct filtmaskrec {\n\
  int region;\n\
  int y;\n\
  int xstart, xstop;\n\
} *FilterMask, FilterMaskRec;\n\
\n\
\n\
typedef struct scanrec{\n\
  struct scanrec *next;\n\
  int x;\n\
} *Scan, ScanRec;\n\
\n\
typedef struct shaperec {\n\
  int init;\n\
  double ystart, ystop;\n\
  Scan *scanlist;\n\
  \n\
  double r1sq, r2sq;\n\
  \n\
  double angl, sinangl, cosangl;\n\
  double cossq, sinsq;\n\
  double xradsq, yradsq;\n\
  double a;\n\
  \n\
  int npt;\n\
  double *pts;\n\
  \n\
  int xonly;\n\
  double x1, x2, y1;\n\
  double invslope;\n\
} *Shape, ShapeRec;\n\
\n\
\n\
typedef struct gfiltrec {\n\
  int maxshapes;		\n\
  Shape shapes;			\n\
  int rid;			\n\
  int usebinsiz;		\n\
  char *evsect;			\n\
  double tlminx, tlminy;	\n\
  double binsizx, binsizy;	\n\
  double tloff;		        \n\
  int xmin, xmax, ymin, ymax;	\n\
  int block;			\n\
  char *ybuf;			\n\
  int *x0;			\n\
  int *x1;			\n\
} *GFilt, GFiltRec;\n\
#endif\n\
\n\
\n\
void imannulusi(GFilt g, int rno, int sno, int flag, int type, \n\
		double x, double y,\n\
		double xcen, double ycen, double iradius, double oradius);\n\
void imboxi(GFilt g, int rno, int sno, int flag, int type,\n\
	    double x, double y,\n\
	    double xcen, double ycen, double xwidth, double yheight,\n\
	    double angle);\n\
void imcirclei(GFilt g, int rno, int sno, int flag, int type,\n\
	       double x, double y,\n\
	       double xcen, double ycen, double radius);\n\
void imellipsei(GFilt g, int rno, int sno, int flag, int type,\n\
		double x, double y,\n\
		double xcen, double ycen, double xrad, double yrad,\n\
		double angle);\n\
void imfieldi(GFilt g, int rno, int sno, int flag, int type,\n\
	      double x, double y);\n\
void imlinei(GFilt g, int rno, int sno, int flag, int type,\n\
	     double x, double y,\n\
	     double x0, double y0, double x1, double y1);\n\
void impiei(GFilt g, int rno, int sno, int flag,  int type,\n\
	    double x, double y,\n\
	    double xcen, double ycen, double angle1, double angle2);\n\
void imqtpiei(GFilt g, int rno, int sno, int flag,  int type,\n\
	      double x, double y,\n\
	      double xcen, double ycen, double angle1, double angle2);\n\
void impointi(GFilt g, int rno, int sno, int flag, int type,\n\
	      double x, double y,\n\
	      double xcen, double ycen);\n\
#ifdef __STDC__\n\
void impolygoni(GFilt g, int rno, int sno, int flag, int type,\n\
		double x, double y, ...);\n\
#endif\n\
\n\
\n\
int imannulus(GFilt g, int rno, int sno, int flag, int type,\n\
	      double x, double y,\n\
	      double xcen, double ycen, double iradius, double oradius);\n\
int imbox(GFilt g, int rno, int sno, int flag, int type,\n\
	  double x, double y,\n\
	  double xcen, double ycen, double xwidth, double yheight,\n\
	  double angle);\n\
int imcircle(GFilt g, int rno, int sno, int flag, int type,\n\
	     double x, double y,\n\
	     double xcen, double ycen, double radius);\n\
int imellipse(GFilt g, int rno, int sno, int flag, int type,\n\
	      double x, double y,\n\
	      double xcen, double ycen, double xrad, double yrad,\n\
	      double angle);\n\
int imfield(GFilt g, int rno, int sno, int flag, int type,\n\
	    double x, double y);\n\
int imline(GFilt g, int rno, int sno, int flag, int type,\n\
	   double x, double y,\n\
	   double x1, double y1, double x2, double y2);\n\
int impie(GFilt g, int rno, int sno, int flag, int type,\n\
	  double x, double y,\n\
	  double xcen, double ycen, double angle1, double angle2);\n\
int imqtpie(GFilt g, int rno, int sno, int flag, int type,\n\
	    double x, double y,\n\
	    double xcen, double ycen, double angle1, double angle2);\n\
int impoint(GFilt g, int rno, int sno, int flag, int type,\n\
	    double x, double y,\n\
	    double xcen, double ycen);\n\
#ifdef __STDC__\n\
int impolygon(GFilt g, int rno, int sno, int flag, int type,\n\
	      double x, double y, ...);\n\
#endif\n\
\n\
\n\
int evannulus(GFilt g, int rno, int sno, int flag, int type,\n\
	      double x, double y,\n\
	      double xcen, double ycen, double iradius, double oradius);\n\
int evbox(GFilt g, int rno, int sno, int flag, int type,\n\
	  double x, double y,\n\
	  double xcen, double ycen, double xwidth, double yheight,\n\
	  double angle);\n\
int evcircle(GFilt g, int rno, int sno, int flag, int type,\n\
	     double x, double y,\n\
	     double xcen, double ycen, double radius);\n\
int evellipse(GFilt g, int rno, int sno, int flag, int type,\n\
	      double x, double y,\n\
	      double xcen, double ycen, double xrad, double yrad,\n\
	      double angle);\n\
int evfield(GFilt g, int rno, int sno, int flag, int type,\n\
	    double x, double y);\n\
int evline(GFilt g, int rno, int sno, int flag, int type,\n\
	   double x, double y,\n\
	   double x1, double y1, double x2, double y2);\n\
int evpie(GFilt g, int rno, int sno, int flag, int type,\n\
	  double x, double y,\n\
	  double xcen, double ycen, double angle1, double angle2);\n\
int evqtpie(GFilt g, int rno, int sno, int flag, int type,\n\
	    double x, double y,\n\
	    double xcen, double ycen, double angle1, double angle2);\n\
int evpoint(GFilt g, int rno, int sno, int flag, int type,\n\
	    double x, double y,\n\
	    double xcen, double ycen);\n\
#ifdef __STDC__\n\
int evpolygon(GFilt g, int rno, int sno, int flag, int type,\n\
	      double x, double y, ...);\n\
#endif\n\
\n\
"
