#ifndef __fitsalloc_h__
#define __fitsalloc_h__

#include "strm.h"

class FitsAlloc : public virtual FitsStream<FILE*> {
public:
  FitsAlloc(const char*);
  virtual ~FitsAlloc() {}
};

class FitsFitsAlloc : public FitsAlloc, public FitsFitsStream<FILE*> {
public:
  FitsFitsAlloc(const char* fn, ScanMode mode) 
    : FitsAlloc(fn), FitsFitsStream<FILE*>(mode) {}
};

class FitsFitsNextAlloc : public FitsFitsNextStream<FILE*> {
public:
  FitsFitsNextAlloc(FitsFile* prev) : FitsFitsNextStream<FILE*>(prev) {}
};

class FitsArrAlloc : public FitsAlloc, FitsArrStream<FILE*> {
public:
  FitsArrAlloc(const char* fn) : FitsAlloc(fn), FitsArrStream<FILE*>() {}
};

class FitsMosaicAlloc : public FitsAlloc, FitsMosaicStream<FILE*> {
public:
  FitsMosaicAlloc(const char* fn) : FitsAlloc(fn), FitsMosaicStream<FILE*>() {}
};

class FitsMosaicNextAlloc : public FitsMosaicNextStream<FILE*> {
public:
  FitsMosaicNextAlloc(FitsFile* prev) : FitsMosaicNextStream<FILE*>(prev) {}
};

#endif
