#ifndef __fitsallocgz_h__
#define __fitsallocgz_h__

#include "strm.h"
#include "zlib.h"

class FitsAllocGZ : public virtual FitsStream<gzFile> {
public:
  FitsAllocGZ(const char*);
  virtual ~FitsAllocGZ() {}
};

class FitsFitsAllocGZ : public FitsAllocGZ, public FitsFitsStream<gzFile> {
public:
  FitsFitsAllocGZ(const char* fn, ScanMode mode) 
    : FitsAllocGZ(fn), FitsFitsStream<gzFile>(mode) {}
};

class FitsFitsNextAllocGZ : public FitsFitsNextStream<gzFile> {
public:
  FitsFitsNextAllocGZ(FitsFile* prev) : FitsFitsNextStream<gzFile>(prev) {}
};

class FitsArrAllocGZ : public FitsAllocGZ, FitsArrStream<gzFile> {
public:
  FitsArrAllocGZ(const char* fn) : FitsAllocGZ(fn), FitsArrStream<gzFile>() {}
};

class FitsMosaicAllocGZ : public FitsAllocGZ, FitsMosaicStream<gzFile> {
public:
  FitsMosaicAllocGZ(const char* fn) : 
    FitsAllocGZ(fn), FitsMosaicStream<gzFile>() {}
};

class FitsMosaicNextAllocGZ : public FitsMosaicNextStream<gzFile> {
public:
  FitsMosaicNextAllocGZ(FitsFile* prev) : FitsMosaicNextStream<gzFile>(prev) {}
};

#endif
