#ifndef __fitschannel_h__
#define __fitschannel_h__

#include "strm.h"

class FitsChannel : public virtual FitsStream<Tcl_Channel> {
public:
  FitsChannel(Tcl_Interp*, const char*, const char*);
};

class FitsFitsChannel : public FitsChannel, public FitsFitsStream<Tcl_Channel>{
public:
  FitsFitsChannel(Tcl_Interp* interp, const char* ch, 
		  const char* ext, ScanMode mode)
    : FitsChannel(interp, ch, ext), FitsFitsStream<Tcl_Channel>(mode) {}
};

class FitsFitsNextChannel : public FitsFitsNextStream<Tcl_Channel> {
public:
  FitsFitsNextChannel(FitsFile* prev) 
    : FitsFitsNextStream<Tcl_Channel>(prev) {}
};

class FitsArrChannel : public FitsChannel, FitsArrStream<Tcl_Channel> {
public:
  FitsArrChannel(Tcl_Interp* interp, const char* ch, const char* ext)
    : FitsChannel(interp, ch, ext), FitsArrStream<Tcl_Channel>() {}
};

class FitsMosaicChannel : public FitsChannel, FitsMosaicStream<Tcl_Channel> {
public:
  FitsMosaicChannel(Tcl_Interp* interp, const char* ch)
    : FitsChannel(interp, ch, ""), FitsMosaicStream<Tcl_Channel>() {}
};

class FitsMosaicNextChannel : public FitsMosaicNextStream<Tcl_Channel> {
public:
  FitsMosaicNextChannel(FitsFile* prev) 
    : FitsMosaicNextStream<Tcl_Channel>(prev) {}
};

#endif

