#ifndef __fitssocket_h__
#define __fitssocket_h__

#include "strm.h"

class FitsSocket : public virtual FitsStream<int> {
public:
  FitsSocket(int, const char*);
};

class FitsFitsSocket : public FitsSocket, public FitsFitsStream<int> {
public:
  FitsFitsSocket(int s, const char* ext, ScanMode mode) 
    : FitsSocket(s, ext), FitsFitsStream<int>(mode) {}
};

class FitsFitsNextSocket : public FitsFitsNextStream<int> {
public:
  FitsFitsNextSocket(FitsFile* prev) : FitsFitsNextStream<int>(prev) {}
};

class FitsArrSocket : public FitsSocket, public FitsArrStream<int> {
public:
  FitsArrSocket(int s, const char* ext) 
    : FitsSocket(s, ext), FitsArrStream<int>() {}
};

class FitsMosaicSocket : public FitsSocket, public FitsMosaicStream<int> {
public:
  FitsMosaicSocket(int s) : FitsSocket(s, ""), FitsMosaicStream<int>() {}
};

class FitsMosaicNextSocket : public FitsMosaicNextStream<int> {
public:
  FitsMosaicNextSocket(FitsFile* prev) : FitsMosaicNextStream<int>(prev) {}
};

#endif

