#ifndef __fitssocketgz_h__
#define __fitssocketgz_h__

#include "strm.h"

class FitsSocketGZ : public virtual FitsStream<gzStream> {
public:
  FitsSocketGZ(int, const char*);
  virtual ~FitsSocketGZ();
};

class FitsFitsSocketGZ : public FitsSocketGZ, 
			 public FitsFitsStream<gzStream> {
public:
  FitsFitsSocketGZ(int s, const char* ext, ScanMode mode) 
    : FitsSocketGZ(s, ext), FitsFitsStream<gzStream>(mode) {}
};

class FitsFitsNextSocketGZ : public FitsFitsNextStream<gzStream> {
public:
  FitsFitsNextSocketGZ(FitsFile* prev) : FitsFitsNextStream<gzStream>(prev) {}
};

class FitsArrSocketGZ : public FitsSocketGZ, public FitsArrStream<gzStream> {
public:
  FitsArrSocketGZ(int s, const char* ext) 
    : FitsSocketGZ(s, ext), FitsArrStream<gzStream>() {}
};

class FitsMosaicSocketGZ : public FitsSocketGZ, 
			   public FitsMosaicStream<gzStream> {
public:
  FitsMosaicSocketGZ(int s) 
    : FitsSocketGZ(s, ""), FitsMosaicStream<gzStream>() {}
};

class FitsMosaicNextSocketGZ : public FitsMosaicNextStream<gzStream> {
public:
  FitsMosaicNextSocketGZ(FitsFile* prev) 
    : FitsMosaicNextStream<gzStream>(prev) {}
};

#endif

