#ifndef __fitsstream_h__
#define __fitsstream_h__

#include <tcl.h>
#include "file.h"
#include "zlib.h"

typedef struct gzStream_ {
  z_stream zstream;
  int id;
  int transparent;
  unsigned char header[2];
  int useHeader;
  unsigned char buf[FTY_BLOCK];
} *gzStream;

template<class T>
class FitsStream : public FitsFile {
protected:
  T stream_;

  FitsHead* headRead();
  void* dataRead(int);
  void dataSkip(int);
  void skipEnd();

  int read(char*, int);
  void close();

public:
  FitsStream();
  virtual ~FitsStream();

  T stream() {return stream_;}
};

template<class T>
class FitsFitsStream : public virtual FitsStream<T> {
protected:
  void processExact();
  void processRelax();

public:
  FitsFitsStream(ScanMode);
};

template<class T>
class FitsFitsNextStream : public FitsStream<T> {
public:
  FitsFitsNextStream(FitsFile* prev);
};

template<class T>
class FitsArrStream : public virtual FitsStream<T> {
public:
  FitsArrStream();
};

template<class T>
class FitsMosaicStream : public virtual FitsStream<T> {
public:
  FitsMosaicStream();
};

template<class T>
class FitsMosaicNextStream : public FitsStream<T> {
public:
  FitsMosaicNextStream(FitsFile* prev);
};

#endif
