#ifndef __annulus_h__
#define __annulus_h__

#include "basecircle.h"

class Annulus : public BaseCircle {
 protected:
  void sortRadii();

 public:
  Annulus(Frame* p, const Vector& ctr, 
	  double start, double stop, int num,
	  const char* clr, int w, const char* f, 
	  const char* t, unsigned short prop, const char* c);

  Annulus(Frame* p, const Vector& ctr, double* r, int n,
	  const char* clr, int w, const char* f, 
	  const char* t, unsigned short prop, const char* c);

  Annulus(const Annulus&);

  Marker* dup() {return new Annulus(*this);}
  void updateBBox();
  void edit(const Vector&, int);
  void editEnd();

  void setRadii(double, double, int);
  void setRadii(const double*, int);
  const double* getRadii() {return radii;}
  int addRadii(const Vector&);
  void deleteRadii(int h);

  void list(ostream&, CoordSystem, CoordFormat, char);
  void listCiao(ostream&, CoordSystem, CoordFormat, char);
  void listSAOimage(ostream&, CoordSystem, CoordFormat, char);
  void listPros(ostream&, CoordSystem, CoordFormat, char);
};

#endif
