#ifndef __basebox_h__
#define __basebox_h__

#include "basemarker.h"

class BaseBox : public BaseMarker {
protected:
  Vector* size;
  Matrix flip;

  void calcPoints(double);
  virtual void updateHandles() {}
  double getWCSAngle();

public:
  BaseBox(const BaseBox&);
  BaseBox(Frame* p, const Vector& ctr, double a,
	  const char* clr, int w, const char* f,
	  const char* t, unsigned short prop, const char* c);
  virtual ~BaseBox();

  virtual Marker* dup() =0;
  void updateCoords(Matrix&);
  virtual void editBegin(int) =0;
  virtual void edit(const Vector&, int) =0;
  virtual void editEnd() =0;
  int isIn(const Vector&);

  virtual void list(ostream&, CoordSystem, CoordFormat, char) =0;
  virtual void listCiao(ostream&, CoordSystem, CoordFormat, char) {}
  virtual void listSAOimage(ostream&, CoordSystem, CoordFormat, char) =0;
  virtual void listPros(ostream&, CoordSystem, CoordFormat, char) =0;
};

#endif
