#ifndef __basecircle_h__
#define __basecircle_h__

#include "basemarker.h"

class BaseCircle : public BaseMarker {
 protected:
  double* radii;

 private:
  virtual void render(Drawable, const Matrix&, double, RenderMode);

 public:
  BaseCircle(const BaseCircle&);
  BaseCircle(Frame* p, const Vector& ctr, double r,
	     const char* clr, int w, const char* f, 
	     const char* t, unsigned short prop, const char* c);
  virtual ~BaseCircle();

  virtual Marker* dup() =0;
  virtual void updateBBox() =0;
  void updateCoords(Matrix&);
  virtual void edit(const Vector&, int) =0;
  virtual void rotate(const Vector& v, int h) {}
  virtual void ps(int);
  int isIn(const Vector&);

  virtual void list(ostream&, CoordSystem, CoordFormat, char) =0;
  virtual void listCiao(ostream&, CoordSystem, CoordFormat, char) {};
  virtual void listSAOimage(ostream&, CoordSystem, CoordFormat, char) {};
  virtual void listPros(ostream&, CoordSystem, CoordFormat, char) {};
};

#endif
