#ifndef __baseellipse_h__
#define __baseellipse_h__

#include "basemarker.h"

class BaseEllipse : public BaseMarker {
protected:
  Vector* radii;
  Matrix flip;            // non iis needs a flip in Y

  void calcPoints(double);
  virtual void updateHandles() {}

public:
  BaseEllipse(const BaseEllipse&);
  BaseEllipse(Frame* p, const Vector& ctr, double a,
	      const char* clr, int w, const char* f, const char* t, 
	      unsigned short prop, const char* c);
  virtual ~BaseEllipse();

  virtual Marker* dup() =0;
  void updateCoords(Matrix&);
  virtual void edit(const Vector&, int) =0;
  int isIn(const Vector&);

  virtual void list(ostream&, CoordSystem, CoordFormat, char) =0;
  virtual void listCiao(ostream&, CoordSystem, CoordFormat, char) {}
  virtual void listSAOimage(ostream&, CoordSystem, CoordFormat, char) =0;
  virtual void listPros(ostream&, CoordSystem, CoordFormat, char) =0;
};

#endif


