#ifndef __basemarker_h__
#define __basemarker_h__

#include <iostream.h>
#include <strstream.h>
#include <tk.h>

#include "marker.h"

#define MAXANNULI 512
#define MAXANGLES 720

class BaseMarker : public Marker {
protected:
  int segments;
  int annuli;
  Vector** vertices;

protected:
  virtual void updateHandles() {}
  virtual void calcPoints(double) {}

private:
  void render(Drawable drawable, const Matrix& matrix, double, RenderMode);
  void newVertices();
  void deleteVertices();

public:
  BaseMarker(const BaseMarker&);
  BaseMarker(Frame*, const Vector&, int, const char*, int, const char*, 
	       const char*, unsigned short, const char*);

  virtual Marker* dup() =0;
  virtual void updateBBox();
  virtual void updateCoords(Matrix&) =0;

  virtual void ps(int);
  int getAnnuliCount() {return annuli;}

  virtual void list(ostream&, CoordSystem, CoordFormat, char) =0;
  virtual void listCiao(ostream&, CoordSystem, CoordFormat, char) =0;
  virtual void listSAOimage(ostream&, CoordSystem, CoordFormat, char) =0;
  virtual void listPros(ostream&, CoordSystem, CoordFormat, char) =0;
};

#endif
