#ifndef __boxannulus_h__
#define __boxannulus_h__

#include "basebox.h"

class BoxAnnulus : public BaseBox {
private:
  void updateHandles();
  void sortSize();

public:
  BoxAnnulus(const BoxAnnulus&);
  BoxAnnulus(Frame* p, const Vector& ctr, const Vector& s, double a,
	     const char* clr, int w, const char* f, const char* t, 
	     unsigned short prop, const char* c);

  BoxAnnulus(Frame* p, const Vector& ctr, 
	     const Vector& inner, const Vector& outer, int, double a,
	     const char* clr, int w, const char* f, const char* t, 
	     unsigned short prop, const char* c);

  BoxAnnulus(Frame* p, const Vector& ctr, double a, int an, Vector* s,
	     const char* clr, int w, const char* f, const char* t, 
	     unsigned short prop, const char* c);

  Marker* dup() {return new BoxAnnulus(*this);}
  void editBegin(int);
  void edit(const Vector&, int);
  void editEnd();

  const Vector* getSize() {return size;}
  void setSize(const Vector&, const Vector&, int);
  void setSize(const Vector*, int);
  int addSize(const Vector&);
  void deleteSize(int h);

  void list(ostream&, CoordSystem, CoordFormat, char);
  void listSAOimage(ostream&, CoordSystem, CoordFormat, char);
  void listPros(ostream&, CoordSystem, CoordFormat, char);
};

#endif
