#ifndef __ellipse_h__
#define __ellipse_h__

#include "baseellipse.h"

class Ellipse : public BaseEllipse {
private:
  void updateHandles();

public:
  Ellipse(const Ellipse&);
  Ellipse(Frame* p, const Vector& ctr, const Vector& r, double a,
	  const char* clr,  int w, const char* f, 
	  const char* t, unsigned short prop, const char* c);

  Marker* dup() {return new Ellipse(*this);}
  void edit(const Vector&, int);

  const Vector& getRadius() {return radii[0];}
  void setRadius(const Vector&);

  void list(ostream&, CoordSystem, CoordFormat, char);
  void listCiao(ostream&, CoordSystem, CoordFormat, char);
  void listSAOtng(ostream&, CoordSystem, CoordFormat, char);
  void listSAOimage(ostream&, CoordSystem, CoordFormat, char);
  void listPros(ostream&, CoordSystem, CoordFormat, char);
};

#endif


