#ifndef __framepseudo8_h__
#define __framepseudo8_h__

#include "frame.h"

class FramePseudoColor8 : public Frame {
private:
  void updateColorScale();
  void fillXImage(XImage*, int, int, int, int, double* (FitsImage::*)());
  void fillXImageMosaic(XImage*, int, int, int, int, double* (FitsImage::*)());
  void fillXImageMosaicFast(XImage*, int, int, int, int, 
			    double* (FitsImage::*)());
  void updateMagnifierReplicate(const Vector&);
  void rotateMotion();

  void psLevel2(PSColorSpace, int, int, float);
  void psLevel2Head(PSColorSpace, int, int);
  void psLevel2Single(PSColorSpace, int, int, float);
  void psLevel2Mosaic(PSColorSpace, int, int, float);
  void psLevel2MosaicFast(PSColorSpace, int, int, float);

  int psLevel2BaseColor(int, unsigned char*, unsigned char*, unsigned char*);

public:
  FramePseudoColor8(Tcl_Interp*, Tk_Canvas, Tk_Item*);

  void colormapCmd(int, float, float, int, unsigned short*, 
		   unsigned char*, int);
  void colormapBeginCmd() {}
  void colormapBeginCmd(const Vector&) {}
  void colormapMotionCmd(int id, float b, float c, int i, unsigned short*,
			 unsigned char* ptr, int cnt) {}
  void colormapEndCmd(int id, float b, float c, int i, unsigned short* index, 
		      unsigned char* cells, int cnt)
    {colormapCmd(id,b,c,i,index,cells,cnt);}
};

#endif
