#ifndef __frametrue_h__
#define __frametrue_h__

#include "frame.h"

class FrameTrueColor : public Frame {
protected:
  int skipUpdate;

  XImage* colormapXM;      // rotate dest ximage
  Pixmap colormapPM;       // rotate pixmap
  GC colormapGCXOR;        // GC for interactive rotation
  long* colormapData;

protected:
  virtual void updateColorScale() =0;

  void fillXImage(XImage*, int, int, int, int, double* (FitsImage::*)());
  void fillXImageMosaic(XImage*, int, int, int, int, double* (FitsImage::*)());
  void fillXImageMosaicFast(XImage*, int, int, int, int, 
			    double* (FitsImage::*)());
  void updateMagnifierReplicate(const Vector&);
  void rotateMotion();

  void colormapBeginSingle(int,int);
  void colormapBeginMosaic(int,int);
  void colormapBeginMosaicFast(int,int);

  void psLevel2(PSColorSpace, int, int, float);
  void psLevel2Head(PSColorSpace, int, int);
  void psLevel2Single(PSColorSpace, int, int, float);
  void psLevel2Mosaic(PSColorSpace, int, int, float);
  void psLevel2MosaicFast(PSColorSpace, int, int, float);

public:
  FrameTrueColor(Tcl_Interp*, Tk_Canvas, Tk_Item*);
  virtual ~FrameTrueColor() {}

  void colormapCmd(int, float, float, int, unsigned short*, 
		   unsigned char*, int);
  void colormapBeginCmd();
  void colormapBeginCmd(const Vector&);
  void colormapMotionCmd(int, float, float, int, unsigned short*, 
			 unsigned char*, int);
  void colormapEndCmd(int, float, float, int, unsigned short*, 
		      unsigned char*, int);
};

#endif
