#ifndef __panda_h__
#define __panda_h__

#include "basecircle.h"

class Panda : public BaseCircle {
 private:
  double *angles;
  int angnum;
  Matrix flip;               // iis needs a flip in Y

  void sortRadii();
  void sortAngles();
  void render(Drawable, const Matrix&, double, RenderMode);
  void listA(ostream&, CoordSystem, CoordFormat, char);
  void listB(ostream&, CoordSystem, CoordFormat, char);

 public:
  Panda(Frame* p, const Vector& ctr, 
	double ang1, double ang2, int angnum,
	double start, double stop, int num,
	const char* clr, int w, const char* f, 
	const char* t, unsigned short prop, const char* c);

  Panda(Frame* p, const Vector& ctr, 
	double* a, int an,
	double* r, int rn,
	const char* clr, int w, const char* f, 
	const char* t, unsigned short prop, const char* c);

  Panda(const Panda&);

  virtual ~Panda();

  Marker* dup() {return new Panda(*this);}
  void updateBBox();
  void edit(const Vector&, int);
  void editEnd();
  void rotate(const Vector& v, int h) {}

  const double* getAngles() {return angles;}
  int getAnglesCount() {return angnum;}
  const double* getRadii() {return radii;}

  int addAngles(const Vector&);
  int addRadii(const Vector&);

  void setAnglesRadii(double, double, int, double, double, int);
  void setAnglesRadii(const double*, int, const double*, int);
  void deleteAnglesRadii(int h);

  void ps(int);

  void list(ostream&, CoordSystem, CoordFormat, char);
  void listCiao(ostream&, CoordSystem, CoordFormat, char);

  double radToDeg(double r);
};

#endif
