#ifndef __polygon_h__
#define __polygon_h__

#include "marker.h"
#include "list.h"

class Polygon : public Marker {
private:
  List<Vertex> vertex;
  Matrix flip;

  void render(Drawable, const Matrix&, double, RenderMode);
  void moveVertex(const Vector&, int);

public:
  Polygon(const Polygon&);
  Polygon(Frame* p, const Vector& ctr, const Vector& bb, 
	  const char* clr, int w, const char* f, 
	  const char* t, unsigned short prop, const char* c);
  Polygon(Frame* p, const List<Vertex>&,
	  const char* clr, int w, const char* f,
	  const char* t, unsigned short prop, const char* c);

  Marker* dup() {return new Polygon(*this);}
  void updateBBox();
  void updateCoords(Matrix&);

  void edit(const Vector&, int);
  void rotate(const Vector&, int);
  void ps(int);
  int isIn(const Vector& v);
  int isPolygon() {return 1;}

  void createVertex(int, const Vector&);
  void deleteVertex(int);
  int getSegment(const Vector&);

  void list(ostream&, CoordSystem, CoordFormat, char);
  void listCiao(ostream&, CoordSystem, CoordFormat, char);
  void listSAOtng(ostream&, CoordSystem, CoordFormat, char);
  void listSAOimage(ostream&, CoordSystem, CoordFormat, char);
  void listPros(ostream&, CoordSystem, CoordFormat, char);
};

#endif
