#ifndef __projection_h__
#define __projection_h__

#include "marker.h"

class Projection : public Marker {
 public:
  enum Method {SUM,AVERAGE};

 private:
  Vector p1;
  Vector p2;
  double width;
  Method method;

  void render(Drawable, const Matrix&, double, RenderMode);
  void update();

 public:
  Projection(const Projection&);
  Projection(Frame* parent, const Vector& ctr, const Vector& p, double w,
	     const char* mvcb, const char* delcb,
	     const char* clr, int w, const char* f, 
	     const char* t, unsigned short prop, const char* c);

  Marker* dup() {return new Projection(*this);}
  void updateBBox();
  void updateCoords(Matrix&);

  void move(const Vector&);
  void moveTo(const Vector&);
  void edit(const Vector&, int);
  void rotate(const Vector& v, int h) {}
  void ps(int);
  int isIn(const Vector&);
  Vector getCenter() {return p1;}

  const Vector& getP1() {return p1;}
  const Vector& getP2() {return p2;}
  void set(const Vector&, const Vector&, double, int);
  void setPoints(const Vector&, const Vector&);
  void setWidth(double);
  double getWidth() {return width;}
  int getMethod() {return method;}

  void list(ostream&, CoordSystem, CoordFormat, char);
};

#endif
