#ifndef __ruler_h__
#define __ruler_h__

#include "marker.h"

class Ruler : public Marker {
private:
  Vector p1;
  Vector p2;
  Vector p3;
  CoordSystem coordSystem;
  CoordSystem distSystem;
  CoordFormat distFormat;
  double dist;
  Tk_Font df;

  void render(Drawable, const Matrix&, double, RenderMode);
  void renderDist(Drawable, Vector);
  void psDist(int, Vector);
  void calcP3();
  void calcDist();
  int isOn(const Vector&, const Vector&, const Vector&);

public:
  Ruler(const Ruler&);
  Ruler(Frame* parent, const Vector& ctr, const Vector& p, 
	CoordSystem, CoordSystem, CoordFormat,
	const char* clr, int w, const char* f, 
	const char* t, unsigned short prop, const char* c);
  ~Ruler();

  Marker* dup() {return new Ruler(*this);}
  void updateBBox();
  void updateCoords(Matrix&);
  void move(const Vector&);
  void moveTo(const Vector&);
  void edit(const Vector&, int);
  void rotate(const Vector& v, int h) {}
  void ps(int);
  int isIn(const Vector&);

  const Vector& getP1() {return p1;}
  const Vector& getP2() {return p2;}
  const Vector& getP3() {return p3;}
  void setPoints(const Vector&, const Vector&);
  void setCoordSystem(CoordSystem, CoordSystem, CoordFormat);

  double getAngle();

  void list(ostream&, CoordSystem, CoordFormat, char);
  void listProperties(ostream&, char);
};

#endif
